/****************************
		'filer.c'
****************************/

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <resource.h>
#include <mouse.h>
#include <file.h>
#include <dir.h>
#include <string.h>

#define NAME_SX	16*8
#define DIR_SX	36*8
#define RDIR_SX	37*8
#define DIRCNT	256
#define FILES	8
#define Q_REN	Q_MAX
#define Q_DEL	Q_MAX+1
#define DRV_SX	16
#define DRV_MAX	7
#define ALL_X	32*8
#define ALL_Y	3*8

extern char mg_sure[];

static flag nextfile;
static DIR  dir;
static DIR  *dirbufp;
static DIR  *dirmaxp;
static char **dirmask;
static DLOG dg_name={ "%s as: ",30*8,0,2,Q_OK,Q_ESC };
static TBOX tb_name={ CT_TBOX,0,0,0,NIL,0,NAME_SX };
static DLOG dg_del={ "Delete \"%s\" ?",30*8,0,2,Q_YES,Q_NO };
static BTNS bt_name={ CT_PBTN,0,16*8,4*8,0,0,1,HZ };
static BTN  pb_name={ "Add No.",0,0,0 };
static DLOG dg_fsel={ "Select %s file ...\n"
	,DIR_SX+6*8,FILES*16+13*8,4,Q_OK,Q_ESC,Q_REN,Q_DEL
};
static DLOG dg_rsel={ "Select %s resource ...\n"
	,RDIR_SX+6*8,FILES*16+10*8,2,Q_OK,Q_ESC,
};
static TEXT tx_sel={ CT_TEXT,0,26*8,0,"in %ditems\n" };
static SMNU sm_fsel={ CT_SMNU,0,0,0,NIL,DIR_SX,FILES };
static SMNU sm_rsel={ CT_SMNU,0,0,0,NIL,RDIR_SX,FILES };
static SBAR sb_sel;
static BTNS bt_drv={ CT_PBTN,0,0,0,"Drive: ",0,DRV_MAX,HZ,8 };
static BTN  pb_drv[]={
	{ "A",DRV_SX,1,MD_BTN },
	{ "B",DRV_SX,1,MD_BTN },
	{ "C",DRV_SX,1,MD_BTN },
	{ "D",DRV_SX,1,MD_BTN },
	{ "E",DRV_SX,1,MD_BTN },
	{ "F",DRV_SX,1,MD_BTN },
	{ "G",DRV_SX,1,MD_BTN },
};
static BTNS bt_all={ CT_PBTN,0,ALL_X,ALL_Y,NIL,0,1,HZ };
static BTN  pb_all={ "All",4*8,0,MD_BTN|MD_ON };
static BTNS bt_fsel={ CT_PBTN,0,0,0,NIL,0,4,HZ,8 };
static BTN  pb_fsel[]={
	{ "OK",40,0,0 },
	{ "ESC",40,0,0 },
	{ "Rename",56,0,0 },
	{ "Delete",56,0,0 },
};

static char *typesym[]={ "PAT","FNT","BLK","SPR","MAP","ACT","3D " };
static char tmpwk[PATHLN];

/*** Set File Name ***/

flag setname(ttl,name)
char *ttl;
char *name;
{
	flag ok;
	char *ext;
	int  nextnumb();
	
	linkctrls(&dg_name,&tb_name,&bt_name,0);
	dg_name.par1=(int)ttl;
	tb_name.str=tmpwk;
	tb_name.val=12;
	bt_name.btnp=&pb_name;
	bt_name.func=nextnumb;
	
	ok=FALSE;
	strcpy(tmpwk,name);
	if(dialog(&dg_name) == Q_OK) {
		ok=TRUE;
		if(tb_name.val) {
			if(!strchr(tmpwk,'.')) {
				ext=strchr(name,'.');
				strcat(tmpwk,ext);
			}
			strcpy(name,tmpwk);
		}
	}
	return(ok);	
}

/*** Next number ***/

nextnumb()
{
	char temp[32];
	char *ext,*p;
	int  c;

	strcpy(temp,tmpwk);
	ext=strchr(tmpwk,'.');
	if(ext) {
		*strchr(temp,'.')=0;
	}
	p=temp;
	repeat {
		c=*p;
		if(c >= '0' && c <= '9') break;
		p++;
	} until(!c);
	if(!c) strcat(temp,"00");
	else {
		sprint(p,"%02d",atoi(p)+1);
	}
	if(ext) strcat(temp,ext);
	strcpy(tmpwk,temp);
	drawtbox(&tb_name);
}

/*** Read Directory ***/

static int readdir()
{
	int  i;
	int  next;
	int  filec;
	char *p;
	DIR  *dp;

	dp=dirbufp;
	filec=0;
	next=0;
	loop {
		next=getdir("*",FA_DIREC,dp,next);
		if(!next) break;
		if(dp->atr != FA_DIREC) continue;
		if(*(word*)(dp->name) == '.') continue;
		if(++dp >= dirmaxp) goto overflow;
		filec++;
	}
	i=0;
	while(*(p=dirmask[i++])) {
		next=0;
		loop {
			next=getdir(p,0,dp,next);
			if(!next) break;
			if(++dp >= dirmaxp) goto overflow;
			filec++;
		}
	}
overflow:
	return(filec);
}

/*** Change drive ***/

static chgdrv(bt)
BTNS *bt;
{
	setdisk(getbutton(bt));
	sm_fsel.iall=tx_sel.par1=readdir();
	sm_fsel.itop=0;
	sm_fsel.selitem=INVALID;
	drawsmnu(&sm_fsel);
	drawtext(&tx_sel);
}

/*** Select File ***/

char *selectfile(ttl,mask)
char *ttl;
char *mask[];
{
	int  i;
	int  filec;
	int  drvcnt;
	int  ret;
	word size;
	char *name;
	DIR  *dp;
	void  printdir();
	
	nextfile=FALSE;
	size=DIRCNT*sizeof(DIR);
	dirbufp=(DIR*)malloc(size);
	dirmaxp=(DIR*)((byte*)dirbufp+size);
	dirmask=mask;
retry:
	drvcnt=getdrive();
	filec=readdir();
	linkctrls(&dg_fsel,&tx_sel,&bt_drv,&bt_all,&sm_fsel,0);
	dg_fsel.par1=(int)ttl;
	dg_fsel.btnsp=&bt_fsel;
	bt_drv.btnp=pb_drv;
	bt_drv.func=chgdrv;
	bt_all.btnp=&pb_all;
	bt_fsel.btnp=pb_fsel;
	tx_sel.par1=filec;
	sm_fsel.iall=filec;
	if(sm_fsel.itop+sm_fsel.idsp > filec) sm_fsel.itop=0;
	sm_fsel.selitem=INVALID;
	sm_fsel.func=printdir;
	sm_fsel.sbar=&sb_sel;
	for_to(i,DRV_MAX) {
		if(i < drvcnt) pb_drv[i].mode&=~MD_NULL;
		else pb_drv[i].mode|=MD_NULL;
	}
	setbutton(&bt_drv,getdisk());
	name=NIL;
	ret=dialog(&dg_fsel);
	if(sm_fsel.selitem >= 0)  {
		dp=dirbufp+sm_fsel.selitem;
		strcpy(tmpwk,dp->name);
	} else {
		dp=NIL;
	}
	switch(ret) {
	case Q_OK:
		if(dp) {
			if(dp->atr & FA_DIREC) {
				chdir(dp->name);
				goto retry;
			} else {
				name=tmpwk;
			}
			nextfile=!!(pb_all.mode & MD_ON);
		}
		break;
	case Q_ESC:
		(int)name=INVALID;
		break;
	case Q_REN:
		if(dp) {
			if(setname("Rename",tmpwk)) {
				rename(dp->name,tmpwk);
				error(tmpwk);
			}
		}
		goto retry;
	case Q_DEL:
		if(dp) {
			dg_del.par1=(int)dp->name;
			if(dialog(&dg_del) == Q_YES) {
				unlink(dp->name);
			}
		}
		goto retry;
	}
	dirmaxp=dirbufp+filec;
	if(!nextfile) free(dirbufp);
	return(name);
}	

/*** Select next file ***/

char *selectnext()
{
	char *p;
	char *name;
	DIR *dp;

	name=NIL;
	if(nextfile) {
		if(p=strchr(tmpwk,'.')) *p=0;
		dp=dirbufp+sm_fsel.selitem+1;
		while(dp < dirmaxp) {
			if(p=strchr(dp->name,'.')) *p=0;
			sm_fsel.selitem++;
			if(!strcmp(tmpwk,dp)) {
				name=dp->name;
				if(p) *p='.';
				break;
			}
			dp++;
		}
		if(!name) free(dirbufp);
	}
	return(name);
}

/*** Print directory ***/

static void printdir(n)
int  n;
{
	DIR  *dp;
	char name[16];
	char *p;

	dp=dirbufp+n;
	if(dp->atr & FA_DIREC) {
		name[0]='<';
		strcpy(&name[1],dp->name);
		strcat(name,">");
		print(" %-20s",name);
	} else {
		strcpy(name,dp->name);
		if(p=strchr(name,'.')) *p++=0;
		print(" %-8s %-3s %6ld ",name,p,dp->size);
	}
	print("%02d-%02d-%02d %2d:%02d"
		,dp->ftime.f.year+80,dp->ftime.f.month,dp->ftime.f.day
		,dp->ftime.f.hour,dp->ftime.f.min,dp->ftime.f.sec
	);
}

/*** Select resource ***/

HEAD *selectrsc(ttl)
char *ttl;
{
	int  rsccnt;
	HEAD *rh;
	void printrsc();

	rsccnt=0;
	while(headrsc(rsccnt)) rsccnt++;
	linkctrls(&dg_rsel,&tx_sel,&sm_rsel,0);
	dg_rsel.par1=(int)ttl;
	tx_sel .par1=rsccnt;
	sm_rsel.iall=rsccnt;
	sm_rsel.itop=0;
	sm_rsel.selitem=INVALID;
	sm_rsel.func=printrsc;
	sm_rsel.sbar=&sb_sel;
	rh=NIL;
	if(dialog(&dg_rsel) == Q_OK) {
		if(sm_rsel.selitem >= 0) {
			rh=headrsc(sm_rsel.selitem);
		}
	} else { 
		(int)rh=INVALID;
	}
	return(rh);
}

/*** Print resource ***/

static void printrsc(n)
int  n;
{
	HEAD *rh;

	rh=headrsc(n);
	print(" %c%c%-12s %3s %c%c%c %5u %5u"
		,rh->status & RST_MDF ? '*' : SPC
		,rh->status & RST_EDT ? '>' : SPC
		,rh->name, typesym[rh->type&7]
		,rh->status & RST_SYS ? 'S' : '-'
		,rh->attr & RAT_BG ? 'B' : (rh->attr & RAT_CH ? 'C' : '-')
		,rh->attr & RAT_3D ? '3' : '-'
		,rh->keep,rh->farkeep
	);
}
