/****************************
		'palet.c'
****************************/

#include <std.h>
#include <graf.h>
#include <mouse.h>
#include "pet.h"

#define PAL_X	10*8
#define PAL_Y	4*8
#define PAL_SZ	16
#define TBOX_X	4*8
#define TBOX_Y	4*8
#define TBOX_SZ	32
#define TIL_X	1*8
#define TIL_Y	6*8
#define EXCOL_X	29*8
#define EXCOL_Y	6*8
#define TL_EXCOL 11

#define PALETS	9
#define MIXLNS	2
#define MIXPALETS PALETS*MIXLNS
#define ALLPALETS PALETS+MIXPALETS

static POINT p0;
static int  selpal=INVALID;
static int  excol=INVALID;
static flag exgcol;
static flag mdfpalet;
int  tilemode;

byte mixpal[MIXPALETS][16];
static PATT pt_pal={ NIL,16,16,3 };
static int  mixpatt[16*3];
static word tilebit[]={ 0x5A5A,0x2828,0x7D7D,0x5A5A };

static char nm_palet[]="palet.pet";

/*** Load/Save palet ***/

extern int  errno;

loadpalet()
{
	aload(nm_palet,mixpal,sizeof(mixpal));
	errno=0;
	mdfpalet=FALSE;
}

savepalet()
{
	if(mdfpalet) {
		asave(nm_palet,mixpal,sizeof(mixpal));
		error(nm_palet);
	}
}

/** Draw palet ***/

drawpalet()
{
	int  i;
	RECT r;

	r.x=TBOX_X;
	r.y=TBOX_Y;
	r.sx=r.sy=TBOX_SZ;
	shaderect(&r,2);
	r.x=TIL_X;
	r.y=TIL_Y;
	r.sx=r.sy=PAL_SZ;
	shaderect(&r,2);
	drawtile();
	r.x=PAL_X;
	r.y=PAL_Y;
	r.sx=PAL_SZ*PALETS;
	r.sy=PAL_SZ*(MIXLNS+1);
	shaderect(&r,2);
	drawsrcpal();
	for_to(i,MIXPALETS) {
		drawmixpal(i);
	}
	selpal=excol=INVALID;
	p0.x=p0.y=INVALID;
	r.x=EXCOL_X;
	r.y=EXCOL_Y;
	r.sx=r.sy=PAL_SZ;
	shaderect(&r,2);
	exgcol=FALSE;
	tilemode=0;
	drawexcol();
}

/*** Draw src palt ***/

static drawsrcpal()
{
	int  i;
	RECT r;
	
	r.x=PAL_X;
	r.y=PAL_Y;
	r.sx=PAL_SZ;
	r.sy=PAL_SZ;
	for_to(i,PALETS) {
		if(i < 8) {
			pn.col=i;
			pn.tile=PN_SOLID;
		} else {
			pn.col=pn_bg.col;
			pn.tile=PN_GRAY;
		}
		fillrect(&r);
		r.x+=PAL_SZ;
	}
	pn.tile=PN_SOLID;
}

/*** Draw Mix Palet ***/

static drawmixpal(pal)
int  pal;
{
	int  i;
	int  tst;
	int  col;
	int  x,y;
	word bit;
	byte *p;
	int  *q,*q1;
	RECT r;

	p=(pal == INVALID) ? px_pen : mixpal[pal];
	q=mixpatt;
	for_to(y,4) {
		bit=0x8888;
		for_to(x,4) {
			col=*p++;
			q1=q;
			for_to(tst,3) {
				for(i=0; i<16; i+=4) {
					if(col & (1<<tst)) {
						*(q1+i)|=bit;
					} else {
						*(q1+i)&=~bit;
					}
				}
				q1+=16;
			}
			bit>>=1;
		}
		q++;
	}
	pt_pal.patp=(byte*)mixpatt;
	if(pal != INVALID) {
		r.x=PAL_X+PAL_SZ*(pal%PALETS);
		r.y=PAL_Y+PAL_SZ*(pal/PALETS+1);
	} else {
		r.x=TIL_X;
		r.y=TIL_Y;
	}
	putpatt(r.x,r.y,&pt_pal,0);
}

/*** Draw Tile Box ***/

drawtile()
{
	int  x,y;
	RECT r;
	int  save_pix;
	int  save_vbox;
	
	save_pix=gp_pix;
	save_vbox=gp_vbox;
	gp_pix=TBOX_Y*80+TBOX_X/8;
	gp_vbox=0;
	for_to(y,4>>vsize) {
		for_to(x,4) {
			drawpix(x,y,gettile(x,y));
		}
	}
	gp_pix=save_pix;
	gp_vbox=save_vbox;
	drawmixpal(INVALID);
}

/*** Draw exchange color icon ***/

static drawexcol()
{
	pt_icon.col0=exgcol ? 0 : 7;
	pt_icon.col1=exgcol ? 7 : 0;
	putpatt(EXCOL_X,EXCOL_Y,&pt_icon,TL_EXCOL);
}

/*** Mix Color ***/

static mixcolor(tcol,mode)
int  tcol;
int  mode;
{
	int  i;
	int  bcol;
	byte *p;
	word tile;
	word mask;

	bcol=px_pen[0];
	tile=tilebit[mode];
	mask=0x8000;
	p=px_pen;
	for_to(i,PENSZ) {
		if(tile & mask) *p=tcol;
		else if(mode) *p=bcol;
		p++;
		mask>>=1;
	}
}

/*** Get Tile ***/

gettile(x,y)
int  x,y;
{
	return(px_pen[x+y*4]);
}

/*** Do palet ***/

flag do_palet(done)
{
	int  i;
	int  oldmode;
	POINT p;
	static RECT r_pal={ PAL_X,PAL_Y,PAL_SZ,PAL_SZ };
	
	p.x=PALETS;
	p.y=exgcol ? 1 : MIXLNS+1;
	if(done || !insquare(ms.x,ms.y,&r_pal,&p)) {
		selpal=INVALID;
		p.x=p.y=INVALID;
		dragrect(&p,&p0,&r_pal);
		done=do_excol(done);
	} else {
		done=TRUE;
		i=p.x+p.y*PALETS;
		dragrect(&p,&p0,&r_pal);
		if(ms.btn & MS_ON) {
			if(!exgcol) {
				if(ms.btn & MS_LON) {
					if(i != selpal || tilemode) {
						if(i < PALETS) {
							memset(&px_pen,i,PENSZ);
						} else {
							memcpy(&px_pen,mixpal[i-PALETS],PENSZ);
						}
						drawtile();
						tilemode=0;
					}
					selpal=i;
				} else {
					if(i < PALETS) {
						oldmode=tilemode;
						if(ms.evnt & MS_RDN) {
							if(i == selpal || selpal == INVALID) {
								if(++tilemode == 5) tilemode=2;
							}
						}
						if(!tilemode) tilemode++;
						if(i != selpal || tilemode != oldmode) {
							mixcolor(i,tilemode-1);
							drawtile();
						}
						selpal=i;
					} else {
						if(ms.evnt & MS_RDN) {
							memcpy(mixpal[i-PALETS],&px_pen,PENSZ);
							dragrect1(&p,&r_pal);
							drawmixpal(i-PALETS);
							dragrect1(&p,&r_pal);
							mdfpalet=TRUE;
						}
					}
				}
			} else if(i < PALETS) {
				if(ms.evnt & MS_LDN) {
					r_pal.x=PAL_X+p.x*PAL_SZ;
					flushrect(&r_pal);
					r_pal.x=PAL_X;
					excol=i;
				} else if(ms.evnt & MS_RDN) {
					if(excol >= 0) {
						exgcolor(i);
						drawebox();
					}
				}
			}
		}
	}
	return(done);
}

/*** Do exchange color ***/

static flag do_excol(done)
flag done;
{
	if(inarea(ms.x-EXCOL_X,ms.y-EXCOL_Y,PAL_SZ,PAL_SZ)) {
		done=TRUE;
		if(ms.evnt & MS_DN) {
			exgcol=!exgcol;
			drawexcol();
		}
	}
	return(done);
}

/*** Exchange color ***/

static exgcolor(newcol)
int newcol;
{
	int  x,y;
	byte *p;
	byte *py;

	memcpy(px_bak,px_edt,BUFSZ);
	p=px_edt;
	for_to(y,siz_y) {
		py=p;
		for_to(x,siz_x) {
			if(*p == excol) {
				*p=newcol;
				drawpix(x,y,newcol);
			}
			p++;
		}
		p=py+BUF_SX;
	}
}

/*** Drag rect ***/

dragrect(p,p0,r)
POINT *p,*p0;
RECT *r;
{
	if(p->x != p0->x || p->y != p0->y) {
		dragrect1(p0,r);
		dragrect1(p,r);
		p0->x=p->x;
		p0->y=p->y;
	}
}

dragrect1(p,r0)
POINT *p;
RECT *r0;
{
	RECT r;

	if(p->x != INVALID && p->y != INVALID) {
		newpen;
		pn.col=7;
		pn.op=GR_NOT;
		r.x=r0->x+p->x*r0->sx;
		r.y=r0->y+p->y*r0->sy;
		r.sx=r0->sx;
		r.sy=r0->sy;
		framerect(&r);
		oldpen;
	}
}
