/****************************
		'pblock.c'
****************************/

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <resource.h>
#include <mem.h>
#include "pet.h"

#define ATRBITS	16
#define ATR_X	30*8
#define ATR_Y	12*8
#define ATR_SX	10*8
#define ATR_SY	18*16
#define ATR_MSKX ATR_X+8
#define ATR_MSKY ATR_Y+33*8
#define PXN_X	44*8
#define PXN_Y	3*8
#define PXN_SX	8*8
#define PXN_SY	5*8

#define ATR_MASK 0x01
#define ATR_OVER 0x02

extern int  pix_cnt;
extern int  pix_use;
extern PATT pt_sel;
extern H_PAT *rh_pat;
extern PEN  pn_base;
extern byte *blktbl;
extern int  blksiz;
extern ATTR  *atrtbl;
byte *pixtbl;
word tblsiz;
flag wordblk;

static flag dspatr;
static BTNS bt_attr={ CT_RBTN,0,ATR_X+8,ATR_Y+8,NIL,0,ATRBITS,VT,16 };
static BTN  rb_attr[ATRBITS]={
	{ "mask",0,0,0 },
	{ "over",0,0,0 },
	{ "----",0,0,0 },
	{ "obst",0,0,0 },
	{ "b4  ",0,0,0 },
	{ "b5  ",0,0,0 },
	{ "b6  ",0,0,0 },
	{ "b7  ",0,0,0 },
	{ "b8  ",0,0,0 },
	{ "b9  ",0,0,0 },
	{ "b10 ",0,0,0 },
	{ "b11 ",0,0,0 },
	{ "b12 ",0,0,0 },
	{ "b13 ",0,0,0 },
	{ "b14 ",0,0,0 },
	{ "b15 ",0,0,0 },
};
static RECT r_attr={ ATR_X,ATR_Y,ATR_SX,ATR_SY };
static RECT r_pixn={ PXN_X,PXN_Y,PXN_SX,PXN_SY };

/*** Init Pix table ***/

initpixtbl()
{
	wordblk=pix_cnt > 256;
	if(pixtbl) {
		free(pixtbl);
		pixtbl=NIL;
	}
	if(blktbl) {
		pixtbl=malloc(pix_cnt);
		setpixtbl();
	}
}

/*** Set Pix table ***/

setpixtbl()
{
	int  i;
	int  blkcnt;
	byte *p;

	memset(pixtbl,0,pix_cnt);
	p=blktbl;
	blkcnt=rh_pat->blk_sx*rh_pat->blk_sy*rh_pat->blk_cnt;
	if(wordblk) {
		for_to(i,blkcnt) {
			pixtbl[*((word*)p)++]=TRUE;
		}
	} else {
		for_to(i,blkcnt) {
			pixtbl[*p++]=TRUE;
		}
	}
	pix_use=0;
	p=pixtbl;
	for_to(i,pix_cnt) {
		if(*p++) pix_use++;
	}
}

/*** Insert new pix ***/

int  insertpix(pat)
byte *pat;
{
	int  pix;
	int  i;
	byte *p;
	byte far *fp;

	pix=INVALID;
	p=pixtbl;
	fp=pt_sel.patp;
	for_to(i,pix_cnt) {
		if(*p++) {
			if(!farmemcmp(fp,(byte far*)pat,pt_sel.pix_siz)) break;
		}
		fp+=pt_sel.pix_siz;
	}
	if(i == pix_cnt) {
		p=pixtbl;
		for_to(i,pix_cnt) {
			if(!*p++) {
				fp=pt_sel.patp+i*pt_sel.pix_siz;
				farmemcpy(fp,(byte far*)pat,pt_sel.pix_siz);
				*(p-1)=TRUE;
				pix=i;
				break;
			}
		}
	} else {
		pix=i;
	}
	return(pix);
}

/*** Clear unused pixcel ***/

usepix()
{
	int  i;
	byte *p;
	byte far *fp;

	p=pixtbl;
	fp=pt_sel.patp;
	for_to(i,pix_cnt) {
		if(!*p) {
			farmemset(fp,0,pt_sel.pix_siz);
		}
		p++;
		fp+=pt_sel.pix_siz;
	}
}

/*** Draw pix No. ***/

drawpixnum(blkn)
int  blkn;
{
	int  i;
	int  n1,n2;
	byte *p;

	newpen;
	pn.col=0;
	drawwindow(&r_pixn,1);
	p=blktbl+blksiz*(blkn<<wordblk);
	for_to(i,2) {
		gloc(PXN_X+4,PXN_Y+4+i*16);
		if(wordblk) {
			n1=*((word*)p)++;
			n2=*((word*)p)++;
		} else {
			n1=*p++;
			n2=*p++;
		}
		print("%3d %3d",n1,n2);
	}
	oldpen;
}

/*** Draw pix-attr ***/

drawattr(atr)
int  atr;
{
	int  i;
	word tst;
	BTN  *bp;
	ATTR *atrp;

	atrp=atrtbl+atr;
	if(!dspatr) {
		drawwindow(&r_attr,-1);
		dspatr=TRUE;
	}
	bp=rb_attr;
	tst=1;
	for_to(i,ATRBITS) {
		bp->mode=atrp->attr & tst ? MD_ON : 0;
		tst<<=1;
		bp++;
	}
	bt_attr.btnp=rb_attr;
	drawrbtn(&bt_attr);
	pn.col=0;
	drawstring(ATR_MSKX,ATR_MSKY,0,atrp->mask ?"mask%3d":"       ",atrp->mask);
	dspatr=TRUE;
}

clearattr()
{
	RECT r;

	pn=pn_base;
	r.x=r_attr.x;
	r.y=r_attr.y;
	r.sx=r_attr.sx+1;
	r.sy=r_attr.sy+1;
	fillrect(&r);
	dspatr=FALSE;
}

/*** Do pix-attr ***/

flag do_attr(done,atr)
flag done;
int  atr;
{
	int  sel;
	word attr1;
	ATTR *atrp;
	
	atrp=atrtbl+atr;
	if(!done && dspatr) {
		sel=do_rbtn(&bt_attr);
		if(sel) {
			done=TRUE;
			if(sel > 0) {
				sel--;
				attr1=1<<sel;
				if(rb_attr[sel].mode & MD_ON) {
					atrp->attr|=attr1;
				} else {
					atrp->attr&=~attr1;
					if(attr1 == ATR_MASK) {
						atrp->mask=0;
						pn.col=0;
						drawstring(ATR_MSKX,ATR_MSKY,0,"       ");
					}
				}
				rh_pat->h.status|=RST_MDF;
			}
		}
	}
	return(done);
}

/*** set mask pixcel ***/

setmaskpix(get,put)
int  get,put;
{
	int  i;
	byte *getp,*putp;

	if(blktbl) {
		getp=blktbl+blksiz*(get<<wordblk);
		putp=blktbl+blksiz*(put<<wordblk);
		for_to(i,blksiz) {
			if(wordblk) {
				setmaskpix1(*((word*)getp)++,*((word*)putp)++);
			} else {
				setmaskpix1(*getp++,*putp++);
			}
		}
	} else {
		setmaskpix1(get,put);
	}
}

static setmaskpix1(get,put)
int  get,put;
{
	int  i;
	flag over;
	word far *fp;
	word far *setpatp();
	ATTR *atrp;

	fp=setpatp(put);
	over=TRUE;
	for_to(i,pt_sel.pix_siz/2) {
		if(*fp++ != 0xFFFF) {
			over=FALSE;
			break;
		}
	}
	atrp=atrtbl+get;
	if(over) {
		atrp->attr&=~ATR_MASK;
		atrp->attr|=ATR_OVER;
		atrp->mask=0;
	} else {
		if(get == put || !put) {
			atrp->attr&=~(ATR_MASK+ATR_OVER);
			atrp->mask=0;
		} else {
			atrp->attr&=~ATR_OVER;
			atrp->attr|=ATR_MASK;
			atrp->mask=put;
		}
	}
}
