/****************************
		'pedit.c'
****************************/

#include <std.h>
#include <graf.h>
#include <mouse.h>
#include "pet.h"

#define EBOX_X	4*8
#define EBOX_Y	11*8
#define VBOX_X	32*8
#define VBOX_Y	5*8
#define TOL_X	1*8
#define TOL_Y	11*8
#define TOL_DY	24

enum _tool {
	TL_PEN,
	TL_LIN,
	TL_BOX,
	TL_CPY,
	TL_CPY2,
	TL_CPY4,
	TL_ROL,
	TL_MIR,
	TL_UPDN,
	TL_UND,
	TL_MEM,
	TOOLS,
};

extern int  tilemode;

static enum _tool penmode;
static flag fatpen;
static flag drag;
static flag bcpy;
static RECT r_edt={ EBOX_X,EBOX_Y,8,8 };

/*** Init edit box ***/

initebox()
{
	gp_pix=EBOX_Y*80+EBOX_X/8;
	gp_vbox=VBOX_Y*80+VBOX_X/8;
	memset(px_edt,8,BUFSZ);
	memset(px_bak,8,BUFSZ);
}

/*** Draw edit window ***/

drawedit()
{
	RECT r;

	r_edt.sx=siz_x*8;
	r_edt.sy=siz_y*8<<vsize;
	shaderect(&r_edt,3);
	r_edt.sx=8;
	r_edt.sy=8<<vsize;
	r.x=VBOX_X;
	r.y=VBOX_Y;
	r.sx=siz_x;
	r.sy=siz_y<<vsize;
	shaderect(&r,2);
	drawebox();
	drawtools();
	drawpalet();
}

/*** Draw edit box ***/

drawebox()
{
	byte *p;
	byte *py;
	int  x,y;
	
	p=px_edt;
	for_to(y,siz_y) {
		py=p;
		for_to(x,siz_x) {
			drawpix(x,y,*p++);
		}
		p=py+BUF_SX;
	}
}

/*** Draw b.y pen ***/

putpen(x,y)
int  x,y;
{
	int  col;
	
	col=gettile(x&3,y&3);
	editpix(x,y,col);
}

editpix(x,y,col)
int  x,y;
int  col;
{
	int  oldcol;

	oldcol=swappix(x,y,px_edt,col);
	if(col != oldcol)
		drawpix(x,y,col);
}

/*** Do edit ***/

flag do_edit(done)
flag done;
{
	done=do_ebox(done);
	done=do_tool(done);
	done=do_palet(done);
	return(done);
}

/*** Do edit box ***/

static int do_ebox(done)
flag done;
{
	int  bsy;
	POINT p;
	static POINT p0;
	static POINT dwn;
	static int  erasecol;
	
	p.x=siz_x;
	p.y=siz_y;
	if(done || !insquare(ms.x,ms.y,&r_edt,&p)) {
		 p0.x=p0.y=dwn.x=dwn.y=INVALID;
	} else {
		done=TRUE;
		if(!(ms.evnt & ~MS_MOV)) {
			if((p.x == p0.x) && (p.y == p0.y)) return(done);
		}
		p0=p;
		if(!penmode) {
			if(drag) {
				dragbox();
				drag=bcpy=FALSE;
			}
			if(ms.btn & MS_LON) {
				putpen(p.x,p.y);
				if(fatpen) {
					if(p.x+1 < siz_x) putpen(p.x+1,p.y);
					if(!vsize) {
						if(p.y+1 < siz_y) putpen(p.x,p.y+1);
						if(p.x+1 < siz_x && p.y+1 < siz_y) putpen(p.x+1,p.y+1);
					}
				}
			} else if(ms.btn & MS_RON) {
				if(ms.evnt & MS_RDN) {
					dwn=p;
					erasecol=getpix(p.x,p.y,px_edt);
				}
				if(p.x != dwn.x || p.y != dwn.y) {
					dwn.x=dwn.y=INVALID;
					editpix(p.x,p.y,erasecol);
				}
			} else if(ms.evnt & MS_RUP) {
				if(p.x == dwn.x && p.y == dwn.y) {
					filltile(getpix(p.x,p.y,px_edt));
				}
			}
		} else {
			bsy=15>>vsize;
			switch(penmode) {
			case TL_CPY2:
				bsy>>=1;
				p.x&=~7;
				p.y&=~bsy;
				break;
			case TL_CPY4:
				p.x&=~15;
				p.y&=~bsy;
				break;
			}
			if(drag) dragbox();
			if(ms.evnt & MS_LDN) {
				if(!drag) {
					b=b0=p;
					drag=TRUE;
				} else {
					switch(penmode) {
					case TL_LIN:
						edt_line();
						break;
					case TL_BOX:
						edt_fill();
						break;
					default:
						edt_copy();
						break;
					}
				}
			} else if(ms.evnt & MS_RDN) {
				if(drag) {
					drag=bcpy=FALSE;
				} else {
					drawtool(penmode,OFF);
					penmode=TL_PEN;
				}
			} else if(ms.evnt & MS_LUP) {
				if(drag && !bcpy) {
					if(penmode < TL_CPY) {
						edt_store(FALSE);
					} else {
						edt_store(TRUE);
						if(penmode == TL_CPY) settile();
					}
					bcpy=TRUE;
				}
			} else if(!(ms.btn & MS_LON)) {
				if(!bcpy) {
					drag=FALSE;
				}
			}
			if(drag) {
				if(penmode <= TL_CPY) {
					b=p;
					if(!bcpy && penmode != TL_LIN) {
						if(b.x < b0.x) b.x=b0.x;
						if(b.y < b0.y) b.y=b0.y;
					}
					if(bcpy) {
						adjbox(siz_x,siz_y);
					}
				} else {
					b0=p;
					if(penmode == TL_CPY2) {
						b.x=b0.x+7;
						b.y=b0.y+bsy;
					} else {
						b.x=b0.x+15;
						b.y=b0.y+bsy;
					}
					if(b.x > siz_x) b.x=siz_x-1;
					if(b.y > siz_y) b.y=siz_y-1;
				}
				dragbox();
			}
		}
	}
	return(done);
}
		
/*** Adjust drag box ***/

adjbox(sx,sy)
int  sx,sy;
{
	b0.x=b.x-cb.sx+1;
	b0.y=b.y-cb.sy+1;
	if(b0.x < 0) {
		b.x-=b0.x;
		b0.x=0;
	} else if(b0.x >= sx) {
		b.x-=b0.x-sx+1;
		b0.x=sx-1;
	}
	if(b0.y < 0) {
		b.y-=b0.y;
		b0.y=0;
	} else if(b0.y >= sy) {
		b.y-=b0.y-sy+1;
		b0.y=sy-1;
	}
}

/*** Dragging box/line ***/

static dragbox()
{
	int  sy;
	int  dy;
	
	newpen;
	pn.col=7;
	pn.op=GR_NOT;
	pn.tile=PN_SOLID;
	sy=8<<vsize;
	if(penmode == TL_LIN) {
		dy=EBOX_Y+(4<<vsize);
		line(b0.x*8+EBOX_X+4,b0.y*sy+dy,b.x*8+EBOX_X+4,b.y*sy+dy);
	} else {
		dy=(8<<vsize)-1;
		box(b0.x*8+EBOX_X-1,b0.y*sy+EBOX_Y-1,b.x*8+7+EBOX_X,b.y*sy+dy+EBOX_Y);
	}
	oldpen;
}	

/*** Draw line ***/

static edt_line()
{
	int  x,y;
	int  sx,sy;
	int  mx,my;

	if(b.x >= b0.x) {
		sx=b.x-b0.x;
		mx=1;
	} else {
		sx=b0.x-b.x;
		mx=-1;
	}
	if(b.y >= b0.y) {
		sy=b.y-b0.y;
		my=1;
	} else {
		sy=b0.y-b.y;
		my=-1;
	}
	if(!sx && !sy) {
		putpen(b0.x,b0.y);
	} else if(sx >= sy) {
		for_to(x,sx+1) {
			putpen(b0.x+x*mx,b0.y+divide(x,sy,sx)*my);
		}
	}
	else {
		for_to(y,sy+1) {
			putpen(b0.x+divide(y,sx,sy)*mx,b0.y+y*my);
		}
	}
}	

static divide(x,i,n)
int  x,i,n;
{
	int t;
	
	t=x*2*i/n;
	if(t & 1) t+=2;
	return(t/2);
}

/*** Fill box ***/

static edt_fill()
{
	int  x,y;
	
	for_to(y,cb.sy) {
		for_to(x,cb.sx) {
			putpen(x+b0.x,y+b0.y);
		}
	}
}

/*** Copy/store box ***/

static edt_store(cpy)
flag cpy;
{
	int  x,y;
	
	cb.x=b0.x;
	cb.y=b0.y;
	cb.sx=b.x-b0.x+1;
	cb.sy=b.y-b0.y+1;
	if(penmode != TL_LIN) {
		flushframe(cb.x*8+EBOX_X,(cb.y*8<<vsize)+EBOX_Y,
			cb.sx*8,(cb.sy*8<<vsize)
		);
	}
	if(cpy) {
		for_to(y,cb.sy) {
			for_to(x,cb.sx) {
				setpix(x+cb.x,y+cb.y,px_bak,getpix(x+cb.x,y+cb.y,px_edt));
			}
		}
	}
}

static edt_copy()
{
	int  x,y;
	int  col;

	for_to(y,cb.sy) {
		for_to(x,cb.sx) {
			col=getpix(x+cb.x,y+cb.y,px_bak);
			if(col < 8) {
				editpix(x+b0.x,y+b0.y,col);
			}
		}
	}
}

/*** Set Tile ***/

static settile()
{
	int  x;
	int  y;
	byte *p;

	p=px_pen;
	for_to(y,4) {
		for_to(x,4) {
			*p++=getpix(cb.x+(x%cb.sx),cb.y+(y%cb.sy),&px_edt);
		}
	}
	drawtile(FALSE);
	tilemode=0;
}

static filltile(col)
int  col;
{
	memset(px_pen,col,PENSZ);
	drawtile(FALSE);
	tilemode=0;
}

/*** Init toolbox ***/

inittool()
{
	fatpen=FALSE;	
	penmode=TL_PEN;
}

/*** Draw tool box ***/

static drawtools()
{
	int  i;
	flag on;
	RECT r;
		
	r.x=TOL_X;
	r.y=TOL_Y;
	r.sx=r.sy=16;
	for_to(i,TOOLS) {
		on=FALSE;
		switch(i) {
		case TL_PEN:
			on=fatpen;
			break;
		case TL_LIN:
		case TL_BOX:
		case TL_CPY:
			if(i == penmode) on=TRUE;
			break;
		}
		drawtool(i,on);
		shaderect(&r,1);
		r.y+=TOL_DY;
	}
}

drawtool(tool,on)
int  tool;
flag on;
{
	pt_icon.col0=on ? 0 : 7;
	pt_icon.col1=on ? 7 : 0;
	putpatt(TOL_X,TOL_Y+tool*TOL_DY,&pt_icon,tool);
}

/*** Do tool box ***/

static flag do_tool(done)
flag done;
{
	int  x,y;	
	int  z;
	enum _tool tool;
	int  col;
	
	x=ms.x-TOL_X;
	y=ms.y-TOL_Y;
	if(!done && inarea(x,y,16,TOOLS*TOL_DY)) {
		done=TRUE;
		tool=y/TOL_DY;
		if((ms.evnt & MS_DN) && (y%TOL_DY < 16)) {
			if(drag) {
				dragbox();
				drag=bcpy=FALSE;
			}
			switch(tool) {
			case TL_PEN:
				fatpen=!fatpen;
				if(penmode) {
					drawtool(penmode,OFF);
				}
				penmode=TL_PEN;
				drawtool(tool,fatpen);
				break;
			case TL_LIN:
			case TL_BOX:
			case TL_CPY:
			case TL_CPY2:
			case TL_CPY4:
				if(penmode) {
					if(tool != penmode) {
						drawtool(penmode,OFF);
						penmode=tool;
					}
					else penmode=TL_PEN;
				}
				else penmode=tool;
				drawtool(tool,penmode);
				break;
			case TL_UND:
				memcpy(px_tmp,px_edt,BUFSZ);
				memcpy(px_edt,px_bak,BUFSZ);
				memcpy(px_bak,px_tmp,BUFSZ);
				drawebox();
				break;
			case TL_MEM:
				memcpy(px_bak,px_edt,BUFSZ);
				break;
			case TL_ROL:
				repmouse(MS_LON,10,10);
				y%=24;
				z=15-x;		
				if(y < z && y < x) {
					for_to(x,siz_x) {
						col=getpix(x,0,px_edt);
						for(y=1; y<siz_y; y++) {
							setpix(x,y-1,px_edt,getpix(x,y,px_edt));
						}
						setpix(x,siz_y-1,px_edt,col);
					}
				} else if(y > z && y > x) {
					for_to(x,siz_x) {
						col=getpix(x,siz_y-1,px_edt);
						for(y=siz_y-1; y>0; --y) {
							setpix(x,y,px_edt,getpix(x,y-1,px_edt));
						}
						setpix(x,0,px_edt,col);
					}
				} else if(y < z && y > x) {
					for_to(y,siz_y) {
						col=getpix(0,y,px_edt);
						for(x=1; x<siz_x; x++) {
							setpix(x-1,y,px_edt,getpix(x,y,px_edt));
						}
						setpix(siz_x-1,y,px_edt,col);
					}
				} else if(y > z && y < x) {
					for_to(y,siz_y) {
						col=getpix(siz_x-1,y,px_edt);
						for(x=siz_x-1; x>0; --x) {
							setpix(x,y,px_edt,getpix(x-1,y,px_edt));
						}
						setpix(0,y,px_edt,col);
					}
				}
				drawebox();
				break;
			case TL_MIR:
				for_to(y,siz_y) {
					for_to(x,siz_x/2) {

						col=getpix(x,y,px_edt);
						col=swappix(siz_x-x-1,y,px_edt,col);
						setpix(x,y,px_edt,col);
					}
				}
				drawebox();
				break;
			case TL_UPDN:
				for_to(x,siz_x) {
					for_to(y,siz_y/2) {
						col=getpix(x,y,px_edt);
						col=swappix(x,siz_y-y-1,px_edt,col);
						setpix(x,y,px_edt,col);
					}
				}
				drawebox();
				break;
			}
		}
	}
	return(done);
}

/*** get/set/swap pixcel ***/

static int getpix(x,y,buf)
word x,y;
byte *buf;
{
	return(buf[y*BUF_SX+x]);
}

static setpix(x,y,buf,col)
word x,y;
byte *buf;
{
	buf[y*BUF_SX+x]=col;
}

static int swappix(x,y,buf,col)
word x,y;
byte *buf;
{
	byte *p;
	int  oldcol;

	p=buf+y*BUF_SX+x;
	oldcol=*p;
	*p=col;
	return(oldcol);
}
