/****************************
		'pet.c'
****************************/

#define MAIN

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <mouse.h>
#include <resource.h>
#include "pet.h"

extern MBAR mb_pet;
extern PATT pt_std;
extern void (*v_stop)();
extern void (*v_error)();

static char nm_std[]="untitled";
PEN  pn_base={ 1,0,PN_GRAY };
RECT r_left={ 0,18,43*8,400-18 };
H_PAT *rh_pat;
H_MAP *rh_map;

/*** pet main ***/

main(argc,argv)
int  argc;
char *argv[];
{
	int  evnt;
	flag done;
	char *p;
	char *name;
	char temp[PATHLN];
	
	if(argc >= 2) {
		if(p=(char*)strchr(argv[1],'.')) *p=0;
		name=argv[1];
	} else {
		name=nm_std;
	}
	strcpy(temp,name);
	debug=TRUE;
	loadpat("std.pat",&pt_std);
	loadpat("peticon.pat",&pt_icon);
	loadpalet();
	loadlpt();
	openpat(extrpl(temp,".bg2"));
	openmap(extrpl(temp,".mp2"));
	initstop();
	initerror();
	initscrn();
	initmouse();
	drawall();
	mouseon();
	repeat {
		done=FALSE;
		evnt=getmouse(&ms);
		if(evnt || ms.btn & MS_ON) {
			done=do_mbar(&mb_pet);
			switch(editmode) {
			case ED_DRAW:
				done=do_edit(done);
				break;
			case ED_MAP:
				done=do_map(done);
				break;
			}
			done=do_select(done);
		}
	} until(quit);
	savepalet();
	stop();
}

/*** Init screen ***/

initscrn()
{
	type98();
	pfkey(0);
	pchr(CLS);
	csroff();
	ginit(400);
	gcls();
	gon();
	initpalet();
	ptype(&p_graf);
	keepgraf((ulong)0x6000);
}

/*** Draw all ***/

drawall()
{
	pn=pn_base;
	fillrect(&r_scrn);
	initall();
	drawmbar(&mb_pet);
	initpen(&pn);
	drawrsc(TRUE,TRUE);
}

initall()
{
	initmenu();
	initpsel();
	initebox();
	inittool();
	initmap();
}

drawrsc(left,right)
flag left;
flag right;
{
	if(right) {
		drawpsel();
	}
	if(left) {
		clearleft();
		switch(editmode) {
		case ED_DRAW:
			drawedit();
			break;
		case ED_MAP:
			drawmap();
			break;
		}
	}
}

clearleft()
{
	pn=pn_base;
	fillrect(&r_left);
}

/*** Init break ***/

static breakin(ofs,seg)
int  ofs;
int  seg;
{
	ptype(&p_dos);
	print("<<< Break in %04X:%04X >>>",seg,ofs);
	stop();
}

static void abort1()
{
	stopoff();
	mouseoff();
	crtvoff();
	goff();
	pfkey(1);
	csron();
}

static initstop()
{
	onstop(breakin);
	v_stop=abort1;
}

/*** Init error ***/

initerror()
{
	void drawerr();
	void drawharderr();

	v_error=drawerr;
	harderr(drawharderr);
}
