/****************************
		'pimage.c'
****************************/

#include <std.h>
#include <graf.h>
#include <mouse.h>
#include <file.h>
#include "pet.h"

#define B_SEG	0xA800
#define R_SEG	0xB000
#define G_SEG	0xB800
#define PIX		8

enum _type {
	TP_ST4,
	TP_IMG,
	TP_BRG,
};

extern int  psiz_x;
extern int  psiz_y;
extern int  pcnt_x;
extern int  pcnt_y;
extern int  blk_cx;
extern int  blk_cy;
extern int  pat_top;
extern int  pat_cnt;
extern int  blksiz;
extern byte *blktbl;
extern flag wordblk;
extern byte pattmp[];
extern RECT r_ssel;
extern PATT pt_sel;

static flag drag;
static flag bcpy;
static RECT ib;	
static RECT r_peek={ 640-14*8,2,13*8,16 };
static char *ext_img[]={ "*.ST4","*.IMG","*.B1","" };
static char nm_img[NAMELN]="UNTITLED.ST4";

char *strchr();
char *extrpl();
char *selectfile();

/*** Load image ***/

loadimage()
{
	int  fh;
	int  i;
	int  type;
	char *p;
	char *name;

	gscreen(1,1);
	name=selectfile("Image",ext_img);
	if(name && (int)name != INVALID)  {
		p=strchr(name,'.');
		strcpy(nm_img,name);
		for_to(type,3) {
			if(!strcmp(p,ext_img[type]+1)) break;
		}
		if((fh=_open(nm_img,O_RDONLY)) >= 0) {
			mouseoff();
			switch(type) {
			case TP_ST4:
				p=0;
				for_to(i,4) {
					farread(fh,p,B_SEG,8000);
					farread(fh,p,R_SEG,8000);
					farread(fh,p,G_SEG,8000);
					p+=8000;
				}
				break;
			case TP_IMG:
				farread(fh,0,B_SEG,32000);
				farread(fh,0,R_SEG,32000);
				farread(fh,0,G_SEG,32000);
				break;
			case TP_BRG:
				farread(fh,0,B_SEG,32000);
				_close(fh);
				name=extrpl(nm_img,".R1");
				if((fh=_open(name,O_RDONLY)) >= 0) {
					farread(fh,0,R_SEG,32000);
					_close(fh);
					name=extrpl(nm_img,".G1");
					if((fh=_open(name,O_RDONLY)) >= 0) {
						farread(fh,0,G_SEG,32000);
					}
				}
				break;
			}
			_close(fh);
			mouseon();
		}
		error(nm_img);
	}
	gscreen(0,0);
}

/*** Save image ***/

saveimage()
{
	int  fh;
	int  i;
	int  type;
	char *p;
	char *name;

	gscreen(1,1);
	if(setname("Save",nm_img)) {
		strupr(nm_img);
		p=strchr(nm_img,'.');
		for_to(type,3) {
			if(!strcmp(p,ext_img[type]+1)) break;
		}
		if(type == 3) type=TP_ST4;
		if((fh=openw(nm_img)) >= 0) {
			mouseoff();
			switch(type) {
			case TP_ST4:
				p=0;
				for_to(i,4) {
					farwrite(fh,p,B_SEG,8000);
					farwrite(fh,p,R_SEG,8000);
					farwrite(fh,p,G_SEG,8000);
					p+=8000;
				}
				break;
			case TP_IMG:
				farwrite(fh,0,B_SEG,32000);
				farwrite(fh,0,R_SEG,32000);
				farwrite(fh,0,G_SEG,32000);
				break;
			case TP_BRG:
				farwrite(fh,0,B_SEG,32000);
				_close(fh);
				name=extrpl(nm_img,".R1");
				if((fh=openw(name)) >= 0) {
					farwrite(fh,0,R_SEG,32000);
					_close(fh);
					name=extrpl(nm_img,".G1");
					if((fh=openw(name)) >= 0) {
						farwrite(fh,0,G_SEG,32000);
					}
				}
				break;
			}
			_close(fh);
			mouseon();
		}
		error(nm_img);
	}
	gscreen(0,0);
}

/*** Define Image block ***/

flag getimgblk()
{
	flag done;

	drag=bcpy=FALSE;
	if(done=do_image()) {
		cb=ib;
	}
	return(done);
}

putimgblk()
{
	drag=FALSE;
	bcpy=TRUE;
	ib=cb;
	do_image();
}

/*** Do image screen ***/

flag do_image()
{
	flag done;
	POINT p,p0;
	void far *peekp;
	
	gscreen(1,1);
	if(peekp=getrect(&r_peek,-1,3)) drawwindow(&r_peek,1);
	p0.x=p0.y=INVALID;
	done=FALSE;
	loop {
		getmouse(&ms);
		p.x=ms.x/PIX;
		p.y=ms.y/PIX;
		if(ms.evnt & MS_DN+MS_UP || p.x != p0.x || p.y != p0.y) {
			p0=p;
			if(drag) dragbox();
			if(bcpy) drag=TRUE;
			if(ms.evnt & MS_LDN) {
				if(!drag) {
					ib.x=p.x;
					ib.y=p.y;
					drag=TRUE;
				} else if(bcpy) {
					pat_to_img();
				}
			} else if(ms.evnt & MS_RDN) {
				if(!drag || bcpy) break;
				else drag=FALSE;
			} else if(ms.evnt & MS_LUP) {
				if(drag && !bcpy) {
					flushframe(ib.x*PIX,ib.y*PIX,ib.sx*psiz_x,ib.sy*psiz_y);
					done=TRUE;
					break;
				}
			}
			if(drag) {
				if(!bcpy) {
					ib.sx=(p.x-ib.x)*PIX/psiz_x+1;
					ib.sy=(p.y-ib.y)*PIX/psiz_y+1;
					if(ib.sx < 1) ib.sx=1;
					if(ib.sy < 1) ib.sy=1;
					if(ib.sx > pcnt_x) ib.sx=pcnt_x;
					if(ib.sy > pcnt_y) ib.sy=pcnt_y;
				} else {
					ib.x=p.x-ib.sx*psiz_x/PIX;
					ib.y=p.y-ib.sy*psiz_y/PIX;
					if(ib.x < 0) ib.x=0;
					if(ib.y < 0) ib.y=0;
				}
				p.x=ib.x;
				p.y=ib.y;
			} else {
				ib.sx=ib.sy=0;
			}
			if(peekp) {
				pn.col=0;
				drawstring(r_peek.x,r_peek.y,0
					," %2d-%-2d %2dx%-2d"
					,p.x,p.y,ib.sx*psiz_x/PIX,ib.sy*psiz_y/PIX
				);
			}
			if(drag) dragbox();
		}
	}
	if(peekp) putgraf(peekp);
	gscreen(0,0);
	return(done);
}

/*** Dragging box ***/

static dragbox()
{
	newpen;
	pn.col=7;
	pn.op=GR_NOT;
	pn.tile=PN_SOLID;
	frame(ib.x*PIX,ib.y*PIX,ib.sx*psiz_x,ib.sy*psiz_y);
	oldpen;
}	

/*** Pattern to Image ***/

pat_to_img()
{
	int  n,n0;
	int  x,y;

	pix0.x=ib.x*PIX;
	pix0.y=ib.y*PIX;
	n0=pat_top+cb.y*pcnt_x+cb.x;
	for_to(y,cb.sy) {
		n=n0;
		for_to(x,cb.sx) {
			drawselpat(x,y,n++,FALSE);
		}
		n0+=pcnt_x;
	}
}

/*** Image to Pattern ***/

img_to_pat()
{
	int  x,y;
	int  n,n0;
	word off,off0;

	mouseoff();
	gscreen(0,1);
	n0=pat_top+cb.y*pcnt_x+cb.x;
	off0=ib.y*PIX*80+ib.x;
	for_to(y,cb.sy) {
		n=n0;
		off=off0;
		for_to(x,cb.sx) {
			imgtopat(n++,off);
			if(n >= pat_cnt) goto skip;
			off+=psiz_x/PIX;
		}
		n0+=pcnt_x;
		off0+=psiz_y*80;
	}
skip:
	gscreen(0,0);
	mouseon();
}

/*** Image to one Pattern ***/

imgtopat(n,off0)
int  n;
word off0;
{
	int  x,y;
	word off;
	byte *p;
	word far *setpatp();

	if(blksiz <= 1) {
		imgtopix(setpatp(n),off0);
	} else {
		n*=blksiz;
		p=blktbl+(n<<wordblk);
		for_to(y,blk_cy) {
			off=off0;
			for_to(x,blk_cx) {
				if(blktbl) {
					imgtopix((byte far*)pattmp,off);
					if(wordblk) *((word*)p)++=insertpix(pattmp);
					else *p++=insertpix(pattmp);
				} else {
					imgtopix(setpatp(n++),off);
				}
				off+=r_ssel.sx/PIX;
			}
			off0+=r_ssel.sy*80;
		}
	}
}

/*** Image to Pixcel ***/

imgtopix(patp,off)
byte far *patp;
word off;
{
	if(maskplane(pt_sel.plane)) {
		farmemset(patp,0,pt_sel.plane_siz);
		patp+=pt_sel.plane_siz;
	}
	if(pt_sel.plane >= 3) {
		imgtopln3(patp,off,B_SEG);
		patp+=pt_sel.plane_siz;
		imgtopln3(patp,off,R_SEG);
		patp+=pt_sel.plane_siz;
		imgtopln3(patp,off,G_SEG);
	} else {
		imgtopln1(patp,off);
	}
}

imgtopln3(patp,imgp)
word far *patp;
word far *imgp;
{
	int  i;

	if(pt_sel.sx >= 16) {
		for_to(i,pt_sel.sy) {
			*patp++=*imgp;
			imgp+=40<<vsize;
		}
	} else {
		for_to(i,pt_sel.sy) {
			*((byte far*)patp)++=*imgp;
			imgp+=40<<vsize;
		}
	}
}

imgtopln1(patp,off)
word far *patp;
word off;
{
	int  i;
	word b,r,g;
	word img;

	for_to(i,pt_sel.sy) {
		b=*(word far *)MK_FP(B_SEG,off);
		r=*(word far *)MK_FP(R_SEG,off);
		g=*(word far *)MK_FP(G_SEG,off);
		switch(ptcol1) {
		case 0:
			img=~(b|r|g); break;
		case 1:
			img=b&~(r|g); break;
		case 2:
			img=r&~(b|g); break;
		case 3:
			img=b&r&~g; break;
		case 4:
			img=g&~(b|r); break;
		case 5:
			img=b&~r&g;	break;
		case 6:
			img=~b&r&g;	break;
		case 7:
			img=b&r&g; break;
		};
		if(pt_sel.sx >= 16) {
			*patp++=img;
		} else {
			*((byte far*)patp)++=img;
		}
		off+=80<<vsize;
	}
}
