/****************************
		'plpt.c'
****************************/

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <resource.h>
#include <error.h>
#include <mouse.h>
#include "pet.h"

#define MAPCOL	0xF0
#define GJCODE	0x7621
#define GJNEXT	0x0100
#define GJLEN	72
#define PIXs	32

enum _mn_lpt {
	MN_LPTCVT,
	MN_LPTOUT,
	MN_LPTS,
};

static DLOG dg_cvtbg={ "Convert BG data ...\n",28*8,13*8,2,Q_OK,Q_ESC };
static USER cb_cvtcol={ CT_USER,0,0,0,"color: " ,0,MD_ON ,0,0,MAPCOL };
static DLOG dg_lptout={ "Print out Full map.\n",25*8,0,2,Q_OK,Q_ESC };
static DLOG dg_lptnow={ "Print out now ...\n",25*8,12*8,1,Q_ESC };
static USER us_lptout={ CT_USER };
static char mg_lptx[]="Printer Not Ready !";
static char mg_formx[]="Format file not exist !";

static int  map_y;
static R_PAT rq_prn={ RSC_PAT,RAT_BG,256,16,16,1,0 };
static byte ptbuf[PIXs];
static char *lpthead;
static char headdata[32];

extern int  map_sx;
extern int  map_sy;
extern byte *blktbl;
extern flag wordblk;
extern MAP  far *maptop;
extern H_PAT *rh_pat;
word far *setpatp();

/*** load header data ***/

loadlpt()
{
	lpthead=(char*)pload("lpt.pet");
	errno=0;
}

/*** print map ***/

printmap(item)
enum _mn_lpt item;
{
	char *extrpl();
	H_PAT *rh;
	H_PAT *searchrsc();
	char name[NAMELN];
	int  drawcolbtn();
	int  do_colbtn();
	int  drawlpt();
	int  do_lpt();

	switch(item) {
	case MN_LPTCVT:
		linkctrls(&dg_cvtbg,&cb_cvtcol,0);
		cb_cvtcol.draw=drawcolbtn;
		cb_cvtcol.do_=do_colbtn;
		if(dialog(&dg_cvtbg) == Q_OK) {
			strcpy(name,rh_pat->h.name);
			extrpl(name,".prn");
			if(!(rh=searchrsc(name))) {
				rq_prn.pix_cnt=rh_pat->blk_cnt;
				rh=(H_PAT*)creatpat(&rq_prn,name,NIL);
				if(rh) strcpy(rh->h.name,name);
			}
			if(rh) {
				convertbg(rh,cb_cvtcol.par);
			}
			exgrsc(rh,FALSE);
		}
		break;
	case MN_LPTOUT:
		if(!lpthead) drawerr(&mg_formx);
		else {
			if(dialog(&dg_lptout) == Q_OK) {
				linkctrls(&dg_lptnow,&us_lptout,0);
				us_lptout.draw=drawlpt;
				us_lptout.do_=do_lpt;
				map_y=0;
				sprint(headdata,lpthead,map_sx*16);
				if(!lputc(CR)) drawerr(mg_lptx);
				else dialog(&dg_lptnow);
			}
		}
		break;
	}
}

/*** Convert BG data ***/

convertbg(rh,colbit)
H_PAT *rh;
byte  colbit;
{
	int  i,j;
	byte *bp;
	word far *srcp;
	byte far *dstp;

	bp=blktbl;
	dstp=rh->h.farp;
	for_to(i,rh_pat->blk_cnt) {
		for_to(j,4) {
			srcp=setpatp(wordblk ? *((word*)bp)++ : *bp++);
			cvtbg(dstp,srcp,colbit);
			dstp+=j&1 ? 15 : 1;
		}
	}
}

/*** set gaiji ***

setgaiji()
{
	int  i,j;
	word code;
	byte far *fp;
	byte *p;
	
	lputs("\0322");			/* clear GAIJI data */
	fp=rh_pat->h.farp;
	p=gjbuf;
	*p++=ESC;
	*p++='+';
	gjbuf[GJLEN-2]=4;
	code=GJCODE;
	for_to(i,rh_pat->pix_cnt) {
		*p=code>>8;
		*(p+1)=code;
		farmemcpy((byte far*)ptbuf,fp,PIXs);
		cvtgaiji(p+2,ptbuf);
		lputs(gjbuf);
		fp+=PIXs;
		code++;
		if(i == 128) code=GJCODE+GJNEXT;
	}
}
*/

/*** print out map ***/

static int  drawlpt(up)
USER *up;
{
	pn.col=0;
	drawstring(up->x,up->y,0,"    line %4d/%-4d",map_y+1,map_sy);
	return(up->y+16);
}

flag do_lpt(up)
USER *up;
{
	int  i,j;
	byte *p;
	MAP  far *mp;
	word far *patp;

	if(map_y < map_sy) {
		while(!(getmouse(&ms)&MS_DN)) {
			lputs(headdata);
			mp=maptop+map_y*map_sx;
			for_to(i,map_sx) {
				patp=setpatp(*mp++);
				cvtlpt(ptbuf,patp);
				p=ptbuf;
				for_to(j,PIXs) lputc(*p++);
			}
			lputc(CR);
			lputc(LF);
			if(++map_y == map_sy) {
				drawstring(up->x,up->y,0,"Print out completed !");
				break;
			} else {
				drawlpt(up);
			}
		}
	}
	return(FALSE);
}
