/****************************
		'pmap.c'
****************************/

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <mouse.h>
#include <resource.h>
#include "pet.h"

#define MAP_X	8
#define MAP_Y	7*8
#define MTTL_SX	22*8
#define MTTL_SY	16
#define PRNTSPC	8
#define TL_SIZE	12
#define VIEW_SZ	10
#define VIEW_MIN 6*16
#define VIEW_MAX 20*16
#define MTOL_X	24*8
#define MTOL_Y	4*8
#define MTOL_DX	24
#define MTOOLS	2

enum _maptool {
	TL_PUT,
	TL_FILL,
	TL_COPY,
};

int  map_sx;
int  map_sy;
int  map_sel;
MAP  far *maptop;

extern int  psiz_x;
extern int  psiz_y;
extern int  pat_get;
extern H_MAP *rh_map;

static enum _maptool maptool;
static flag drag;
static flag bcpy;
static POINT p;
static POINT p0;
static RECT view={ 0,0,0,0 };
static RECT r_map=  { MAP_X,MAP_Y,0,0 };
static RECT r_msel= { MAP_X,MAP_Y,0,0 };
static RECT r_mttl= { MAP_X,MAP_Y-MTTL_SY-2,MTTL_SX,MTTL_SY };
static RECT r_sblk= { SBLK_X,SBLK_Y,0,0 };
static RECT r_msiz= { 0,0,16,16 };
static POINT view_min;
static POINT view_max;
SBAR sb_maph={ CT_SBAR,0,0,0,NIL,0,HZ };
SBAR sb_mapv={ CT_SBAR,0,0,0,NIL,0,VT };

R_MAP rq_map0={ RSC_MAP,0,64,64 };

/*** Create map ***/

H_MAP *creatmap(req,name,oldrh)
R_MAP *req;
char  *name;
H_MAP *oldrh;
{
	word farkeep;
	H_MAP *rh;

	farkeep=req->map_sx*req->map_sy*sizeof(MAP);
	if(oldrh) {
		rh=(H_MAP*)allocrsc(oldrh,0,farkeep);
	} else {
		rh=(H_MAP*)openrsc(0,farkeep);
	}
	if(rh) {
		strcpy(rh->h.name,name);
		rh->h.type=req->type;
		rh->map_sx=req->map_sx;
		rh->map_sy=req->map_sy;
		rh->view_sx=VIEW_SZ;
		rh->view_sy=VIEW_SZ;
	}
	return(rh);
}

/*** Open map ***/

openmap(name)
char *name;
{
	if(!(rh_map=(H_MAP*)loadrsc(name))) {
		rh_map=(H_MAP*)creatmap(&rq_map0,name,NIL);
	}
}

/*** Init map ***/

initmap()
{
	if(rh_map) {
		maptop=(MAP far *)(rh_map->h.farp);
		view.sx=VIEW_MAX/psiz_x;
		view.sy=VIEW_MAX/psiz_y;
		map_sx=rh_map->map_sx;
		map_sy=rh_map->map_sy;
	}
}

/*** Draw map ***/

drawmap()
{
	r_map.sx=view.sx*psiz_x;
	r_map.sy=view.sy*psiz_y;
	r_msel.sx=r_sblk.sx=psiz_x;
	r_msel.sy=r_sblk.sy=psiz_y;
	drawmapttl(TRUE);
	drawmbox();
	sb_maph.x=r_map.x;
	sb_maph.y=r_map.y+r_map.sy;
	sb_maph.fw=r_map.sx-32;
	sb_maph.max=map_sx-view.sx+1;
	sb_maph.val=view.x;
	sb_maph.view=view.sx;
	sb_maph.skip=view.sx/2;
	drawsbar(&sb_maph);
	sb_mapv.x=r_map.x+r_map.sx;
	sb_mapv.y=r_map.y;
	sb_mapv.fw=r_map.sy-32;
	sb_mapv.max=map_sy-view.sy+1;
	sb_mapv.val=view.y;
	sb_mapv.view=view.sy;
	sb_mapv.skip=view.sy/2;
	drawsbar(&sb_mapv);
	r_msiz.x=r_map.x+r_map.sx;
	r_msiz.y=r_map.y+r_map.sy;
	pt_icon.col0=7;
	pt_icon.col1=0;
	putpatt(r_msiz.x,r_msiz.y,&pt_icon,TL_SIZE);
	p0.x=p0.y=map_sel=INVALID;
	shaderect(&r_sblk,2);
	pat_get=0;
	pix0.x=SBLK_X;
	pix0.y=SBLK_Y;
	drawselpat(0,0,pat_get,0);
	drawmtools();
}

drawmbox()
{
	int  x,y;
	MAP  far *mp, far *mpy;

	pix0.x=r_map.x;
	pix0.y=r_map.y;
	mp=maptop+(view.y*map_sx+view.x);
	for_to(y,view.sy) {
		mpy=mp;
		for_to(x,view.sx) {
			drawselpat(x,y,*mp,0);
			mp++;
		}
		mp=mpy+map_sx;
	}
}

/*** Draw map title bar ***/

static drawmapttl(new)
flag new;
{
	int  x,y;

	if(new) {
		shaderect(&r_mttl,1);
		pn.col=COL7;
		pn.tile=PN_SOLID;
		fillrect(&r_mttl);
		gloc(r_mttl.x+PRNTSPC,r_mttl.y);
		pn.col=COL0;
		print(rh_map->h.name);
	}
	pn.col=COL0;
	x=view.x;
	y=view.y;
	if(map_sel != INVALID) {
		x+=p.x;
		y+=p.y;
	}
	drawstring(r_mttl.x+r_mttl.sx,r_mttl.y,PRNTSPC,"%3d-%-3d",x,y);
}

/*** Do map ***/

flag do_map(done)
{
	MAP  far *mp;
	int  sel;
	int  in_bar;
	
	p.x=view.sx;
	p.y=view.sy;
	sel=INVALID;
	if(!done && insquare(ms.x,ms.y,&r_msel,&p)) {
		done=TRUE;
		sel=(view.y+p.y)*map_sx+(view.x+p.x);
		if(ms.evnt & MS_DN+MS_UP || sel != map_sel) {
			if(!maptool) {
				dragrect(&p,&p0,&r_msel);
				if(ms.btn & MS_ON) {
					mp=maptop+sel;
					if(*mp != pat_get) {
						if(ms.btn & MS_LON) {
							*mp=pat_get;
							dragrect1(&p,&r_msel);
							pix0.x=r_map.x;
							pix0.y=r_map.y;
							drawselpat(p.x,p.y,pat_get,0);
							dragrect1(&p,&r_msel);
							rh_map->h.status|=RST_MDF;
						} else {
							pat_get=*mp;
							pix0.x=SBLK_X;
							pix0.y=SBLK_Y;
							drawselpat(0,0,pat_get,0);
						}
					}
				}
			} else {
				if(drag) dragbox(&r_map);
				if(ms.evnt & MS_LDN) {
					if(!drag) {
						b=b0=p;
						drag=TRUE;
					} else {
						switch(maptool) {
						case TL_FILL:
							map_fill();
							break;
						case TL_COPY:
							map_copy();
							break;
						}
					}
				} else if(ms.evnt & MS_RDN) {
					if(drag) {
						drag=bcpy=FALSE;
					} else {
						drawmtool(maptool,OFF);
						maptool=TL_PUT;
					}
				} else if(ms.evnt & MS_LUP) {
					if(drag && !bcpy) {
						map_store();
						bcpy=TRUE;
					}
				} else if(!(ms.btn & MS_LON)) {
					if(!bcpy) {
						drag=FALSE;
					}
				}
				if(drag) {
					b=p;
					if(!bcpy) {
						if(b.x < b0.x) b.x=b0.x;
						if(b.y < b0.y) b.y=b0.y;
					} else {
						adjbox(view.sx,view.sy);
					}
					dragbox(&r_map);
				}
			}
		}
	} else {
	 	if(map_sel != INVALID) {
			p.x=p.y=INVALID;
			dragrect(&p,&p0,&r_msel);
	 	}
	 	in_bar=do_sbar(&sb_maph);
	 	if(!in_bar) in_bar=do_sbar(&sb_mapv);
	 	if(in_bar) {
			if(in_bar > 0) {
				view.x=sb_maph.val;
				view.y=sb_mapv.val;
				drawmbox();
				map_sel=0;
				if(drag) {
					if(bcpy) dragbox(&r_map);
					else drag=FALSE;
				}
			}
			done=TRUE;
		} else if(inrect(ms.x,ms.y,&r_msiz)) {
			if(ms.evnt & MS_DN) {
				if(drag) {
					dragbox(&r_map);
					drag=bcpy=FALSE;
				}
				if(viewsize()) {
					clearleft();
					drawmap();
				}
			}
			done=TRUE;
		} else {
			done=do_mtool(done);
		}
	}
	if(sel != map_sel) {
		map_sel=sel;
		drawmapttl(FALSE);
	}
	return(done);
}

/*** view size ***/

static flag viewsize()
{
	POINT p,p0;
	RECT  r;

	newpen;
	p0.x=p0.y=0;
	r=r_map;
	pn.col=7;
	pn.op=GR_NOT;
	framerect(&r);
	repeat {
		if(getmouse(&ms)) {
			p.x=ms.x-r_map.x;
			p.y=ms.y-r_map.y;
			if(p.x < VIEW_MIN) p.x=VIEW_MIN;
			if(p.y < VIEW_MIN) p.y=VIEW_MIN;
			if(p.x > VIEW_MAX) p.x=VIEW_MAX;
			if(p.y > VIEW_MAX) p.y=VIEW_MAX;
			p.x/=psiz_x;
			p.y/=psiz_y;
			if(p.x != p0.x || p.y != p0.y) {
				framerect(&r);
				r.sx=p.x*psiz_x;
				r.sy=p.y*psiz_y;
				framerect(&r);
				p0=p;
			}
		}
	} until(!ms.btn);
	framerect(&r);
	view.sx=p.x;
	view.sy=p.y;
	oldpen;
	return(r.sx != r_map.sx || r.sy != r_map.sy);
}

/*** Draw map tools ***/

static drawmtools()
{
	int  i;
	RECT r;
		
	r.x=MTOL_X;
	r.y=MTOL_Y;
	r.sx=r.sy=16;
	for_to(i,MTOOLS) {
		drawmtool(i+1,i+1 == maptool);
		shaderect(&r,1);
		r.x+=MTOL_DX;
	}
}

static drawmtool(tool,on)
int  tool;
flag on;
{
	tool-=TL_FILL;
	pt_icon.col0=on ? 0 : 7;
	pt_icon.col1=on ? 7 : 0;
	putpatt(MTOL_X+tool*MTOL_DX,MTOL_Y,&pt_icon,tool+2);
}

/*** Do map tools ***/

static flag do_mtool(done)
flag done;
{
	int  x,y;	
	enum _maptool tool;
	
	x=ms.x-MTOL_X;
	y=ms.y-MTOL_Y;
	if(!done && inarea(x,y,MTOOLS*MTOL_DX,16)) {
		done=TRUE;
		tool=x/MTOL_DX+1;
		if((ms.evnt & MS_DN) && (x%MTOL_DX < 16)) {
			if(drag) {
				dragbox(&r_map);
				drag=bcpy=FALSE;
			}
			if(maptool) {
				if(tool != maptool) {
					drawmtool(maptool,OFF);
					maptool=tool;
				}
				else maptool=TL_PUT;
			}
			else maptool=tool;
			drawmtool(tool,maptool);
		}
	}
	return(done);
}

/*** Dragging box ***/

dragbox(r)
RECT *r;
{
	newpen;
	pn.col=7;
	pn.op=GR_NOT;
	pn.tile=PN_SOLID;
	frame(b0.x*psiz_x+r->x,b0.y*psiz_y+r->y
		,(b.x-b0.x+1)*psiz_x,(b.y-b0.y+1)*psiz_y
	);
	oldpen;
}	

/*** Store map ***/

static map_store()
{
	cb.x=b0.x;
	cb.y=b0.y;
	cb.sx=b.x-b0.x+1;
	cb.sy=b.y-b0.y+1;
	flushframe(cb.x*psiz_x+r_map.x,cb.y*psiz_y+r_map.y
		,cb.sx*psiz_x,cb.sy*psiz_y
	);
	cb.x+=view.x;
	cb.y+=view.y;
}

/*** Fill map ***/

static map_fill()
{
	int  x,y;
	MAP  far *mp,far *mp0;

	mp0=maptop+((b0.y+view.y)*map_sx+b0.x+view.x);
	for_to(y,cb.sy) {
		mp=mp0;
		for_to(x,cb.sx) {
			*mp=pat_get;
			pix0.x=r_map.x;
			pix0.y=r_map.y;
			drawselpat(x+b0.x,y+b0.y,pat_get,0);
			mp++;
		}
		mp0+=map_sx;
	}
}

/*** Copy map ***/

static map_copy()
{
	flag dx,dy;
	int  x,y;
	int  dif;
	MAP  far *mp,far *mp0;

	x=b0.x+view.x;
	y=b0.y+view.y;
	dx=x > cb.x;
	dy=y > cb.y;
	dif=(y-cb.y)*map_sx+(x-cb.x);
	mp0=maptop+((cb.y+(dy?cb.sy-1:0))*map_sx+cb.x+(dx?cb.sx-1:0));
	for_to(y,cb.sy) {
		mp=mp0;
		for_to(x,cb.sx) {
			*(mp+dif)=*mp;
			pix0.x=r_map.x;
			pix0.y=r_map.y;
			drawselpat(dx ? b0.x+cb.sx-x-1 : x+b0.x
				,dy ? b0.y+cb.sy-y-1 : y+b0.y,*mp,0
			);
			if(dx) mp--; else mp++;
		}
		if(dy) mp0-=map_sx; else mp0+=map_sx;
	}
	cb.x=view.x+b0.x;
	cb.y=view.y+b0.y;
}

/*** Expand map ***/

expandmap(rh,map_sx0,map_sy0)
H_MAP *rh;
int  map_sx0;
int  map_sy0;
{
	int  i;
	int  map_sx;
	MAP  far *p,far *p0;

	map_sx=rh->map_sx;
	p=p0=(MAP far *)(rh->h.farp);
	if(map_sx0 < map_sx) {
		p+=map_sy0*map_sx;
		p0+=map_sy0*map_sx0;
		for_to(i,map_sy0) {
			p-=map_sx;
			p0-=map_sx0;
			farmemcpy(p,p0,map_sx0*sizeof(MAP));
			farmemset(p+map_sx0,0,(map_sx-map_sx0)*sizeof(MAP));
		}
	} else if(map_sx0 > map_sx) {
		for_to(i,map_sy0) {
			farmemcpy(p,p0,map_sx0*sizeof(MAP));
			p+=map_sx;
			p0+=map_sx0;
		}
	}
}
