/****************************
		'pmenu.c'
****************************/

#include <std.h>
#include <graf.h>
#include <graftool.h>
#include <mouse.h>
#include <resource.h>
#include "pet.h"

#define MENUS	6
#define RATCNT	4

enum _mb_pet {
	MN_FILE,
	MN_EDIT,
	MN_RSC,
	MN_FORM,
	MN_LPT,
	MN_SYS,
};

enum _mn_file {
	MN_LOAD,
	MN_SAVE,
	MN_OPEN,
	MN_CLOSE,
	MN_LOADIMG,
	MN_SAVEIMG,
	MN_QUIT=7,
	MN_FILES,
};

enum _mn_edit {
	MN_DRAW,
	MN_MAP,
	MN_ACTION,
	MN_3D,
	MN_IMAGE,
	MN_EDITS,
};

enum _mn_rsc {
	MN_SELECT,
	MN_CLEAR,
	MN_REFORM,
	MN_RSCS,
};

enum _mn_form {
	MN_BYPIX,
	MN_BYBLK,
	MN_TYPE=3,
	MN_SIZE,
	MN_FORMS,
};

enum _mn_lpt {
	MN_LPTCVT,
	MN_LPTOUT,
	MN_LPTS,
};

enum _mn_sys {
	MN_PALET,
	MN_COLOR,
	MN_PACK,
	MN_INFO,
	MN_ME,
	MN_SYSS,
};

MENU mn_pet[]={
	"File"	,  MN_FILES,0,0,104,16,0,0,0,0,
	"Edit"	,  MN_EDITS,0,0, 80,16,0,0,0,0,
	"Resource",MN_RSCS, 0,0, 80,16,0,0,0,0,
	"Format",  MN_FORMS,0,0, 96,16,0,0,0,0,
	"Print",   MN_LPTS, 0,0, 96,16,0,0,0,0,
	"System",  MN_SYSS, 0,0,128,16,0,0,0,0,
};
static ITEM it_file[]={
	"Load",0,
	"Save",0,
	"Open more",0,
	"Close",0,
	"Load Image",0,
	"Save Image",0,
	NIL,0,
	"Quit",0
};
static ITEM it_edit[]={
	"Draw",0,
	"Map",0,
	"Action",0,
	"3D",0,
	"Image",0,
};
static ITEM it_rsc[]={
	"Select",0,
	"Clear",0,
	"Reform",0,
};
static ITEM it_form[]={
	"by Pixcel",0,
	"by Block",0,
	NIL,0,
	"Type",0,
	"Size",0,
};
static ITEM it_lpt[]={
	"Convert",0,
	"Print out",0,
};
static ITEM it_sys[]={
	"Palet",0,
	"Env-color",0,
	"Save mode",0,
	"System info.",0,
	"About me",0,
};

char *file_ext[]={ "*.PAT","*.BG?","*.CH?","*.MP?","" };
MBAR mb_pet={ "PET Graphic Editor",MENUS,0,0,640,16 };

static DLOG dg_rtype={ "Resource type ...\n",0,15*8,2,Q_OK,Q_ESC };
static BTNS bt_rtype={ CT_RBTN,0,0,0,NIL,0,2,VT };
static BTN  rb_rtype[]={
	{ " Pattern",0,1,0 },
	{ " Map",0,1,0 },
};
static DLOG dg_ptype={ "Pattern type ...\n",32*8,22*8,2,Q_OK,Q_ESC };
static BTNS bt_ptype={ CT_RBTN,0,0,0,NIL,0,4,VT };
static BTN  rb_ptype[]={
	{ "PAT :standard",0,1,0 },
	{ "FNT :+ width table",0,1,0 },
	{ "BLK :+ block table",0,1,0 },
	{ "SPR :variable size",0,1,0 },
};
static BTNS bt_pattr={ CT_RBTN,0,0,0,NIL,0,4,HZ };
static BTN  rb_pattr[]={
	{ "BASE ",0,0,0 },
	{ "CHAR ",0,0,0 },
	{ "3D ",0,0,0 },
	{ "ATTR",0,0,0 },
};
static DLOG dg_pform={ "Pattern format ...\n",47*8,25*8,2,Q_OK,Q_ESC };
static BTNS bt_plane={ CT_RBTN,0,0,0,"Plane:  ",0,4,HZ };
static BTN  rb_plane[]={
	{ "B/W ",0,1,0 },
	{ "B/W(m) ",0,1,0 },
	{ "RGB ",0,1,0 },
	{ "RGB(m) ",0,1,0 },
};
static BTNS bt_vsize={ CT_RBTN,0,0,6*8,"V-size: ",0,2,HZ };
static BTN  rb_vsize[]={
	{ "200line ",0,1,0 },
	{ "400line",0,1,0 },
};	
static BTNS bt_pix_x={ CT_RBTN,0,0,9*8,"Pixcel width: ",0,2,HZ };
static BTN  rb_pix_x[]={
	{ "8dots",0,1,0 },
	{ "16dots ",0,1,0 },
};	
static SBAR sb_pix_y={ CT_SBAR,0,0,12*8,"Pixcel height: ",0,HZ,48,16,32,0,0,8,0,2};
static SBAR sb_blk_x={ CT_SBAR,0,   0,15*8,"Block size x: ",0,HZ,48,16,16,0,0,2,0,2};
static SBAR sb_blk_y={ CT_SBAR,0,27*8,15*8,"y: ",0,HZ,48,16,16,0,0,2,0,2};
static DLOG dg_pcnt={ "Pattern count ...\n",32*8,16*8,2,Q_OK,Q_ESC };
static SBAR sb_pixcnt={ CT_SBAR,0,0,0,"Pixcel: ",0,HZ,80,16,64,0,0,4,0,4};
static SBAR sb_blkcnt={ CT_SBAR,0,0,0,"Block : ",0,HZ,80,16,64,0,0,4,0,4};
static DLOG dg_msiz={ "Map size ...\n",32*8,16*8,2,Q_OK,Q_ESC };
static SBAR sb_msiz_x={ CT_SBAR,0,0,0,"x size: ",0,HZ,80,16,64,0,0,4,0,4};
static SBAR sb_msiz_y={ CT_SBAR,0,0,0,"y size: ",0,HZ,80,16,64,0,0,4,0,4};
static DLOG dg_mode={ "Save mode ...\n",32*8,16*6,2,Q_OK,Q_ESC };
static BTNS bt_mode={ CT_RBTN,0,0,0,NIL,0,2,HZ };
static BTN  rb_mode[]={
	{ "Pack",0,1,0 },
	{ "Unpack",0,1,0 },
};	
static DLOG dg_info={ "Free memory size ...\n",25*8,15*8,1,Q_OK };
static TEXT tx_sys1={ CT_TEXT,0,0,0,"  near: %6ubytes\n" };
static TEXT tx_sys2={ CT_TEXT,0,0,0,"  far : %6lubytes\n" };
static DLOG dg_me={ "Graphic Editor ods Version 0.10\n\n",40*8,15*8,1,Q_OK};
static TEXT tx_me={ CT_TEXT,0,0,0,"   Copyright (C) 1988 by C.MOS" };
static DLOG dg_save={ "Save \"%s\" ?",0,0,3,Q_YES,Q_NO,Q_ESC };
static DLOG dg_color={ "Environment Color ...\n",28*8,23*8,2,Q_OK,Q_ESC };
static USER cb_ptcol0={ CT_USER,0,0,0,"mono 0: " };
static USER cb_ptcol1={ CT_USER,0,0,0,"mono 1: " };
static USER cb_bgcol= { CT_USER,0,0,0,"ground: " };
static USER cb_bscol= { CT_USER,0,0,0,"base  : " };
static DLOG dg_palet={ "Color Palet ...\n",29*8,33*8,2,Q_OK,Q_ESC };
static USER cb_palet[8]={
	{ CT_USER,0,0,0,"palet 0: ",0,0,0,0,0 },
	{ CT_USER,0,0,0,"palet 1: ",0,0,0,0,1 },
	{ CT_USER,0,0,0,"palet 2: ",0,0,0,0,2 },
	{ CT_USER,0,0,0,"palet 3: ",0,0,0,0,3 },
	{ CT_USER,0,0,0,"palet 4: ",0,0,0,0,4 },
	{ CT_USER,0,0,0,"palet 5: ",0,0,0,0,5 },
	{ CT_USER,0,0,0,"palet 6: ",0,0,0,0,6 },
	{ CT_USER,0,0,0,"palet 7: ",0,0,0,0,7 },	/* UUMU... TENUKIDA... */
};

static char mg_xcls[]="Cannot CLOSE active resource !";
static char mg_clr[]="Data exist. Clear it ?";
static char mg_svall[]="Save touched resource ?";
static char mg_quit[]="Quit from editor ?";
char mg_sure[]="Are you sure ?";

char *selectfile();
char *selectnext();
HEAD *selectrsc();
HEAD *creatpat();
HEAD *creatmap();
HEAD *formatrsc();
HEAD *activersc();

static flag pack=TRUE;
extern H_PAT *rh_pat;
extern H_MAP *rh_map;
extern R_PAT rq_pat0;
extern R_MAP rq_map0;
extern HEAD *rsctop;
extern int  bypix;
extern PEN  pn_base;

/*** Do menu file ***/

static do_mnfile(item)
enum _mn_file item;
{
	switch(item) {
	case MN_LOAD:
		do_open(TRUE);
		break;
	case MN_SAVE:
		do_save();
		break;
	case MN_OPEN:
		do_open(FALSE);
		break;
	case MN_CLOSE:
		do_close();
		break;
	case MN_LOADIMG:
		loadimage();
		break;
	case MN_SAVEIMG:
		saveimage();
		break;
	case MN_QUIT:
		do_quit();
		break;
	}
	initmenu();
}

/*** Do menu edit ***/

static do_mnedit(item)
enum _editmode item;
{
	if(item != editmode) {
		exgmode(item);
		drawrsc(TRUE,FALSE);
	}
	initmenu();
}

/*** Do menu resource ***/

static do_mnrsc(item)
enum _mn_rsc item;
{
	switch(item) {
	case MN_SELECT:
		do_selrsc();
		break;
	case MN_CLEAR:
		do_clear();
		break;
	case MN_REFORM:
		do_reform();
		break;
	}
	initmenu();
}

/*** Do menu format ***/

static do_mnform(item)
enum _mn_form item;
{
	switch(item) {
	case MN_BYPIX:
	case MN_BYBLK:
		if(bypix=(item == MN_BYPIX)) {
			if(rh_pat->h.type == RSC_BLK) usepix();
		}
		initall();
		drawrsc(TRUE,TRUE);
		break;
	case MN_TYPE:
		do_type();
		break;
	case MN_SIZE:
		do_size();
		break;
	}
}

/*** Do menu lpt ***/

static do_mnlpt(item)
enum _mn_lpt item;
{
	printmap(item);
}

/*** Do menu system ***/

static do_mnsys(item)
enum _mn_sys item;
{
	switch(item) {
	case MN_PALET:
		do_palet();
		break;
	case MN_COLOR:
		do_color();
		break;
	case MN_PACK:
		do_pack();
		break;
	case MN_INFO:
		do_info();
		break;
	case MN_ME:
		do_me();
		break;
	}
	initmenu();
}

/*** Init Menus ***/

initmenu()
{
	HEAD *rh;

	mb_pet.menu=mn_pet;
	mn_pet[MN_FILE].item=it_file;
	mn_pet[MN_EDIT].item=it_edit;
	mn_pet[MN_RSC ].item=it_rsc;
	mn_pet[MN_FORM].item=it_form;
	mn_pet[MN_LPT ].item=it_lpt;
	mn_pet[MN_SYS ].item=it_sys;
	mn_pet[MN_FILE].func=do_mnfile;
	mn_pet[MN_EDIT].func=do_mnedit;
	mn_pet[MN_RSC ].func=do_mnrsc;
	mn_pet[MN_FORM].func=do_mnform;
	mn_pet[MN_LPT ].func=do_mnlpt;
	mn_pet[MN_SYS ].func=do_mnsys;
	markitem(it_edit,MN_EDITS,editmode);
	nullitem(&it_edit[MN_MAP],1,!(rh_map && rh_pat->h.attr&RAT_BG));
	nullitem(&it_edit[MN_ACTION],3,TRUE);
	nullitem(it_form,MN_FORMS,FALSE);
	rh=activersc();
	nullitem(&it_rsc[MN_CLEAR],2,rh ? rh->status&RST_SYS : FALSE);
	if(rh_pat->blk_sx < 1 && rh_pat->blk_sy < 1) {
		nullitem(&it_form[MN_BYBLK],1,TRUE);
	} else {
		if(editmode) {
			nullitem(&it_form[MN_BYPIX],2,TRUE);
		}
		markitem(it_form,2,!bypix);
	}
	nullitem(&it_form[MN_TYPE],1,editmode);
	nullitem(&it_lpt[MN_LPTCVT],1,!(rh_pat->h.type == RSC_BLK));
	nullitem(&it_lpt[MN_LPTOUT],1,!(rh_pat->h.type == RSC_PAT && rh_map));
}	

/*** Do load resource ***/

static HEAD *do_open1(name,load)
char *name;
flag load;
{
	HEAD *rh;

	rh=NIL;
	if(name && (int)name != INVALID)  {
		rh=loadrsc(name);
	} else if(!name) {
		linkctrls(&dg_rtype,&bt_rtype,0);
		bt_rtype.btnp=rb_rtype;
		setbutton(&bt_rtype,0);
		if(dialog(&dg_rtype) == Q_OK) {
			rh=formatrsc(getbutton(&bt_rtype),NIL);
		}
	}
	if(rh) {
		exgrsc(rh,load);
	}
	return(rh);
}

static do_open(load)
flag load;
{
	char *name;
	HEAD *rh;
	
	name=selectfile(load ? "LOAD " : "OPEN",file_ext);
	rh=do_open1(name,load);
	if(rh && name && (int)name != INVALID) {
		while(name=selectnext()) {
			rh=do_open1(name,load);
			if(!rh) break;
		}
	}
}

/*** Do save resource ***/

static do_save()
{
	HEAD *rh;

	rh=selectrsc("SAVE ");
	if(!rh) saveall();
	else if((int)rh != INVALID) {
		if(setname("Save",rh->name)) {
			saversc(rh,pack);
		}
	}
}

static saveall()
{
	flag save;
	HEAD *rh;

	rh=rsctop;
	save=FALSE;
	while(rh) {
		if(rh->status & RST_MDF) {
			save=drawask(mg_svall);
			break;
		}
		rh=rh->link;
	}
	if(save) {
		rh=rsctop;
		while(rh) {
			if(rh->status & RST_MDF) {
				saversc(rh,pack);
			}
			rh=rh->link;
		}
	}
}

static flag closesave(rh)
HEAD *rh;
{
	int  ret;

	if(rh->status & RST_SYS) return(FALSE);
	if(rh->status & RST_MDF) {
		dg_save.par1=(int)rh->name;
		ret=dialog(&dg_save);
		if(ret == Q_YES) saversc(rh,pack);
		else if(ret == Q_ESC) return(FALSE);
	}
	closersc(rh);
	return(TRUE);
}

/*** Do close resorce ***/

static do_close()
{
	HEAD *rh;

	rh=selectrsc("CLOSE");
	if(rh && (int)rh != INVALID) {
		if(rh->status & RST_EDT+RST_SYS) {
			drawerr(mg_xcls);
		} else {
			if(closesave(rh)) {
				if(rh == (HEAD*)rh_map) rh_map=NIL;
			}
		}
	}
}

/*** Do quit ***/

static do_quit()
{
	saveall();
	if(drawask(mg_quit)) quit=TRUE;	
}

/*** Do select resource ***/

static do_selrsc()
{
	HEAD *rh;

	rh=selectrsc("EDIT ");
	if(rh && (int)rh != INVALID) {
		exgrsc(rh,FALSE);
	}
}

/*** Do clear resource ***/

static do_clear()
{
	HEAD *rh;

	if(drawask(mg_sure)) {
		if(rh=activersc()) {
			clearrsc(rh);
			initrsc(rh,FALSE);
		}
	}
}

/*** Do reform resource ***/

static do_reform()
{
	HEAD *rh;
	HEAD *rh1;
	flag clr;
	flag new;

	clr=new=FALSE;
	if(rh=activersc()) {
		if(!(rh->status & RST_NEW)) {
			if(drawask(mg_clr)) {
				clearrsc(rh);
				clr=TRUE;
			} else return;
		}
		if(rh1=formatrsc(editmode,rh)) {
			if(rh == (HEAD*)rh_pat) rh_pat=(H_PAT*)rh1;
			else if(rh == (HEAD*)rh_map) rh_map=(H_MAP*)rh1;
			clr=new=TRUE;
			rh=rh1;
		}
		if(clr) initrsc(rh,new);
	}
}

/*** Do pattern type ***/

static do_type()
{
	if(typeofpat(&rq_pat0)) {
		rh_pat->h.type=rq_pat0.type;
		rh_pat->h.attr=rq_pat0.attr;
		rh_pat->h.status|=RST_MDF;
	}
}

/*** Do change size ***/

static do_size()
{
	int  cnt0,cnt;
	int  map_sx0;
	int  map_sy0;
	HEAD *rh;

	switch(editmode) {
	case ED_DRAW:
		memcpy(&rq_pat0.pix_cnt,&rh_pat->pix_cnt,sizeof(R_PAT)-2);
		rq_pat0.type=rh_pat->h.type;
		rq_pat0.attr=rh_pat->h.attr;
		cnt0=rq_pat0.pix_cnt;
		if(cntofpat(&rq_pat0)) {
			rh=creatpat(&rq_pat0,rh_pat->h.name,rh_pat);
			if(rh) {
				rh_pat=(H_PAT*)rh;
				rh_pat->h.status|=RST_MDF;
			}
			if(rh->type == RSC_BLK) {
				cnt=rh_pat->pix_cnt;
				if(cnt0 <= 256 && cnt > 256) expandblk(rh,TRUE);
				else if(cnt0 > 256 && cnt <= 256) expandblk(rh_pat,FALSE);
			}
		}
		break;
	case ED_MAP:
		rq_map0.type=rh_map->h.type;
		rq_map0.attr=rh_map->h.attr;
		rq_map0.map_sx=map_sx0=rh_map->map_sx;
		rq_map0.map_sy=map_sy0=rh_map->map_sy;
		if(formatmap(&rq_map0)) {
			rh=creatmap(&rq_map0,rh_map->h.name,rh_map);
			if(rh) {
				rh_map=(H_MAP*)rh;
				rh_map->h.status|=RST_MDF;
			}
			if(map_sx0 != rh_map->map_sx) expandmap(rh_map,map_sx0,map_sy0);
		}
		break;
	}
	if(rh) initrsc(rh,FALSE);
}

/*** expand block table ***/

expandblk(rh,expand)
H_PAT *rh;
flag  expand;
{
	int  i;
	int  cnt;
	byte *bp;
	word *wp;

	bp=(byte*)rh+HEADSZ;
	wp=(word*)bp;
	cnt=rh->blk_cnt*rh->blk_sx*rh->blk_sy;
	if(expand) {
		bp+=cnt;
		wp+=cnt;
		for_to(i,cnt) {
			*--wp=*--bp;
		}
	} else {
		for_to(i,cnt) {
			*bp++=*wp++;
		}
	}
}

/*** Change mode ***/

static exgmode(mode)
{
	editmode=mode;
	switch(mode) {
	case ED_DRAW:
		if(rh_map) rh_map->h.status&=~RST_EDT;
		rh_pat->h.status|=RST_EDT;
		break;
	case ED_MAP:
		rh_map->h.status|=RST_EDT;
		break;
	}
}

/*** Init resource ***/

static initrsc(rh,new)
HEAD *rh;
flag new;
{
	initall();
	if(rh == (HEAD*)rh_pat) {
		drawrsc(editmode == ED_DRAW && new,TRUE);
	} else if(rh == (HEAD*)rh_map) {
		drawrsc(editmode == ED_MAP,FALSE);
	}
}

/*** Exchange edit resource ***/

exgrsc(rh,close)
HEAD *rh;
flag close;
{
	switch(rh->type) {
	case RSC_PAT:
	case RSC_FNT:
	case RSC_BLK:
	case RSC_SPR:
		rh_pat->h.status&=~RST_EDT;
		if(close) closesave(rh_pat);
		rh_pat=(H_PAT*)rh;
		exgmode(ED_DRAW);
		break;
	case RSC_MAP:
		rh_map->h.status&=~RST_EDT;
		if(close) closesave(rh_map);
		rh_map=(H_MAP*)rh;
		exgmode(ED_MAP);
		break;
	}
	initrsc(rh,TRUE);
}

/*** Active resource ***/

static HEAD *activersc()
{
	HEAD *rh;

	rh=NIL;
	switch(editmode) {
	case ED_DRAW:
		rh=(HEAD*)rh_pat;
		break;
	case ED_MAP:
		rh=(HEAD*)rh_map;
		break;
	}
	return(rh);
}

/*** Format resource ***/

static HEAD *formatrsc(type,oldrh)
enum _editmode type;
HEAD *oldrh;
{
	HEAD *rh;

	rh=NIL;
	switch(type) {
	case ED_DRAW:
		if(typeofpat(&rq_pat0)) {
			if(formatpat(&rq_pat0)) {
				if(cntofpat(&rq_pat0)) {
					rh=creatpat(&rq_pat0,rh_pat->h.name,oldrh);
				}
			}
		}
		break;
	case ED_MAP:
		if(formatmap(&rq_map0)) {
			rh=creatmap(&rq_map0,rh_map->h.name,oldrh);
		}
		break;
	}
	return(rh);
}

/*** Set pattern type ***/

static flag typeofpat(rq)
R_PAT *rq;
{
	int  i;
	flag ok;

	linkctrls(&dg_ptype,&bt_ptype,&bt_pattr,0);
	bt_ptype.btnp=rb_ptype;
	bt_pattr.btnp=rb_pattr;
	setbutton(&bt_ptype,rh_pat->h.type&3);
	setbutton(&bt_pattr,INVALID);
	rb_ptype[PT_FNT].mode|=MD_NULL;
	rb_ptype[PT_SPR].mode|=MD_NULL;
	for_to(i,RATCNT) {
		if(rh_pat->h.attr & bit(i)) rb_pattr[i].mode|=MD_ON;
	}
	ok=FALSE;
	if(dialog(&dg_ptype) == Q_OK) {
		ok=TRUE;
		rq->type=RSC_PAT+getbutton(&bt_ptype);
		rq->attr=0;
		for_to(i,RATCNT) {
			if(rb_pattr[i].mode & MD_ON) rq->attr|=bit(i);
		}
	}
	return(ok);
}

/*** Format pattern ***/

static int plus_1(var)
int  var;
{
	return(var+1);
}

static flag formatpat(rq)
R_PAT *rq;
{
	flag ok;

	linkctrls(&dg_pform,&bt_plane,&bt_vsize,&bt_pix_x,&sb_pix_y,&sb_blk_x,&sb_blk_y,0);
	bt_plane.btnp=rb_plane;
	bt_vsize.btnp=rb_vsize;
	bt_pix_x.btnp=rb_pix_x;
	setbutton(&bt_plane,rh_pat->plane-1);
	setbutton(&bt_vsize,1-rh_pat->vsize);
	setbutton(&bt_pix_x,rh_pat->pix_sx/8-1);
	sb_pix_y.func=sb_blk_x.func=sb_blk_y.func=plus_1;
	sb_pix_y.val=rh_pat->pix_sy-1;
	sb_blk_x.val=rh_pat->blk_sx-1;
	sb_blk_y.val=rh_pat->blk_sy-1;
	ok=FALSE;
	if(dialog(&dg_pform) == Q_OK) {
		ok=TRUE;
		rq->plane=getbutton(&bt_plane)+1;
		rq->vsize=1-getbutton(&bt_vsize);
		rq->pix_sx=(getbutton(&bt_pix_x)+1)*8;
		rq->pix_sy=sb_pix_y.val+1;
		rq->blk_sx=sb_blk_x.val+1;
		rq->blk_sy=sb_blk_y.val+1;
	}
	return(ok);
}

/*** Set picxel/block count ***/

static int  mul_16(var)
{
	return((var+1)*16);
}

static flag cntofpat(rq)
R_PAT* rq;
{
	flag ok;

	linkctrls(&dg_pcnt,&sb_pixcnt,&sb_blkcnt,0);
	sb_pixcnt.func=sb_blkcnt.func=mul_16;
	sb_pixcnt.val=rh_pat->pix_cnt/16-1;
	if(rq->type == RSC_BLK) {
		sb_blkcnt.val=rh_pat->blk_cnt/16-1;
		sb_blkcnt.mode&=~MD_NULL;
	} else {
		sb_blkcnt.mode|=MD_NULL;
	}
	ok=FALSE;
	if(dialog(&dg_pcnt) == Q_OK) {
		ok=TRUE;
		rq->pix_cnt=(sb_pixcnt.val+1)*16;
		if(rq->type == RSC_BLK) {
			rq->blk_cnt=(sb_blkcnt.val+1)*16;
		} else {
			rq->blk_cnt=0;
		}
	}
	return(ok);
}

/*** Format map ***/

static flag formatmap(rq)
R_MAP *rq;
{
	flag ok;

	linkctrls(&dg_msiz,&sb_msiz_x,&sb_msiz_y,0);
	sb_msiz_x.func=sb_msiz_y.func=mul_16;
	sb_msiz_x.val=rq->map_sx/16-1;
	sb_msiz_y.val=rq->map_sy/16-1;
	ok=FALSE;
	if(dialog(&dg_msiz) == Q_OK) {
		ok=TRUE;
		rq->map_sx=(sb_msiz_x.val+1)*16;
		rq->map_sy=(sb_msiz_y.val+1)*16;
	}
	return(ok);
}

/*** System ***/

static do_color()
{
	int  drawcolbtn();
	int  do_colbtn();

	cb_ptcol0.draw=cb_ptcol1.draw=cb_bgcol.draw=cb_bscol.draw=drawcolbtn;
	cb_ptcol0.do_=cb_ptcol1.do_=cb_bgcol.do_=cb_bscol.do_=do_colbtn;
	linkctrls(&dg_color,&cb_ptcol0,&cb_ptcol1,&cb_bgcol,&cb_bscol,0);
	cb_ptcol0.par=ptcol0;
	cb_ptcol1.par=ptcol1;
	cb_bgcol.par =pn_bg.col;
	cb_bscol.par =pn_base.col;
	if(dialog(&dg_color) == Q_OK) {
		ptcol0=cb_ptcol0.par;
		ptcol1=cb_ptcol1.par;
		pn_bg.col=cb_bgcol.par;
		pn_base.col=cb_bscol.par;
		drawall();
	}
}

static do_info()
{
	ulong farcoreleft();
	ulong farleft;

	linkctrls(&dg_info,&tx_sys1,&tx_sys2,0);
	tx_sys1.par1=coreleft();
	farleft=farcoreleft();
	tx_sys2.par1=FP_OFF(farleft);
	tx_sys2.par2=FP_SEG(farleft);
	dialog(&dg_info);
}

static do_me()
{
	linkctrls(&dg_me,&tx_me,0);
	dialog(&dg_me);
}

static do_palet()
{
	int  i;
	int  drawcolbtn();
	int  do_palbtn();

	for_to(i,8) {
		cb_palet[i].draw=drawcolbtn;
		cb_palet[i].do_=do_palbtn;
	}
	linkctrls(&dg_palet,&cb_palet[0],&cb_palet[1],&cb_palet[2],&cb_palet[3],&cb_palet[4],&cb_palet[5],&cb_palet[6],&cb_palet[7],0);
	dialog(&dg_palet);
}

do_palbtn(up)
USER *up;
{
	int  i;
	int  sel;
	USER *cbp;
	int  do_colbtn();

	if((sel=do_colbtn(up)) > 0) {
		cbp=cb_palet;
		for_to(i,8) {
			if(cbp == up) break;
			cbp++;
		}
		dpalet(i,sel-1);
	}
}

do_pack()
{
	linkctrls(&dg_mode,&bt_mode,0);
	bt_mode.btnp=rb_mode;
	setbutton(&bt_mode,!pack);
	dialog(&dg_mode);
	pack=!getbutton(&bt_mode);
}
