/****************************
		'pselect.c'
****************************/

#include <std.h>
#include <graf.h>
#include <mouse.h>
#include <resource.h>
#include <mem.h>
#include "pet.h"

#define PIXCELS	256
#define BLOCKS	128
#define PATTMPSZ 256
#define PAGEACT	4

#define PSEL_X	44*8
#define PSEL_Y	11*8
#define PSEL_SX	32*8
#define PSEL_SY	32*8
#define STTL_SX	32*8
#define STTL_SY	16
#define PCNT_X	14*8
#define PRNTSPC	8
#define STOL_X	77*8
#define STOL_Y	11*8
#define STOL_DY	24
#define STOOLS	3

enum _seltool {
	TL_SEL,
	TL_IGET,
	TL_IPUT,
	TL_MASK,
};

extern H_PAT *rh_pat;
extern flag wordblk;

enum _pattype pattype;
static enum _seltool seltool;
static int  pat_sel;
static int  ps_sel;
int  pat_cnt;
int  pat_top;
int  pat_get;
int  pix_cnt;
int  pix_use;
int  psiz_x;
int  psiz_y;
int  pcnt_x;
int  pcnt_y;
static flag large;
static int  epix_cx;
static int  epix_cy;
int  blk_cx;
int  blk_cy;
byte *blktbl;
ATTR *atrtbl;
flag atrf;
byte pattmp[PATTMPSZ];
flag bypix;
int  blksiz;
PATT pt_sel;
static POINT p0;
static POINT ps0;
static flag drag;
static flag bcpy;
static int  undo;
static flag in_sttl;

static RECT r_sbox= { PSEL_X,PSEL_Y,PSEL_SX,PSEL_SY };
static RECT r_sel= { PSEL_X,PSEL_Y,0,0 };
RECT r_ssel;
static RECT r_sttl= { PSEL_X,PSEL_Y-STTL_SY-2,STTL_SX,STTL_SY };
static char *patext[4]={
	".pat",".bg2",".ch2",".pat"
};

R_PAT rq_pat0={ RSC_BLK,RAT_BG|RAT_ATR,256,16,8,3,1,128,2,2 };
static char mg_large[]="Resource too large !";

/*** Create pattern ***/

H_PAT *creatpat(req,name,oldrh)
R_PAT *req;
char  *name;
H_PAT *oldrh;
{
	word keep;
	word farkeep;
	H_PAT *rh;

	keep=req->pix_sx/8*req->pix_sy*req->plane;
	farkeep=keep*req->pix_cnt;
	if(!farkeep) farkeep=WORD_MAX;
	if(farkeep < keep) {
		drawerr(mg_large);
		return(FALSE);
	}
	switch(req->type) {
	case RSC_PAT:
		keep=0;
		break;
	case RSC_FNT:
		keep=req->width ? 0 : req->pix_cnt;
		break;
	case RSC_BLK:
		keep=req->blk_sx*req->blk_sy*req->blk_cnt;
		if(req->pix_cnt >= 256) keep*=2;
		break;
	}
	if(req->attr & RAT_ATR) {
		keep+=req->pix_cnt*sizeof(ATTR);
	}
	if(oldrh) {
		rh=(H_PAT*)allocrsc(oldrh,keep,farkeep);
	} else {
		rh=(H_PAT*)openrsc(keep,farkeep);
	}
	if(rh) {
		memcpy(&rh->pix_cnt,&req->pix_cnt,sizeof(R_PAT)-2);
		rh->h.type=req->type;
		rh->h.attr=req->attr;
		strcpy(rh->h.name,name);
		extrpl(rh->h.name,patext[rq_pat0.attr&3]);
	}
	return(rh);
}

/*** Open pattern ***/

openpat(name)
char *name;
{
	if(!(rh_pat=(H_PAT*)loadrsc(name))) {
		rh_pat=(H_PAT*)creatpat(&rq_pat0,name,NIL);
	}
	rh_pat->h.status|=RST_EDT;
}

/*** Init select window ***/

initpsel()
{
	pattype=rh_pat->h.type&3;
	pat_top=0;
	pt_sel.patp=rh_pat->h.farp;
	pt_sel.sx=rh_pat->pix_sx;
	pt_sel.sy=rh_pat->pix_sy;
	pt_sel.plane=rh_pat->plane;
	pt_sel.vsize=vsize=rh_pat->vsize;
	pt_sel.plane_siz=pt_sel.sx/8*pt_sel.sy;
	pt_sel.pix_siz=pt_sel.plane_siz*pt_sel.plane;
	pt_sel.col0=ptcol0;
	pt_sel.col1=ptcol1;
	r_ssel.sx=psiz_x=pt_sel.sx;
	r_ssel.sy=psiz_y=pt_sel.sy<<vsize;
	if(bypix) {
		blk_cx=blk_cy=1;
	} else {
		if(!(blk_cx=rh_pat->blk_sx)) blk_cx=1;
		if(!(blk_cy=rh_pat->blk_sy)) blk_cy=1;
	}
	blksiz=blk_cx*blk_cy;
	epix_cx=EDT_SX/psiz_x;
	epix_cy=EDT_SY/psiz_y;
	psiz_x*=blk_cx;
	psiz_y*=blk_cy;
	pcnt_x=PSEL_SX/psiz_x;
	pcnt_y=PSEL_SY/psiz_y;
	large=blk_cx > epix_cx || blk_cy > epix_cy;
	siz_x=min(epix_cx,blk_cx)*pt_sel.sx;
	siz_y=min(epix_cy,blk_cy)*pt_sel.sy;
	r_sel.sx=psiz_x;
	r_sel.sy=psiz_y;
	pix_cnt=rh_pat->pix_cnt;
	pat_cnt=pix_cnt/blksiz;
	blktbl=NIL;
	if(!bypix) {
		switch(pattype) {
		case PT_BLK:
			pat_cnt=rh_pat->blk_cnt;
			blktbl=(byte*)rh_pat+HEADSZ;
			break;
		}
	}
	initpixtbl();
	atrtbl=NIL;
	if(rh_pat->h.attr & RAT_ATR) {
		atrtbl=(ATTR*)(
			(byte*)rh_pat+HEADSZ
			+(rh_pat->blk_sx*rh_pat->blk_sy*rh_pat->blk_cnt<<wordblk)
		);
	}
}

/*** Draw select window ***/

drawpsel()
{
	pn.tile=PN_SOLID;
	shaderect(&r_sbox,3);
	drawselttl(TRUE);
	if(blktbl) drawpixcnt();
	drawsbox();
	p0.x=p0.y=ps0.x=ps0.y=pat_sel=pat_get=undo=INVALID;
	in_sttl=FALSE;
	drawstools();
	if(atrtbl && !blktbl) clearattr();
}

static drawsbox()
{
	int  i;
	int  x,y;

	pn=pn_bg;
	fillrect(&r_sbox);
	pix0.x=PSEL_X;
	pix0.y=PSEL_Y;
	i=pat_top;
	for_to(y,pcnt_y) {
		for_to(x,pcnt_x) {
			drawselpat(x,y,i++,FALSE);
			if(i >= pat_cnt) goto enddraw;
		}
	}
enddraw:;
}

/*** Draw sel pattern ***/

drawselpat(x,y,n,bg)
int  x,y;
int  n;
flag bg;
{
	int  x1,y1;
	byte *p;
	RECT r;

	r.x=x*psiz_x+pix0.x;
	r.y=y*psiz_y+pix0.y;
	if(bg && maskplane(pt_sel.plane)) {
		r.sx=psiz_x;
		r.sy=psiz_y;
		pn=pn_bg;
		fillrect(&r);
		pn.tile=PN_SOLID;
	}
	if(blksiz <= 1) {
		putpatt(r.x,r.y,&pt_sel,n);
	} else {
		n*=blksiz;
		p=blktbl+(n<<wordblk);
		for(y1=0; y1<psiz_y; y1+=r_ssel.sy) {
			for(x1=0; x1<psiz_x; x1+=r_ssel.sx) {
				putpatt(r.x+x1,r.y+y1,&pt_sel
					,blktbl ? (wordblk ? *((word*)p)++ : *p++) : n++
				);
			}
		}
	}
}

/*** Draw sub sel pattern ***/

drawsselpat(x0,y0,n,lp)
int  x0,y0;
int  n;
POINT *lp;
{
	int  x,y;
	byte *p;
	int  n0;
	RECT r;

	r.x=x0*psiz_x+pix0.x+lp->x*r_ssel.sx;
	r.y=y0*psiz_y+pix0.y+lp->y*r_ssel.sy;
	if(maskplane(pt_sel.plane)) {
		r.sx=siz_x;
		r.sy=siz_y<<vsize;
		pn=pn_bg;
		fillrect(&r);
		pn.tile=PN_SOLID;
	}
	n0=blksiz*n+lp->y*blk_cx+lp->x;
	for(y=0; y<siz_y<<vsize; y+=r_ssel.sy) {
		n=n0;
		p=blktbl+(n<<wordblk);
		for(x=0; x<siz_x; x+=r_ssel.sx) {
			putpatt(r.x+x,r.y+y,&pt_sel
				,blktbl ? (wordblk ? *((word*)p)++ : *p++) : n++
			);
		}
		n0+=blk_cx;
	}
}

/*** Draw title bar ***/

drawselttl(new)
flag new;
{
	if(new) {
		shaderect(&r_sttl,1);
		pn.col=7;
		fillrect(&r_sttl);
		gloc(r_sttl.x+PRNTSPC,r_sttl.y);
		pn.col=0;
		print(rh_pat->h.name);
	}
	pn.col=in_sttl ? COL7 : COL0;
	drawstring(r_sttl.x+PCNT_X,r_sttl.y,0,
		"%3d/%-3d",pat_sel == INVALID ? pat_top : pat_sel,pat_cnt
	);
}

/*** Draw pixcel count ***/

drawpixcnt()
{
	drawstring(r_sttl.x+r_sttl.sx,r_sttl.y,PRNTSPC,"%4d/%-4d",pix_use,pix_cnt);
}

/*** Do select window ***/

flag do_select(done)
flag done;
{
	done=do_sttl(done);
	done=do_sbox(done);
	done=do_stool(done);
	if(atrtbl && !blktbl && pat_get != INVALID) {
		done=do_attr(done,pat_get);
	}
	return(done);
}

static flag do_sbox(done)
flag done;
{
	int  sel;
	int  ssel;
	RECT r;
	POINT p,ps;
	
	sel=INVALID;
	p.x=pcnt_x;
	p.y=pcnt_y;
	if(!done && insquare(ms.x,ms.y,&r_sel,&p)) {
		done=TRUE;
		sel=pat_top+p.y*pcnt_x+p.x;
		if(sel < pat_cnt) {
			if(seltool == TL_SEL || seltool == TL_MASK) {
				dragrect(&p,&p0,&r_sel);
				if(editmode) {
					if(ms.evnt & MS_DN) {
						pix0.x=SBLK_X;
						pix0.y=SBLK_Y;
						drawselpat(0,0,sel,TRUE);
						pat_get=sel;
					}
				} else {
					if(seltool == TL_MASK) {
						if(atrtbl) {
							if(ms.evnt & MS_RDN) {
								r.x=PSEL_X+p.x*psiz_x;
								r.y=PSEL_Y+p.y*psiz_y;
								r.sx=r_sel.sx;
								r.sy=r_sel.sy;
								flushrect(&r);
								pat_get=sel;
							} else if(ms.evnt & MS_LDN) {
								if(pat_get != INVALID) {
									setmaskpix(pat_get,sel);
								}
							}
						}
					} else {
						if(large) {
							if(sel != pat_sel) {
								draglrect1(&ps0);
								ps_sel=ps0.x=ps0.y=INVALID;
							}
							r_ssel.x=PSEL_X+p.x*psiz_x;
							r_ssel.y=PSEL_Y+p.y*psiz_y;
							ps.x=blk_cx;
							ps.y=blk_cy;
							insquare(ms.x,ms.y,&r_ssel,&ps);
							if(ps.x > blk_cx-epix_cx)  ps.x=blk_cx-epix_cx;
							if(ps.y > blk_cy-epix_cy)  ps.y=blk_cy-epix_cy;
							draglrect(&ps,&ps0);
						} else {
							ps.x=ps.y=0;
						}
						if(ms.evnt & MS_RDN) {
							getselpat(sel,FALSE,&ps);
							drawebox();
							if(atrtbl && !blktbl) {
								pat_get=sel;
								drawattr(sel);
							}
							if(blktbl) drawpixnum(sel);
							undo=INVALID;
						} else if(ms.evnt & MS_LDN) {
							dragrect1(&p,&r_sel);
							if(large) draglrect1(&ps);
							ssel=sel*blksiz+ps.y*blk_cx+ps.x;
							if(undo == ssel) {
								putselpat(sel,TRUE,&ps);
								undo=INVALID;
							} else {
								getselpat(sel,TRUE,&ps);
								putselpat(sel,FALSE,&ps);
								undo=ssel;
							}
							pix0.x=PSEL_X;
							pix0.y=PSEL_Y;
							drawsselpat(p.x,p.y,sel,&ps);
							dragrect1(&p,&r_sel);
							if(large) draglrect1(&ps);
							rh_pat->h.status|=RST_MDF;
							rh_pat->h.status&=~RST_NEW;
						}
					}
				}
			} else {
				if(ms.evnt & MS_DN+MS_UP || sel != pat_sel) {
					if(drag) dragbox(&r_sbox);
					if(bcpy) drag=TRUE;
					if(ms.evnt & MS_LDN) {
						if(!drag && !bcpy) {
							b=b0=p;
							drag=TRUE;
						} else {
							cb.x=b0.x;
							cb.y=b0.y;
							cb.sx=b.x-b0.x+1;
							cb.sy=b.y-b0.y+1;
							img_to_pat();
							drawsbox();
							rh_pat->h.status|=RST_MDF;
							rh_pat->h.status&=~RST_NEW;
						}
					} else if(ms.evnt & MS_RDN) {
						if(!drag || seltool == TL_IGET) {
							drawstool(seltool,OFF);
							seltool=TL_SEL;
						}
						drag=bcpy=FALSE;
					} else if(ms.evnt & MS_LUP) {
						if(drag && !bcpy) {
							cb.x=b0.x;
							cb.y=b0.y;
							cb.sx=b.x-b0.x+1;
							cb.sy=b.y-b0.y+1;
							flushframe(cb.x*psiz_x+r_sbox.x,cb.y*psiz_y+r_sbox.y
								,cb.sx*psiz_x,cb.sy*psiz_y
							);
							putimgblk();
							drag=FALSE;
						}
					} else if(!(ms.btn & MS_LON)) {
						if(!bcpy) {
							drag=FALSE;
						}
					}
					if(drag) {
						b=p;
						if(!bcpy) {
							if(b.x < b0.x) b.x=b0.x;
							if(b.y < b0.y) b.y=b0.y;
						} else {
							adjbox(pcnt_x,pcnt_y);
						}
						dragbox(&r_sbox);
					}
				}
			}
			if(sel != pat_sel) {
				pat_sel=sel;
				drawselttl(FALSE);
			}
			goto skip;
		}
	}
	if(pat_sel != INVALID) {
		pat_sel=INVALID;
		p.x=p.y=INVALID;
		dragrect(&p,&p0,&r_sel);
		if(large) {
			ps_sel=ps.x=ps.y=INVALID;
			draglrect(&ps,&ps0);
		}
		drawselttl(FALSE);
		undo=INVALID;
	}
skip:
	return(done);
}

/*** Do title bar ***/

static flag do_sttl(done)
flag done;
{
	int  n;
	int  page;

	if(done || !inrect(ms.x,ms.y,&r_sttl)) {
		if(in_sttl) {
			in_sttl=FALSE;
			invertrect(&r_sttl);
		}
	} else {
		done=TRUE;
		page=pcnt_x*pcnt_y;
		if(!in_sttl) {
			in_sttl=TRUE;
			invertrect(&r_sttl);
		}
		if(ms.evnt&MS_DN) {
			if(ms.evnt&MS_LDN) {
				n=pat_top+page;
				if(n >= pat_cnt) n=0;
			} else {
				if(rh_pat->h.attr&RAT_CH) {
					n=pat_top^PAGEACT;
				} else {
					n=pat_top-page;
					if(n < 0) {
						n=0;
						while(n+page < pat_cnt) n+=page;
					}
				}
			}
			if(n != pat_top) {
				pat_top=n;
				drawsbox();
				drawselttl(FALSE);
			}
		}
	}
	return(done);
}	

/*** Draw select tool ***/

static drawstools()
{
	int  i;
	RECT r;
		
	r.x=STOL_X;
	r.y=STOL_Y;
	r.sx=r.sy=16;
	for_to(i,STOOLS) {
		drawstool(i+1,i+1 == seltool);
		shaderect(&r,1);
		r.y+=STOL_DY;
	}
}

static drawstool(tool,on)
int  tool;
flag on;
{
	tool--;
	pt_icon.col0=on ? 0 : 7;
	pt_icon.col1=on ? 7 : 0;
	putpatt(STOL_X,STOL_Y+tool*STOL_DY,&pt_icon,tool+13);
}

static flushstool(tool)
int  tool;
{
	RECT r;

	r.x=STOL_X;
	r.y=STOL_Y+(tool-1)*STOL_DY;
	r.sx=r.sy=16;
	flushrect(&r);
}

/*** Do select tools ***/

static flag do_stool(done)
flag done;
{
	int  x,y;	
	enum _maptool tool;
	
	x=ms.x-STOL_X;
	y=ms.y-STOL_Y;
	if(!done && inarea(x,y,16,STOOLS*STOL_DY)) {
		done=TRUE;
		tool=y/STOL_DY+1;
		if((ms.evnt & MS_DN) && (y%STOL_DY < 16)) {
			if(drag) {
				dragbox(&r_sbox);
				drag=bcpy=FALSE;
			}
			if(seltool) {
				if(tool != seltool) {
					drawstool(seltool,OFF);
					seltool=tool;
				}
				else seltool=TL_SEL;
			}
			else seltool=tool;
			drawstool(tool,seltool);
			if(seltool == TL_IGET) {
				flushstool(TL_IGET);
				if(getimgblk()) {
					bcpy=TRUE;
				} else {
					seltool=TL_SEL;
					drawstool(TL_IGET,OFF);
				}
			}
		}
	}
	return(done);
}

/*** Drag large rect ***/

draglrect(p,p0)
POINT *p,*p0;
{
	if(p->x != p0->x || p->y != p0->y) {
		draglrect1(p0);
		draglrect1(p);
		p0->x=p->x;
		p0->y=p->y;
	}
}

static draglrect1(p)
POINT *p;
{
	RECT r;

	if(p->x != INVALID && p->y != INVALID) {
		newpen;
		pn.col=7;
		pn.op=GR_NOT;
		r.x=r_ssel.x+p->x*r_ssel.sx+1;
		r.y=r_ssel.y+p->y*r_ssel.sy+1;
		r.sx=siz_x-2;
		r.sy=(siz_y<<vsize)-2;
		framerect(&r);
		oldpen;
	}
}

/*** Get selected pattern ***/

word far *setpatp(n)
int  n;
{
	return((word far*)(pt_sel.patp+n*pt_sel.pix_siz));
}

static getselpat(n,undo,lp)
int  n;
flag undo;
POINT *lp;
{
	int  x,y;
	int  n0;
	byte *p;

	if(!undo) {
		memcpy(px_bak,px_edt,BUFSZ);
	}
	if(blksiz <= 1) {
		getspat(0,0,n,undo);
	} else {
		n0=blksiz*n+lp->y*blk_cx+lp->x;
		for(y=0; y<siz_y; y+=pt_sel.sy) {
			n=n0;
			p=blktbl+(n<<wordblk);
			for(x=0; x<siz_x; x+=pt_sel.sx) {
				getspat(x,y
					,blktbl ? (wordblk ? *((word*)p)++ : *p++) : n++
					,undo
				);
			}
			n0+=blk_cx;
		}
	}
}

static getspat(x0,y0,n,undo)
int  x0,y0;
int  n;
flag undo;
{
	int  i;
	int  x,y;
	int  plane;
	int  col;
	word mask;
	word bit;
	word pat[3];
	byte *p,*p0;
	word far *patp;
	word far *patp1;

	if(undo) {
		p=px_tmp;
	} else {
		p=px_edt;
	}
	p0=p+y0*BUF_SX+x0;
	patp=setpatp(n);
	if(pt_sel.sx >= 16) {
		for_to(y,pt_sel.sy) {
			p=p0;
			patp1=patp;
			plane=pt_sel.plane;
			if(maskplane(plane)) {
				mask=swaphl(*patp1);
				(byte*)patp1+=pt_sel.plane_siz;
				plane--;
			} else {
				mask=0;
			}
			for_to(i,plane) {
				pat[i]=swaphl(*patp1);
				(byte*)patp1+=pt_sel.plane_siz;
			}
			bit=0x8000;
			for_to(x,16) {
				if(bit&mask) col=8;
				else {
					col=!!(pat[0]&bit);
					if(plane == 3) {
						if(pat[1]&bit) col|=2;
						if(pat[2]&bit) col|=4;
					} else {
						col=(col) ? ptcol1 : ptcol0;
					}
				}
				bit>>=1;
				*p++=col;
			}
			patp++;
			p0+=BUF_SX;
		}
	} else {
		for_to(y,pt_sel.sy) {
			p=p0;
			patp1=patp;
			plane=pt_sel.plane;
			if(maskplane(plane)) {
				mask=*(byte far*)patp1;
				(byte*)patp1+=pt_sel.plane_siz;
				plane--;
			} else {
				mask=0;
			}
			for_to(i,plane) {
				pat[i]=*(byte far*)patp1;
				(byte*)patp1+=pt_sel.plane_siz;
			}
			bit=0x80;
			for_to(x,8) {
				if(bit&mask) col=8;
				else {
					col=!!(pat[0]&bit);
					if(plane == 3) {
						if(pat[1]&bit) col|=2;
						if(pat[2]&bit) col|=4;
					} else {
						col=(col) ? ptcol1 : ptcol0;
					}
				}
				bit>>=1;
				*p++=col;
			}
			((byte *)patp)++;
			p0+=BUF_SX;
		}
	}
}

/*** Put selected pattern ***/

static putselpat(n,undo,lp)
int  n;
flag undo;
POINT *lp;
{
	int  x,y;
	int  n0;
	byte *p;

	if(blksiz <= 1) {
		putspat(0,0,setpatp(n),undo);
	} else {
		n0=blksiz*n+lp->y*blk_cx+lp->x;
		for(y=0; y<siz_y; y+=pt_sel.sy) {
			n=n0;
			p=blktbl+(n<<wordblk);
			for(x=0; x<siz_x; x+=pt_sel.sx) {
				if(blktbl) {
					putspat(x,y,(byte far*)pattmp,undo);
					if(wordblk) *((word*)p)++=insertpix(pattmp);
					else *p++=insertpix(pattmp);
				} else {
					putspat(x,y,setpatp(n++),undo);
				}
			}
			n0+=blk_cx;
		}
	}
	if(blktbl) {
		setpixtbl();
		drawpixcnt();
	}
}

static putspat(x0,y0,patp,undo)
int  x0,y0;
word far *patp;
flag undo;
{
	int  i;
	int  x,y;
	int  plane;
	int  col;
	word mask;
	word bit;
	word pat[3];
	byte *p,*p0;
	word far *patp1;

	p0=((undo) ? px_tmp : px_edt)+y0*BUF_SX+x0;
	if(pt_sel.sx >= 16) {
		for_to(y,pt_sel.sy) {
			p=p0;
			bit=0x8000;
			mask=pat[0]=pat[1]=pat[2]=0;
			plane=pt_sel.plane;
			for_to(x,16) {
				col=*p++;
				if(col == 8) {
					mask|=bit;
				} else if(plane >= 3) {
					if(col&1) pat[0]|=bit;
					if(col&2) pat[1]|=bit;
					if(col&4) pat[2]|=bit;
				} else {
					if(col != ptcol0) pat[0]|=bit;
				}
				bit>>=1;
			}
			patp1=patp;
			if(maskplane(plane)) {
				*patp1=swaphl(mask);
				(byte*)patp1+=pt_sel.plane_siz;
				plane--;
			}
			for_to(i,plane) {
				*patp1=swaphl(pat[i]);
				(byte*)patp1+=pt_sel.plane_siz;
			}
			patp++;
			p0+=BUF_SX;
		}
	} else {
		for_to(y,pt_sel.sy) {
			p=p0;
			bit=0x80;
			mask=pat[0]=pat[1]=pat[2]=0;
			plane=pt_sel.plane;
			for_to(x,8) {
				col=*p++;
				if(col == 8) {
					mask|=bit;
				} else if(plane >= 3) {
					if(col&1) pat[0]|=bit;
					if(col&2) pat[1]|=bit;
					if(col&4) pat[2]|=bit;
				} else {
					if(col != ptcol0) pat[0]|=bit;
				}
				bit>>=1;
			}
			patp1=patp;
			if(maskplane(plane)) {
				*(byte far*)patp1=mask;
				(byte*)patp1+=pt_sel.plane_siz;
				plane--;
			}
			for_to(i,plane) {
				*(byte far*)patp1=pat[i];
				(byte*)patp1+=pt_sel.plane_siz;
			}
			((byte*)patp)++;
			p0+=BUF_SX;
		}
	}
}
