/**************************
	'MET' Block Handler
**************************/

#include "std.h"
#include "graf.h"
#include "met.h"

#define IC_INS	2
#define IC_PASTE 36
#define IC_DEL	57
#define IC_DUP	58
#define IC_KEY	59

static DLOG dg_key={ "Transpose Key...\n\n",216,9*13,2,Q_OK,Q_ESC };
static SBAR sb_key={ CT_SBAR,0,0,0,"down<->up ",0,HZ,46,16,15,7,2,0,2 };

extern DLOG dg_full;

static int cv_key(val)
int  val;
{
	return(val-7);
}

/*** Do Block ***/

doblck(icn)
int  icn;
{
	word size;
	flag f;
	char *tp,*ep;
	PBLK *pbp;
	int  d;

	setinsp(&icsr,icsr.part,0,&tp,TRUE);
	if(icn != IC_PASTE) {
		setinsp(&bcsr,icsr.part,0,&ep,TRUE);
	}
	pbp=part[icsr.part].partp;
	f=FALSE;
	switch(icn) {
	case IC_DEL:
	case IC_DUP:
		size=ep-tp;
		if(maxp-freep < size) goto memfull;
		clipp=maxp-size;
		movemem(tp,clipp,size);
		if(icn == IC_DEL) {
			delpart(pbp,tp,size);
			imode=insblk=INSMODE;
			f=TRUE;
		} else {
			drawicsr(0);
			imode=insblk=INSMODE;
			drawicsr(0);
		}
		icon=IC_INS;
		break;
	case IC_PASTE:
		if(inspart(pbp,tp,clipp,maxp-clipp) == ERROR) goto memfull;
		f=TRUE;
		break;
	case IC_KEY:
		dg_key.link=(CTRL*)&sb_key;
		sb_key.func=cv_key;
		if(dialog(&dg_key) == Q_OK) {
			d=sb_key.val-7;
			if(d) {
				transkey(tp,ep,d);
				f=TRUE;
			}
		}
		break;
	}
	locbar(icsr.part,ndsp);
	if(f) {
		calcbar();
		setnall();
		if(ndsp > mb.nall) ndsp=0;
		seekbar();
		drawstf1(icsr.part);
		drawseek();
	}
	setimnu();
	return(0);
memfull:
	dialog(&dg_full);
}

/*** Transpose key ***/

transkey(tp,ep,d)
char *tp,*ep;
int  d;
{
	int  i;
	int  n;
	int  key;
	int  dat;

	n=cp.chord ? 3 : 1;
	while(tp < ep) {
		if(*tp < 0) {
			tp++;
			for_to(i,n) {
				dat=*tp;
				if(dat != RESTC) {
					key=((dat&0x38)>>3)*7+(dat&7);
					key+=d;
					if(key < 0) key=0;
					else if(key > 55) key=55;
					*tp=(dat&0xC0)|(key/7<<3)|(key%7);
				}
				tp++;
			}
		} else tp+=2;
	}	
}
