/**************************
	'MET' Control Panel
**************************/

#include "std.h"
#include "graf.h"
#include "met.h"

#define PANL_Y	17
#define PANL_SY	SCOR_Y-PANL_Y-1
#define PANLL_X	24
#define PANLL_SX 288
#define PANLR_X	332
#define PANLR_SX 268
#define PANLD_Y	39
#define PANLD_SY 19
#define PLAY_X	PANLR_X
#define PLAY_Y	19
#define PSEL_X	PLAY_X+48
#define PSEL_Y  PLAY_Y
#define PSEL_SX	248
#define VOLM_X	PANLL_X+4
#define VOLM_Y	PANLD_Y+2
#define TEMP_X	PANLL_X+136
#define TEMP_Y	PANLD_Y+2
#define SEEK_X	PANLR_X+4
#define SEEK_Y	PANLD_Y+2
#define SVAL_DX	40
#define SVAL_SX	80

static BTNS bt_play={ CT_PBTN,0,PLAY_X,PLAY_Y,0,0,1,HZ };
static BTN  pb_play={ "Play",32,0,0 };
static SBAR sb_volm={
	CT_SBAR,0,VOLM_X,VOLM_Y,"Volume",0,HZ,16+16,16,16,0,2,0,2 };
static SBAR sb_temp={
	CT_SBAR,0,TEMP_X,TEMP_Y,"Tempo",0,HZ,32+16,16,32,0,2,0,3 };
static SBAR sb_seek={ CT_SBAR,0,SEEK_X,SEEK_Y,0,0,HZ,128+16,16 };
extern BTNS bt_part;
extern BTN  pb_part[];
extern int ticks[];

static RECT r_panll={ PANLL_X,PANLD_Y,PANLL_SX,PANLD_SY };
static RECT r_panlr={ PANLR_X,PANLD_Y,PANLR_SX,PANLD_SY };

char *incbar();
char *locbar();

/*** Draw Control Panel ***/

int  cv_temp(val)
int  val;
{
	return(val-16);
}

drawpanl()
{
	mousoff();
	fillrect(0,PANL_Y,640,PANL_SY,&bak_s);
	drawmnam();
	drawplay();
	pn.col=7;
	drawrect(&r_panll,2);
	sb_volm.val=mastvolm;
	drawsbar(&sb_volm);
	sb_temp.val=masttemp+16;
	sb_temp.func=cv_temp;
	drawsbar(&sb_temp);
	drawrect(&r_panlr,2);
	drawseek();
	mouson();
}

static drawplay()
{
	bt_play.btnp=&pb_play;
	pb_play.mode=playf ? MD_ON+MD_BTN : MD_BTN;
	drawpbtn(&bt_play);
	drawpsel();
}

flag do_panl()
{
	flag f;

	f=FALSE;
	if(mb.part) {
		if((f=do_pbtn(&bt_play)) > 0) {
			playf=!!(pb_play.mode&MD_ON);
			if(playf) playin(); else playout();
		} else if(f=do_sbar(&sb_temp) > 0) {
			masttemp=sb_temp.val-16;
			setmtemp(masttemp*8);
		} else if(f=do_sbar(&sb_volm) > 0) {
			mastvolm=sb_volm.val;
			setmvolm(mastvolm);
		} else if(f=do_psel()) {
		} else if(f=do_seek()) {
		} else f=FALSE;
	}
	return(f);
}

/*** Draw Part Select ***/

drawpsel()
{
	mousoff();
	setbtns(playf ? 2 : 1);
	bt_part.px=PSEL_X;
	bt_part.py=PSEL_Y;
	fillrect(PSEL_X-2,PSEL_Y-2,PSEL_SX,20,&bak_s);
	drawpbtn(&bt_part);
	mouson();
}

static int do_psel()
{
	int  i;
	int  f;
	int  sel;
	int  sy;
	int  dspc;
	PART *pp;
	PART *dp;

	bt_part.px=PSEL_X;
	bt_part.py=PSEL_Y;
	if((f=do_pbtn(&bt_part)) > 0) {
		sel=f-1;
		if(playf) {
			mute^=1<<sel;
			playctrl(CP_MUTE,mh,mute);
		} else {
			sy=part[sel].stafsy;
			if(pb_part[sel].mode&MD_ON) {
				for(i=mb.part-1; i>=0; i--) {
					pp=&part[i];
					if(SCOR_SY-stafssy >= sy) break;
					if(pp->disp) {
						pp->disp=0;
						stafssy-=pp->stafsy;
					}
				}
				part[sel].disp=1;
				stafssy+=sy;
			} else {
				part[sel].disp=0;
				stafssy-=part[sel].stafsy;
			}
			dspc=0;
			sy=SCOR_Y;
			pp=&part[0];
			for_to(i,mb.part) {
				if(pp->disp) {
					pp->disp=++dspc;
					pp->dspbtm=FALSE;
					pp->stafy=sy;
					sy+=pp->stafsy;
					dp=pp;
				}
				pp++;
			}
			if(dp) dp->dspbtm=TRUE;
			setmstaf();
			drawpsel();
			drawseek();
			drawscor();
		}
	}
	return(f);
}

/*** Draw Seek bar ***/

drawseek()
{
	setnall();
	if(mulstaf > 1) {
		sb_seek.max=mb.nall/mb.barlin+((mb.nall%mb.barlin) ? 1 : 0);
		sb_seek.val=ndsp/mb.barlin;
	} else {
		sb_seek.max=mb.nall;
		sb_seek.val=ndsp;
	}
	sb_seek.mode=(sb_seek.max > 1) ? 0 : MD_INACT;
	drawsbar(&sb_seek);
	drawsval();
}

setnall()
{
	int  n;
	int  nmax;
	int  i;

	nmax=0;
	for_to(i,mb.part) {
		n=part[i].barc;
		if(n > nmax) nmax=n;
	}
	mb.nall=nmax;
}

/*** Draw Bar No. ***/

static drawsval()
{
	int  x,y;
	int  sy;

	mousoff();
	x=SEEK_X+sb_seek.fw+SVAL_DX;
	sy=fonthigt();
	y=SEEK_Y+(16-sy)/2;
	pn.col=7;
	fillrect(x,y,SVAL_SX,sy,NIL);
	gloc(x,y);
	pn.col=0;
	print("%d/%d",ndsp+1,mb.nall);
	mouson();
}

/*** Do Seek ***/

static int do_seek()
{
	int  ret;
	int  n;

	sb_seek.skp=(mulstaf > 1) ? mulstaf : mb.barlin;
	if(ret=do_sbar(&sb_seek) > 0) {
		n=(mulstaf > 1) ? sb_seek.val*mb.barlin : sb_seek.val;
		if(n < mb.nall) {
			ndsp=n;
			drawsval();
			seekbar();
			drawscor();
			if(playf) {
				playctrl(CP_OFF,mh);
				playin1();
			}
		}
	}
	return(ret);
}

seekbar()
{
	int  i;

	for_to(i,mb.part) locbar(i,ndsp);
}

/*** Music Play  ***/

static int pi;
static int cbar;
static int ctick;
static int cx;
static int cbx;
static int cby;

playin()
{
	int  i;

	for_to(i,mb.part) {
		if(part[i].disp) break;
	}
	if(i < mb.part) {
		pi=i;
		loadprec(pi);
	} else pi=-1;
	cbar=-1;
	ctick=0;
	movemem(&mb,musicp,sizeof(MBLK));
	playin1();
	drawplay();
}

static playin1()
{
	if(ndsp || mute) {
		mh=playmusc(musicp,1);
		if(ndsp) playctrl(CP_SEEK,mh,ndsp);
		if(mute) playctrl(CP_MUTE,mh,mute);
		playctrl(CP_ON,mh);
	}
	else mh=playmusc(musicp,0);
}

playout()
{
	playctrl(CP_OFF,mh);
	playf=FALSE;
	drawplay();
}

do_play()
{
	int  bar;
	int  tick;

	if(!playctrl(CP_STT,mh)) playout();
	else {
		bar=playctrl(CP_POS,mh,&tick)-1;
		if(bar != -1) {
			if(bar != cbar) {
				if(cbar != -1) {
					if(bar >= ndsp && bar < ndsp+mb.barlin*mulstaf) {
						if(bar == cbar+1) {
							cp.nowp=incbar(cp.nowp,1,cbar);
						} else {
							loadprec(pi);
							cp.nowp=incbar(ndsp,bar-ndsp,ndsp);
						}
					} else {
						ndsp=bar;
						seekbar();
						drawseek();
						drawscor();
					}
				}
				cbar=bar;
			}
		}
	}
}

/*** Load/Save Part record ***/

loadprec(n)
int  n;
{
	movemem(&part[n],&cp,sizeof(PART));
	setparm();
}

saveprec(n)
int  n;
{
	movemem(&cp,&part[n],sizeof(PART));
}

/*** Set Parameter ***/

setparm()
{
	setkparm();
	settparm();
}

/*** Set Key ***/

setkparm()
{
	int keymdf;

	switch(cp.clef) {
	case CLEF_G:
	case CLEF_N:
		cp.key_l=OCT_M*7+TONE_D;
		cp.key_h=(OCT_M+1)*7+TONE_G;
		break;
	case CLEF_F:
		cp.key_l=(OCT_M-2)*7+TONE_F;
		cp.key_h=(OCT_M-1)*7+TONE_B;
		break;
	case CLEF_GF:
		cp.key_l=(OCT_M-2)*7+TONE_F;
		cp.key_h=(OCT_M+1)*7+TONE_G;
		break;
	}
	keymdf=cp.clefva*7;
	cp.key_l+=keymdf;
	cp.key_h+=keymdf;
	setkref(cp.ksig);
}

/*** Set Tick ***/

static settparm()
{
	if(cp.meter) {
		cp.tbeat=ticks[cp.meter&7];
		cp.tmesr=cp.tbeat*((cp.meter>>3&0x1F)+1);
	} else {
		cp.tbeat=48;
		cp.tmesr=192;
	}
}

/*** Set Inserted parm. ***/

setiparm(d0,d1)
int  d0,d1;
{
	int  i;
	int  c;

	switch(d0) {
	case D_CLEF:
		cp.clef=d1&3;
		cp.clefva=d1>>2;
		cp.chgf|=XG_CLEF;
		break;
	case D_KSIG:
		cp.ksig0=cp.ksig;
		cp.ksig=d1;
		cp.chgf|=XG_KSIG;
		break;
	case D_TSIG:
		cp.meter=d1;
		cp.chgf|=XG_METR;
		break;
	case D_BAR:
		switch(d1) {
		case 0x08:
			cp.chgf|=XG_SEGN;
			break;
		case 0x09:
			cp.chgf|=XG_1END;
			break;
		case 0x0C:
			cp.chgf|=XG_REPT;
			break;
		}
		break;
	case D_TEMPO:
		cp.tempo=d1;
		break;
	case D_OCTA:
		cp.octa=d1;
		break;
	case D_VOICE:
		cp.voice=d1;
		break;
	case D_GS:
		cp.gate=d1;
		break;
	case D_LFO:
		cp.lfo=d1;
		break;
	case D_DYNA:
		cp.dyna=d1;
		break;
	case D_REPT:
		cp.trep=0;
		break;
	case D_REPT9:
		i=(d1>>6)&3;
		c=d1&0x3F;
		cp.repm=i+1;
		if(i == 2) c*=2;
		cp.repc=c;
		break;
	}
}

/*** Scan Inserted Parm ***/

char *scanipar(p)
char *p;
{
	cp.chgf=0;
	if(p) {
		if(!cp.repm) {
			while(*p > 0 && *p <= D_BAR) {
				setiparm(*p,*(p+1));
				p+=2;
			}
			setparm();
		}
	}
	return(p);
}

/*** Increment Bar ***/

char *incbar(p,n,nc)
char *p;
int  n;
int  nc;
{
	int  i;
	int  d0,d1;
	int  tick;
	int  tsum;

	if(p) {
		for_to(i,n) {
			if(cp.repm) {
				if(!--cp.repc) cp.repm=0;
			} else {
				tsum=setisum(nc+i);
				repeat {
					if(cp.repc > 0) {
						if(!--cp.repc) cp.repm=0;
						tsum+=cp.trep;
						continue;
					}
					d0=*p++;
					d1=*p++;
					if(!d0) {
						p-=2;
						if(n && i < n) p=NIL;
						goto end_inc;
					}
					else if(d0 < 0) {
						tick=settick(d0);
						tsum+=tick;
						cp.trep+=tick;
						if(cp.chord) p+=2;
					} else {
						setiparm(d0,d1);
						settparm();
					}
				} until (tsum >= cp.tmesr);
			}
			cp.ksig0=cp.ksig;
			if(!cp.repm && *p == D_REPT9) {
				setiparm(*p,*(p+1));
				p+=2;
			}
		}
	}
end_inc:
	return(p);
}

/*** Locate Bar ***/

char *locbar(pi,n)
int  pi;
int  n;
{
	initprec(pi,FALSE);
	loadprec(pi);
	cp.dspp=cp.nowp=(char*)incbar(cp.topp,n,0);
	saveprec(pi);
	return(cp.nowp);
}

/*** Calculate Bar count ***/

calcbar()
{
	int  i;
	int  n;
	PART *pp;
	char *p;

	for_to(i,mb.part) {
		initprec(i);
		pp=&part[i];
		loadprec(i);
		p=pp->topp;
		n=0;
		while(p=(char*)incbar(p,1,n)) n++;
		pp->barc=n;
	}
}
