/***************************
	'MET' Drawing Module
***************************/

#include "std.h"
#include "graf.h"
#include "met.h"

#define BARLMGN	32
#define BARSKPSZ 32
#define PART_SY	16
#define LMGN	10
#define LMGN1	4

#define P_GCLEF 0
#define P_FCLEF	0x04*64
#define P_GCLFS	0x06*64
#define P_FCLFS	0x07*64
#define P_NATU	0x08*64
#define P_SHARP 0x09*64
#define P_FLAT	0x0B*64
#define P_TEMPO	0x26*64
#define P_PORT	P_TEMPO+32
#define P_DYNA	0x27*64
#define P_TRIP	0x28*64+32
#define P_METER	0x20*64
#define P_VA	0x28*64+16
#define P_8		0x29*64
#define P_1END	0x2A*64
#define P_D		P_1END+32
#define P_C		0x2B*64
#define P_SEGN	0x2C*64
#define P_CORO	P_SEGN+32
#define P_REP	0x2D*64
#define P_RDOT	P_REP+32
#define P_REP1	0x2E*64
#define P_REP2	0x2F*64

#define REP1WD	19
#define REP2WD	29

#define SY_DC	0
#define SY_DS	1
#define SY_CORO	2
#define SY_SEGN	4
#define SY_1END	5

#define BAR_SGL	0
#define BAR_DBL	1
#define BAR_END	2
#define BAR_RPE	3
#define BAR_RPT	4

int  keyord[7]={ 3,0,4,1,5,2,6 };
int  shappos[7]={ 1*4,4*4,0,3*4,6*4,2*4,5*4 };
int  flatpos[7]={ 5*4,2*4,6*4,3*4,7*4,4*4,8*4 };
int  keycnv[24]={
	0,-5,2,-3,4,-1,6,1,-4,3,-2,5,
	-3,4,-1,6,1,-4,3,-2,5,0,-5,2
};

int barsz[4];
int barskp[BARSKPSZ];

static int beats[32]={
/* 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19 */
   2,1,2,3,4,1,2,1,2,3, 2, 1, 4, 1, 2, 3, 4, 1, 6, 1,
/* 20,21,22,23,24,25,26,27,28,29,30,31 */
    4, 7, 2, 1, 8, 5, 2, 9, 7, 1,10, 1 };

typedef struct beamrec {
	int  x;
	int  y;
	int  gyh;
	int  gyl;
	int  len;
	int  by;
	int  acc;
	flag key;
} BEAM;

BEAM beamwk[64];
BEAM *bmp;
int  bmi;

/*** Draw Score ***/

drawscor()
{
	int  i;
	int  y;

	peek(X_I);
	mousoff();
	fillrect(0,SCOR_Y-1+scorsy,640,SCOR_SY+1-scorsy,&bak_s);
	if(scorsy) {
		pn.col=7;
		fillrect(0,SCOR_Y,640,scorsy,NIL);
		if(scorsy) {
			pn.col=0;
			y=SCOR_Y-1;
			line(0,y,639,y);
			if(scorsy < SCOR_SY) {
				y=SCOR_Y+scorsy;
				line(0,y,639,y);
				y++;
				line(0,y,639,y);
			}
		}
		for_to(i,BARSKPSZ) barskp[i]=LMGN;
		for_to(i,mb.part) {
			if(part[i].disp) drawstaf(i);
		}
		if(insblk) drawicsr(FALSE);
	}
	mouson();
}

drawstf1(n)
int  n;
{
	if(mulstaf > 1) drawscor();
	else {
		drawstaf(n);
		if(insblk) drawicsr(FALSE);
	}
}

/*** Draw Staff ***/

static drawstaf(pi)
int  pi;
{
	int  x,y;
	int  i,j;
	int  n;

	mousoff();
	loadprec(pi);
	setbarsz();
	y=cp.stafy;
	n=0;
	for_to(i,mulstaf) {
		drawbase(SCOR_X,y,SCOR_SX+1);
		x=SCOR_X;
		for_to(j,mb.barlin+1) {
			drawbar(x,y,BAR_SGL);
			x+=barsz[j];
		}
		if(!i) drawpart(SCOR_X,y);
		for_to(j,mb.barlin) {
			cp.nowp=(char*)scanipar(cp.nowp);
			drawmesr(cp.nowp,n,FALSE);
			cp.nowp=(char*)incbar(cp.nowp,1,ndsp+n);
			if(!cp.nowp) goto end_staf;
			n++;
		}
		y+=stafssy;
	}
end_staf:
	mouson();
}

/*** Draw Measur ***/

drawmesr(p,n,clear)
char *p;
int  n;
flag clear;
{
	int  x,y;
	int  x0,y0,y1;
	int  xi,yi;
	int  px;
	int  mx;
	int  i;
	int  d0;
	int  d1;
	int  tick;
	int  tsum;
	int  trip;
	int  octx;
	int  octv;
	int  port;
	flag beam;
	flag beamf;
	flag accent;
	int  tbeam;
	int  tbeat;
	int  xbeam;
	
	mousoff();
	pn.col=0;
	port=RESTC;
	xi=n%mb.barlin;
	yi=n/mb.barlin;
	px=SCOR_X;
	for_to(i,xi) px+=barsz[i];
	mesrsx=barsz[xi];
	octx=x=px;
	octv=cp.octa;
	y=cp.stafy+stafssy*yi;
	if(clear) drawbase(x+1,y,mesrsx-1);
	if(mesrnum && cp.disp == 1) {
		gloc(x-4,y+cp.vtmgn-12);
		print("%d",ndsp+n+1);
	}
	if(!n) drawpart(x,y);
	if(!xi) x=drawclef(x,y,NORMAL);
	else {
		if(cp.chgf & XG_REPT) x=drawbar(x,y,BAR_RPT);
		if(cp.chgf & XG_CLEF) x=drawclef(x,y,SMALL);
	}
	if(!xi || cp.chgf & XG_KSIG) x=drawksig(x,y);
	if(!(ndsp+n) || cp.chgf & XG_METR) x=drawmetr(x,y);
	if(!xi && cp.chgf & XG_REPT) { x=drawbar(x+LMGN1,y,BAR_RPT); }
	if(cp.chgf & XG_SEGN) drawsym(x,y,SY_SEGN);
	if(cp.chgf & XG_1END) drawsym(x,y,SY_1END);
	x+=LMGN;
	barskp[(cp.disp-1)*mb.barlin*mulstaf+n]=(x-px);
	mesrsx-=(x-px);
	px=x;
	if(p) {
		if(cp.repm) {
			drawrepm(x,y,xi);
			x+=sumtox(cp.tmesr);
		} else {
			tsum=tbeat=setisum(ndsp+n);
			if(tsum) x+=sumtox(tsum);
			tbeam=cp.tmesr/beats[cp.meter ? ((byte)cp.meter>>3)+1 : 0];
			while(tbeat >= tbeam) {
				tbeat-=tbeam;
			}
			trip=bmi=0;
			bmp=&beamwk[0];
			accent=FALSE;
			mx=x;
			xbeam=0;
			repeat {
				d0=*p++;
				d1=*p++;
				if(!d0) {
					p-=2;
					break;
				}
				else if(d0 < 0) {
					beamf=FALSE;
					if(trip) {
						trip--;
						if(!trip) beamf=TRUE;
					} else if((d0 & 0x18) == 0x18) {
						drawtrip(x,y,d0);
						trip=2;
					}
					beam=((d0&7) >= 4);
					if(bmi) {
						if(!beam) drawbeam(y);
					} else {
						beam=beam && d1 != RESTC;
					}
					if(cp.chord) {
						y0=drawcord(x,y,p-1,d0,!beam,accent);
						p+=2;
					} else y0=drawnote(x,y,d1,d0,!beam,accent);
					accent=FALSE;
					tick=settick(d0);
					tsum+=tick;
					cp.trep+=tick;
					tbeat+=tick;
					while(tbeat >= tbeam) {
						tbeat-=tbeam;
						beamf=TRUE;
					}
					if(beam) {
						bmi++;
						bmp++;
						if(xbeam < 0 || !xbeam && beamf) drawbeam(y);
					}
					x0=x;
					mx=x=sumtox(tsum)+px;
					if(port != RESTC) {
						y0=y+cp.vtmgn+y0*(GRID/2);
						y1=drawnote(x-10,y,port,0,FALSE);
						y1=y+cp.vtmgn+y1*(GRID/2);
						line(x0+13,y0+2,x-14,y1+2);
						port=RESTC;
					}
					xbeam=0;
				} else {
					switch(d0) {
					case D_TEMPO:
						mx=drawtemp(mx,y,d1);
						break;
					case D_OCTA:
						drawocta(octx,x,y,octv,d1);
						octx=x;
						cp.octa=octv=d1;
						setkparm();
						break;
					case D_VOICE:
						mx=drawvoic(mx,y,d1);
						break;
					case D_GS:
						mx=drawgate(mx,y,d1);
						break;
					case D_LFO:
						mx=drawlfo(mx,y,d1);
						break;
					case D_DYNA:
						drawdyna(x,y,d1);
						break;
					case D_ACC:
						accent=TRUE;
						break;
					case D_PORT:
						port=d1;
						break;
					case D_BEAM:
						xbeam=d1 ? -1 : 1;
						break;
					case D_REPT:
						cp.trep=0;
						break;
					case D_REPT9:
						if(bmi) drawbeam(y);
						setiparm(d0,d1);
						tick=drawrept(x,y,d1);
						tsum+=tick;
						mx=x=sumtox(tsum)+px;
						cp.repm=cp.repc=0;
						tbeat+=tick;
						while(tbeat >= tbeam) {
							tbeat-=tbeam;
						}
						break;
					}
				}
			} until (tsum >= cp.tmesr);
			if(bmi) drawbeam(y);
		}
		drawocta(octx,x,y,octv,octv);
		if(cp.repc <= 1) {
			x=px+mesrsx;
			while(*p == D_BAR) {
				d1=*(p+1);
				i=(d1>>4)&0x0F;
				d1&=0x0F;
				if(d1 < 4) {
					drawbar(x,y,d1+1);
					if(d1 == 2 && i && cp.disp == 1) {
						gloc(x-16,y+cp.vtmgn-16);
						print("x%d",i+2);
					}
				} else if(d1 < 8) {
					drawsym(x,y,d1-4);
				}
				p+=2;
			}
		}
	}
	mouson();
}

/*** Set Bar size ***/

setbarsz()
{
	int  i;
	int  size;
	int  total;

	size=(SCOR_SX-BARLMGN)/mb.barlin;
	total=barsz[0]=size+BARLMGN;
	for_to(i,mb.barlin-1) {
		barsz[i+1]=size;
		total+=size;
	}
	barsz[i]+=SCOR_SX-total;
}

/*** Draw Staff base ***/

drawbase(x,y,sx)
int  x,y,sx;
{
	int  i;
	int  grid;

	grid=(cp.clef == CLEF_GF) ? 11 : 5;
	pn.col=7;
	fillrect(x,y,sx,cp.stafsy,0);
	pn.col=0;
	y+=cp.vtmgn;
	for_to(i,grid) {
		if(i != 5) line(x,y,x+sx-1,y);
		y+=GRID;
	}
}

/*** Draw Bar ***/

static int drawbar(px,y,type)
int  px,y;
int  type;
{
	int  x;
	int  yh,yl;
	int  i;
	int  n;
	int  c;
	flag dir,dot;

	x=px;
	yh=y+((cp.disp == 1) ? cp.vtmgn : 0);
	yl=y+cp.stafsy-(cp.dspbtm ? cp.vtmgn : 0);
	dir=dot=FALSE;
	switch(type) {
	case BAR_SGL:
		n=1;
		break;
	case BAR_DBL:
		n=2;
		break;
	case BAR_RPT:
		dir=TRUE;
	case BAR_RPE:
		dot=TRUE;
	case BAR_END:
		n=5;
		break;
	}
	for_to(i,n) {
		line(x,yh,x,yl);
		if(n == 2) x-=4;
		else {
			c=(i == 3) ? 3 : 1;
			if(dir) x+=c; else x-=c;
		}
	}
	if(dot) {
		if(!dir) x-=3; else x+=1;
		putmpat(x,y+cp.vtmgn+GRID,16,P_RDOT);
	}
	return(px+12);
}

/*** Draw Part Name ***/

drawpart(x,y)
int  x,y;
{
	int  sx;

	x+=2;
	y+=2;
	sx=strwdth(cp.name);
	shaderct(x,y,sx,PART_SY,0);
	gloc(x,y+(PART_SY-fonthigt())/2);
	print(cp.name);
}

/*** Put pattern ***/

putmpat(x,y,sy,p)
int  x,y;
int  sy;
int  p;
{
	mpat_s.pat=(char*)metpatp+p;
	mpat_s.sy=sy;
	putpat16(x,y,&mpat_s);
}

/*** Put Sharp ***/

drawshap(x,y,p,type)
int  x,y;
int  p;
flag type;
{
	int  dy;

	if(type) {
		dy=(p >= P_FLAT) ? 12 : 9;
		putmpat(x,y-dy,19,p);
	} else {
		dy=(p >= P_FLAT) ? 9 : 6;
		putmpat(x+2,y-dy,13,p+38);
	}
}

/*** Draw Triplet ***/

static drawtrip(x,y,ldat)
int  x,y;
int  ldat;
{
	int  sx;

	y+=MSG_SY;
	sx=sumtox(settick(ldat)*2);
	drawkako(x+8,y+4,sx,TRUE);
	x+=sx/2+4;
	pn.col=7;
	line(x-2,y+4,x+8,y+4);
	pn.col=0;
	putmpat(x,y,8,P_TRIP);
}

/*** Draw 'KAKKO' ***/

static drawkako(x,y,sx,upper)
int  x,y;
int  sx;
flag upper;
{
	int  dy;

	line(x,y,x+sx,y);
	dy=upper ? 4 : -4;
	line(x,y,x,y+dy);
	line(x+sx,y,x+sx,y+dy);
}

/*** Draw Clef ***/

static int  drawclef(x,y,small)
int  x,y;
flag small;
{
	int  va;
	int  y0;
	
	x+=4;
	y+=cp.vtmgn;
	y0=y;
	if(cp.clef == CLEF_N) {
		framerct(x+5,y+GRID,6,17);
	} else {
		if(!(cp.clef & 1)) {
			if(small) putmpat(x,y+2,32,P_GCLFS);
			else {
				putmpat(x,y-8,52,P_GCLEF);
				putmpat(x+16,y-8,52,P_GCLEF+64*2);
			}
			y+=GRID*6;
		}
		if(cp.clef) {
			if(small) putmpat(x,y+2,18,P_FCLFS);
			else {
				putmpat(x,y+1,32,P_FCLEF);
				putmpat(x+16,y+1,32,P_FCLEF+64);
			}
		}
		if(cp.clefva) {
			y=y0;
			va=cp.clefva;
			if(va > 0) {
				y-=16;
			} else {
				y+=cp.gridsy+4;
				va=-va;
			}
			putmpat(x+4,y,10,P_8+(va-1)*22);
		}
	}
	if(small) x+=16; else x+=20;
	return(x);
}

/*** Draw Key sig. ***/

static int  drawksig(x,y)
int  x,y;
{
	int  key;

	x+=LMGN1;
	y+=cp.vtmgn;
	key=setkref(cp.ksig);
	switch(cp.clef) {
	case CLEF_G:
		x=drawksg1(x,y-4,key);
		break;
	case CLEF_F:
		x=drawksg1(x,y+4,key);
		break;
	case CLEF_GF:
		drawksg1(x,y-4,key);
		x=drawksg1(x,y+GRID*6+4,key);
		break;
	}
	return(x);
}

static int drawksg1(x,y,key)
int  x,y;
int  key;
{
	int  i;
	int  oldkey;

	oldkey=setkref(cp.ksig0);
	if(key > 0) {
		for_to(i,key) {
			drawshap(x,y+shappos[i],P_SHARP,TRUE);
			x+=8;
		}
	} else if(key < 0) {
		for_to(i,-key) {
			drawshap(x,y+flatpos[i],P_FLAT,TRUE);
			x+=8;
		}
	}
	if(oldkey > 0) {
		if(oldkey > key) {
			for_to(i,oldkey-key) {
				drawshap(x,y+shappos[i+key],P_NATU,TRUE);
				x+=8;
			}
		}
	} else if(oldkey < 0) {
		if(oldkey < key) {
			for_to(i,key-oldkey) {
				drawshap(x,y+flatpos[i-key],P_NATU,TRUE);
				x+=8;
			}
		}
	}
	return(x);
}

/*** Set Key reference ***/

int setkref(ksig)
int  ksig;
{
	int  i;
	int  n;

	if(ksig & 0x80) ksig=(ksig & 0x7F)+12;
	n=keycnv[ksig];
	fillmem(krefb,14,0);	
	if(n > 0) {
		for_to(i,n) krefb[keyord[i]]=1;
	} else {
		for_to(i,-n) krefb[keyord[6-i]]=-1;
	}
	return(n);
}

/*** Draw Meter ***/

static int drawmetr(x,y)
int  x,y;
{
	int  i;
	int  n;
	int  x1;
	int  nm;
	int  nb;

	x+=LMGN1;
	y+=cp.vtmgn+1;
	n=(cp.clef == CLEF_GF) ? 2 : 1;
	for_to(i,n) {
		if(cp.meter) {
			nb=((byte)cp.meter >> 3)+1;
			nm=(1 << ((cp.meter & 7)-1));
			if(nb >= 10 || nm >= 10) x1=x+6; else x1=x;
			drawnum(x1,y,nb);
			x1=drawnum(x1,y+GRID*2,nm);
		} else {
			putmpat(x,y+GRID,16,P_METER+5*64);
			x1=x+16;
		}
		y+=GRID*6;
	}
	return(x1);
}

static int drawnum(x,y,n)
int  x,y;
int  n;
{
	if(n >= 10) {
		putmpat(x-6,y,16,P_METER+(n/10)*32);
		x+=6;
	}
	putmpat(x,y,16,P_METER+(n%10)*32);
	return(x+16);
}

/*** Draw Tempo ***/

static int drawtemp(x,y,dat)
int  x,y;
byte dat;
{
	putmpat(x,y,16,P_TEMPO);
	gloc(x+16,y+2);
	print("%d",dat);
	return(x+46);
}

/*** Draw Octave up/down ***/

static drawocta(oldx,x,y,old,dat)
int  oldx,x,y;
int  old,dat;
{
	int  y1;
	int  d;

	pn.lin=0xCCCC;
	if(old && oldx != x) {
		setocty(old,y,&y1,&d);
		line(oldx,y1,x,y1);
		if(old != dat) line(x,y1,x,y1+d);
	}
	if(old != dat && dat) {
		setocty(dat,y,&y1,&d);
		line(x,y1,x,y1+d);
		y1+=(d < 0) ? -11 : 2;
		if(dat < 0) dat=-dat;
		putmpat(x+2,y1,10,P_8+(dat-1)*22);
		putmpat(x+10+dat*2,y1,8,P_VA);
	}
	pn.lin=0xFFFF;
}

static setocty(dat,y,yp,dp)
int  dat;
int  y;
int  *yp;
int  *dp;
{
	if(dat > 0) {
		*yp=y+2;
		*dp=12;
	} else {
		*yp=y+cp.stafsy-2;
		*dp=-12;
	}
}

/*** Draw Voice name ***/

static int drawvoic(x,y,dat)
int  x,y;
int  dat;
{
	int  wd;
	char *name;

	gloc(x,y+2);
	if(dat >= vcount) {
		print("#%d",dat);
		wd=32;
	} else {
		name=(char*)vnameptr(dat);
		print(name);
		wd=strwdth(name);
	}
	return(x+wd+4);
}

/*** Draw G/S ***/

static int drawgate(x,y,dat)
int  x,y;
int  dat;
{
	gloc(x,y+2);
	print("G/S=%d",dat+1);
	return(x+48);
}

/*** Draw LFO ***/

static int drawlfo(x,y,dat)
int  x,y;
int  dat;
{
	gloc(x,y+2);
	if(dat) print("LFO on");
	else print("LFO off");
	return(x+52);
}

/*** Draw Dyanamics ***/

static drawdyna(x,y,dat)
int  x,y;
int  dat;
{
	int  i;
	int  n;
	int  p;

	y+=cp.stafsy-MSG_SY-8;
	dat&=7;
	if(dat == 3 || dat == 4) {
		putmpat(x,y+4,8,P_DYNA+64);
		x+=9;
	}
	if(dat < 4) { p=P_DYNA+32; n=3-dat; }
	else { p=P_DYNA; n=dat-4; }
	if(!n) n=1;
	for_to(i,n) {
		putmpat(x,y+1,12,p);
		x+=9;
	}
}

/*** Draw Repeat ***/

static int drawrept(x,y,dat)
int  x,y;
int  dat;
{
	int  i;
	int  tick;

	tick=0;
	for_to(i,cp.repc) {
		putmpat(x+sumtox(tick),y+cp.vtmgn+GRID,16,P_REP);
		tick+=cp.trep;
	}
	return(tick);
}

static drawrepm(x,y,n)
int  x,y;
int  n;
{
	int  p;

	if(cp.repm == 2) {
		p=P_REP1;
		x+=(mesrsx-REP1WD)/2;
	} else {
		p=P_REP2;
		if(cp.repc&1) { if(n) x=0; }
		else x+=mesrsx-((n+1 == mb.barlin) ? REP2WD : REP2WD/2);
	}
	y+=cp.vtmgn+GRID+1;
	if(x) {
		putmpat(x,y,16,p);
		putmpat(x+16,y,16,p+32);
	}				
}

/*** Draw Symbol ***/

static drawsym(x,y,dat)
int  x,y;
int  dat;
{
	int  p;

	p=0;
	if(dat <= SY_DS) {
		if(!cp.dspbtm) goto end_sym;
		y+=cp.gridsy+2;
	} else {
		if(cp.disp > 1) goto end_sym;
		y-=16;
	}
	y+=cp.vtmgn;
	switch(dat) {
	case SY_DC:
	case SY_DS:
		x-=32;
		p=P_D;
		break;
	case SY_CORO:
		x-=8;
		p=P_CORO;
		break;
	case SY_SEGN:
		x-=8;
		p=P_SEGN;
		break;
	case SY_1END:
		p=P_1END;
		break;
	}
	putmpat(x,y,16,p);
	if(dat <= SY_DS) {
		p+=dat ? 64 : 32;
		putmpat(x+16,y,16,p);
	}
end_sym:;
}
