/*************************
	'MET' Music Editor    
*************************/

#define MAIN 1

#include "std.h"
#include "graf.h"
#include "met.h"

#define MN_EDT	0

/***********
	main
***********/

main(argc,argv)
int  argc;
char *argv[];
{
	int  mous;

	font16p=load("font16.pat");
	font12p=load("font12.pat");
	initspat(load("ctrl.pat"),&ctrl_s);
	metpatp=load("metpat.pat")+HEADSZ;
	meticnp=load("meticon.pat")+HEADSZ;
	initmous(metmous=load("metmous.pat"));
	setfont(font12p);
	setpen(&pn);
	pfkey(OFF);
	pchr(CLS);
	gcls();
	gmode(1);
	gon();
	pinit(PR_GRAF);
	init();
	initsnd1();
	mousini;
	setmscsr(MC_NOTE,FALSE);
	mouson();
	if(argc >= 2) {
		if(loadvoic(argv[1]) && argc >=3) {
			if(loadmusc(argv[2])) {
				init();
				if(argc >= 4) {
					if(!strcmp(argv[3],"/p")) {
						setmscsr(MC_AROW,TRUE);
						loop {
							if(!playf) {
								playf=TRUE;
								playin();
							}
							do_play();
							if(!playf) {
								if(++edtmn == mcount) edtmn=0;
								musicblk(MN_EDT,edtmn);
								drawall();
							}
							if(getmous(&msrec)&MS_LDN) goto mainloop;
							if(gchr(5) == 0x1B) {
								playout();
								goto todos;
							}
						}
					}
				}
			}
		}
	}
mainloop:
	repeat {
		getmous(&msrec);
		if(!vedit) {
			mous=MC_AROW;
			if(msrec.py >= SCOR_Y && msrec.py < SCOR_Y+scorsy) {
				if(playf) mous=MC_PLAY;
				else {
					if(msrec.evnt & MS_RDN) { do_popup(); continue; }
					mous=icon+1;
				}
			}
			if(mous != moustyp) setmscsr(moustyp=mous,TRUE);
		}
		if(msrec.evnt || msrec.btn & MS_LON) {
			if(vedit) {
				if(domenu(&mb_voic)) continue;
				if(do_vedt()) continue;
			} else if(playf) {
				if(do_panl()) continue;
			} else {
				if(domenu(&mb_musc)) continue;
				if(do_panl()) continue;
				if(do_edit()) continue;
			}
		}
		if(playf) do_play();
	} until(quit);
todos:
	initsnd();
	mousoff();
	pchr(CLS);
	goff();
	pfkey(ON);
	exit();
}

/*** Get memory & clear ***/

char *getmemc(size)
int  size;
{
	char *p;

	if(!(p=getmem(size))) {
		print("Not enough memory !\n");
		exit();
	}
	fillmem(p,size,0);
	return(p);
}

/*** Initialize ***/

init()
{
	word size;

	bak_s.pat=(char*)bakpat;
	bak_s.col1=7;
	if(!vheadp) {
		size=memsize();
		if(size < VBUFSZ+HEADSZ+sizeof(MBLK)) {
			memerror();
			exit();
		}
		vheadp=(HEAD*)getmem(size);
		maxp=clipp=(char*)vheadp+size;
		fillmem(vheadp,size,0);
	}
	if(!mheadp) {
		mheadp=(HEAD*)((char*)vheadp+VBUFSZ);
		musicp=(char*)mheadp+HEADSZ;
		freep=musicp+sizeof(MBLK);
		fillmem(mheadp,HEADSZ+sizeof(MBLK),0);
		mb.part=0;
		mcount=0;
		makepart(-1,IPMODE);
	}
	initmmnu();
	drawall();
}

drawall()
{
	mousoff();
	fillrect(0,0,640,384,&bak_s);
	drawmenu(&mb_musc);
	drawpanl();
	drawscor();
	mouson();
}

initmedt()
{
	vedit=FALSE;
	oncrtv(0,3);
	initsnd1();
	initmmnu();
	drawall();
}

static initsnd1()
{
	initsnd();
	initvoic(vheadp);
	setmvolm(mastvolm);
}

/*** load file ***/

load(name)
char *name;
{
	int  p;
	
	p=loadfile(name);
	if(!p) {
		print("*** Can't find \"%s\"\n",name);
		exit();
	} else if(p == -1) {
		memerror();
		exit();
	}
	return(p);
}

memerror()
{
	print("*** Not enough memory !");
}

/*** Init Mous Pattern ***/

initmous(mp)
HEAD *mp;
{
	int  i;
	int  *p;

	p=(int*)(mp+1);
	for_to(i,mp->count*32) {
		*p=swaphl(*p);
		*p++;
	}
}

/*** Set Mouse cursor ***/

setmscsr(csr,f)
int  csr;
flag f;
{
	int  hot;

	hot=csr > 2 ? 8 : 0;
	mouscsr(metmous+csr*64+HEADSZ,hot,hot);
	if(f) {
		mousoff();
		mouson();
	}
}
