/******************************
	'MET' Music Editor Defs
******************************/

/*** Symbols ***/

#define HEADSZ	16
#define VBLKSZ	64
#define VCMAX	128
#define VBUFSZ  VBLKSZ*VCMAX+HEADSZ
#define PARTRH	34

#define SCOR_X	8
#define SCOR_Y	64
#define SCOR_SX	640-24
#define SCOR_SY	400-SCOR_Y
#define MSG_SY	8

#define INSMODE	1
#define BLKMODE	2

#define MC_AROW	0
#define MC_NOTE	1
#define MC_PLAY	37

#define LEN_A	0
#define LEN_1	1
#define LEN_2	2
#define LEN_8	4
#define CLEF_G	0
#define CLEF_F	1
#define CLEF_GF	2
#define CLEF_N	3
#define OCT_M	4
#define GRID	8
#define VASPACE	4
#define STEMLN	28
#define RESTC	0xFFFF
#define PARTPC	4
#define IPMODE	0x00
#define DSPBTM	0x80
#define NORMAL	FALSE
#define SMALL	TRUE

#define TONE_C	0
#define	TONE_D	1
#define	TONE_E	2
#define	TONE_F	3
#define	TONE_G	4
#define	TONE_A	5
#define	TONE_B	6

#define D_CLEF	1
#define D_KSIG	2
#define D_TSIG	3
#define D_BAR	4
#define D_TEMPO	5
#define D_OCTA	6
#define D_VOICE	7
#define D_GS	8
#define D_LFO	9
#define D_DYNA	10
#define D_ACC	11
#define D_PORT	12
#define D_BEAM	13
#define D_REPT	14
#define D_REPT9	15

#define XG_CLEF	0x01
#define XG_KSIG 0x02
#define XG_METR	0x04
#define XG_SEGN	0x08
#define XG_1END	0x10
#define XG_REPT	0x20

enum playcrec {
	CP_ON,
	CP_OFF,
	CP_STOP,
	CP_MUTE,
	CP_SEEK,
	CP_BLCK,
	CP_STT,
	CP_POS
};

/*** Records ***/

typedef struct header {
	char id[4];
	int  size;
	int  count;
	char dummy[8];
} HEAD;

typedef struct mblkrec {
	int  size;
	int  part;
	int  nall;
	char barlin;
	char beat;
	char name[24];
} MBLK;

typedef struct pblkrec {
	int  size;
	char mode;
	char vmgn;
	int  data;
} PBLK;
	
typedef struct partrec {
	PBLK *partp;	/* PARTPC=4 */
	char *topp;
	char *dspp;
	char *nowp;
	char name[8];
	int  disp;
	flag dspbtm;
	int  stafy;
	int  stafsy;
	int  gridsy;
	int  mode;
	int  legmax;
	int  vtmgn;
	int  barc;

	int  chord;		/* PARTRH=34 */
	int  clef;
	int  clefva;
	int  ksig;
	int  meter;
	int  tempo;
	int  voice;
	int  gate;
	int  lfo;
	int  dyna;
	int  octa;
	int  key_h;
	int  key_l;
	int  tmesr;
	int  tbeat;
	int  chgf;
	int  ksig0;
	int  repm;
	int  repc;
	int	 trep;
} PART;

typedef struct icsrrec {
	int  px;
	int  py;
	int  sy;
	int  part;
	int  bar;
	int  tick;
	int  sumx;
} ICSR;

/*** Global Symbols ***/

#ifdef MAIN

int  font16p;
int  font12p;
int  metpatp;
int  meticnp;
int  metmous;
int  moustyp;
HEAD *mheadp;
HEAD *vheadp;
char *voicep;
char *musicp;
char *freep;
char *clipp;
char *maxp;
int  mcount;
int  vcount;
int  edtmn;
int  edtvn;
int  vch=2;
int  mh;
int  mute;
flag quit;
flag vedit;
flag playf;
flag mdup;
flag vdup;
flag mesrnum;
int  usefm;
int  usepsg;
int  usenois;
int  usefm3;
int  rest;
int  insblk;
int  icon;
int  imode;
int  acticon;
int  dsppart;
int  mastvolm=15;
int  masttemp;

MBLK mb={ 0,0,0,2,0,"untitled" };
int  bakpat[2]={ 0xAAAA,0x5555 };
PATT ctrl_s;
PATT bak_s={ 0,2,2,1 };
PATT mpat_s={ 0,2,32,1,0,0,0,8,0 };
PATT micn_s={ 0,2,16,1,0,0,0,7,0 };
MOUS msrec;
PEN	 pn;
MBAR mb_musc={ NIL,5,0,0,640,NIL };
MBAR mb_voic={ NIL,3,0,0,640,NIL };
char mfilenam[]="untitled.msc";
char vfilenam[]="untitled.vce";
char voicname[16]="untitled";

int  stafssy;
int	 scorsy;
int  mesrsx;
int  lfmgn;
int  mulstaf=1;
int  ndsp;
char krefb[7];
char kref[7];
PART part[7];
PART cp;
ICSR icsr;
ICSR bcsr;
ICSR tcsr;

#else

/*** External Symbols ***/

extern int  font16p;
extern int  font12p;
extern int  metpatp;
extern int  meticnp;
extern int  metmous;
extern int  moustyp;
extern HEAD *mheadp;
extern HEAD *vheadp;
extern char *voicep;
extern char *musicp;
extern char *freep;
extern char *clipp;
extern char *maxp;
extern int  mcount;
extern int  vcount;
extern int  edtmn;
extern int  edtvn;
extern int  vch;
extern int  mh;
extern int  mute;
extern flag quit;
extern flag vedit;
extern flag playf;
extern flag mdup;
extern flag vdup;
extern flag mesrnum;
extern int  usefm;
extern int  usepsg;
extern int  usenois;
extern int  usefm3;
extern int  rest;
extern int  insblk;
extern int  icon;
extern int  imode;
extern int  acticon;
extern int  dsppart;
extern int  mastvolm;
extern int  masttemp;

extern MBLK mb;
extern int  bakpat[];
extern PATT ctrl_s;
extern PATT bak_s;
extern PATT mpat_s;
extern PATT micn_s;
extern MOUS msrec;
extern PEN	pn;
extern MBAR mb_musc;
extern MBAR mb_voic;
extern char mfilenam[];
extern char vfilenam[];
extern char voicname[];

extern int  stafssy;
extern int	scorsy;
extern int  mesrsx;
extern int  lfmgn;
extern int  mulstaf;
extern int  ndsp;
extern char krefb[7];
extern char kref[7];
extern PART part[6];
extern PART cp;
extern ICSR icsr;
extern ICSR bcsr;
extern ICSR tcsr;
#endif

extern char *getmem();
extern char *strcpy();
