/************************
	'MET' Icon Handler
************************/

#include "std.h"
#include "graf.h"
#include "met.h"

#define M_TSIG	0x80

#define PALSZ	20
#define PALHF	10
#define PALOF	2
#define FRAME	4

#define IC_NOTE	0
#define IC_REST	1
#define IC_INS	2
#define IC_BLK	3
#define IC_CUT	4
#define	IC_REP	5
#define	IC_REP1	6
#define	IC_REP2	7
#define	IC_TIE	8
#define	IC_STAC	9
#define	IC_STACS 10
#define	IC_TRIP	11
#define	IC_ACC	12
#define	IC_PORT	13
#define IC_DYNA 14
#define IC_INOTE 22
#define IC_IREST 29
#define IC_IRST9 36

#define IC_PASTE 36
#define IC_BEAMC 37
#define IC_BEAMS 38
#define IC_TEMPO 39
#define IC_OCTA	40
#define IC_VOICE 41
#define IC_GS	42
#define IC_LFO	43
#define IC_CLEF	44
#define IC_KSIG	45
#define IC_TSIG	46
#define IC_BAR	47
#define IC_BAR9	57

#define IC_DEL	57
#define IC_DUP	58
#define IC_KEY	59

#define R_NOP	0
#define R_MESR	1
#define R_SCOR	2

typedef struct paltrec {
	int	cx;
	int	cy;
	int wsx;
	int wsy;
	int	base;
} PALT;

static PALT palets[3]={
	{ 8,4,8*PALSZ,4*PALSZ,IC_CUT },
	{ 5,5,5*PALSZ,5*PALSZ,IC_PASTE },
	{ 5,1,5*PALSZ,1*PALSZ,IC_DEL },
};

static int xary[3][5]={
	{ 6,6,8,7,0 },
	{ 5,5,3,5,5 },
	{ 5,0,0,0,0 }
};

extern int ticks[];
extern char *locbar();

/*** Pop Up Menu ***/

do_popup()
{
	int  i;
	int  x,y;
	int  cx,cy;
	int  cxi,cyi;
	int  wpx,wpy;
	int	 wsx,wsy;
	PALT *pl;
	int  *xp,*xpi;
	int  imgp;
	int  maxicon;
	int  btst;
	int  col;
	int  icn;
	flag f;

	pl=&palets[imode];
	xp=xary[imode];
	wsx=pl->wsx;
	wsy=pl->wsy;
	wpx=msrec.px-PALHF;
	wpy=msrec.py-PALHF;
	if(wpx < FRAME) wpx=FRAME;
	else if(wpx+wsx+FRAME > 640) wpx=640-FRAME-wsx;
	if(wpy < FRAME) wpy=FRAME;
	else if(wpy+wsy+FRAME > 400) wpy=400-FRAME-wsy;
	msrec.px=wpx+PALHF;
	msrec.py=wpy+PALHF;

	mousoff();
	setmscsr(MC_AROW,FALSE);
	setmous(&msrec);
	imgp=getrect(wpx-FRAME,wpy-FRAME,wsx+FRAME*2+1,wsy+FRAME*2+1);
	pn.col=7;
	fillrect(wpx-2,wpy-2,wsx+5,wsy+5,NIL);
	pn.col=0;
	for(i=3; i<=4; i++) {
		framerct(wpx-i,wpy-i,wsx+i*2+1,wsy+i*2+1);
	}
	pn.col=0;
	i=(icon == IC_NOTE) ? IC_REST : IC_NOTE;
	if(imode == INSMODE) {
		if(!insblk) maxicon=IC_NOTE;
		else if(acticon&M_TSIG) maxicon=IC_LFO;
		else maxicon=IC_BAR9;
	} else if(imode == BLKMODE) {
		if(insblk == INSMODE) maxicon=IC_INS;
		else maxicon=IC_KEY;
	} else maxicon=IC_IRST9;
	xpi=xp;
	btst=1;
	for(y=wpy; y < wpy+wsy; y+=PALSZ) {
		cx=0;
		for(x=wpx; x < wpx+wsx; x+=PALSZ) {
			framerct(x,y,PALSZ+1,PALSZ+1);
			col=0;
			if(i > maxicon) col=5;
			else if(i >= IC_TEMPO && i <= IC_TSIG) {
				if(acticon&btst) col=5;
				btst<<=1;
			}
			micn_s.col1=col;
			micn_s.pat=(char*)meticnp+i*32;
			putpat16(x+PALOF,y+PALOF,&micn_s);
			if(i < IC_CUT) {
				if(i <= IC_REST) i=(imode == INSMODE) ? IC_BLK : IC_INS;
				else i=pl->base;
			} else i++;
			if(i == IC_INOTE) {
				if(rest) i=IC_IREST;
			}
			if(++cx == *xpi) break;
		}
		xpi++;
	}
	cx=0;
	cy=0;
	invpalt(wpx,wpy,cx,cy);
	mouson();

	f=TRUE;
	icn=0;
	repeat {
		getmous(&msrec);
		if(!(msrec.evnt & MS_MOV)) continue;
		cxi=msrec.px-wpx;
		cyi=msrec.py-wpy;
		if(cxi >= 0) cxi/=PALSZ; else cxi=-1;
		if(cyi >= 0) cyi/=PALSZ; else cyi=-1;
		if(cxi != cx || cyi != cy) {
			mousoff();
			if(f) invpalt(wpx,wpy,cx,cy);
			cx=cxi;
			cy=cyi;
			f=FALSE;
			if(cx >= 0 && cx < *(xp+cy) && cy >= 0 && cy < pl->cy) {
				icn=0;
				for_to(i,cy) icn+=*(xp+i);
				icn+=cx;
				if(icn >= 2) icn+=pl->base-2;
				if(icn <= maxicon) {
					if(icn >= IC_TEMPO && icn <= IC_TSIG) {
						if(!(acticon&(1<<(icn-IC_TEMPO)))) f=TRUE;
					} else f=TRUE;
					if(f) invpalt(wpx,wpy,cx,cy);
				}
			}
			mouson();
		}
	} until(msrec.evnt & MS_RUP);
		
	mousoff();
	if(f && icn >= IC_PASTE) {
		flushrct(wpx+cx*PALSZ,wpy+cy*PALSZ,PALSZ,PALSZ);
	}
	putrect(imgp);
	mouson();

	if(f) {
		if(!imode) {
			if(!icn) {
				if(icon == IC_NOTE) icon=IC_REST;
				else icon=IC_NOTE;
				rest=icon;
			} else if(icn == 1) {
				icon=IC_INS;
				imode=INSMODE;
			} else {
				icon=icn;
				if(icon >= IC_INOTE && rest) icon+=IC_IREST-IC_INOTE;
			}
		} else {
			if(!icn) {
				drawicsr(FALSE);
				imode=insblk=FALSE;
				icon=rest=IC_NOTE;
			} else {
				if(icon == IC_INS) {
					if(icn == 1) { icon=IC_BLK; imode=BLKMODE; }
					else {
						if(icn == IC_PASTE) doblck(icn);
						else doinst(icn);
					}
				} else {
					if(icn == 1) { icon=IC_INS; imode=INSMODE; }
					else doblck(icn);
				}
			}
		}
	}
	moustyp=0;
}

static invpalt(wpx,wpy,cx,cy)
int  wpx;
int  wpy;
int  cx;
int  cy;
{
	invrect(wpx+cx*PALSZ+1,wpy+cy*PALSZ+1,PALSZ,PALSZ);
}

/*** Do Marking Icon ***/

int  domark(edtp,mode)
int  mode;
char *edtp;
{
	int  ret;
	int  old;
	int  new;

	ret=R_NOP;
	if(mode < 0 ) goto end_mark;
	if(*(edtp+1) == RESTC) goto end_mark;
	if(icon < IC_TRIP) {
		old=*edtp & 0x60;
		new=(icon-IC_TIE+1)<<5;
		if(old == new) new=0;
		*edtp=(*edtp & ~0x60)|new;
		ret=R_MESR;
	} else {
		if(icon >= IC_DYNA) ret=dodyna(edtp);
		else {
			switch(icon) {
			case IC_TRIP:
				ret=dotrip(edtp);
				break;
			case IC_ACC:
				ret=doprefix(edtp,D_ACC,0);
				break;
			case IC_PORT:
				ret=doprefix(edtp,D_PORT,*(edtp+1));
				break;
			}
		}
	}
end_mark:
	return(ret);
}

/*** Scan Data ***/

static char *scandata(edtp,data)
char *edtp;
int  data;
{
	int  d0;
	char *fp;
	char *p;

	fp=NIL;
	p=cp.nowp;
	while(p < edtp) {
		d0=*p;
		if(d0 > 0) {
			if(d0 == data) fp=p;
		} else {
			fp=NIL;
			if(cp.chord) p+=2;
		}
		p+=2;
	}
	return(fp);
}

/*** Do Triplet ***/

static flag dotrip(edtp)
char *edtp;
{
	int  i,j;
	int  ldat;
	int  gs;
	int  mod;
	int  len;
	int  trip;
	char *p;
	int  ret;

	ret=R_NOP;
	ldat=*edtp;
	gs=ldat & 0xE0;
	mod=ldat & 0x18;
	len=ldat & 0x07;
	if(!mod) {
		if(++len > 7) goto end_trip;
		*edtp=gs | len | 0x18;
		for_to(i,2) {
			if(cp.chord) {
				for_to(j,2) insdata(edtp,*(edtp+2),*(edtp+3));
			} else insdata(edtp,*edtp,*(edtp+1));
		}
		ret=R_MESR;
	} else if(mod == 0x18) {
		p=cp.nowp;
		trip=0;
		while(p < edtp) {
			if((ldat=*p) < 0) {
				if((ldat & 0x18)==0x18) {
					if(!trip) trip=2;
					else trip--;
				}
				p+=(cp.chord) ? 4 : 2;
			} else p+=2;
		}
		if(!trip) {
			for_to(i,(cp.chord ? 4 : 2)) deldata(edtp);
			*edtp=(*edtp & ~0x18)-1;
			ret=R_MESR;
		}
	}
end_trip:
	return(ret);
}

/*** Do Dynamics ***/

static flag dodyna(edtp)
char *edtp;
{
	int  dat;
	char *nowp;

	nowp=scandata(edtp,D_DYNA);
	dat=7-(icon-IC_DYNA);
	if(nowp) {
		if(dat == *(nowp+1)) deldata(nowp);
		else *(nowp+1)=dat;
	} else insdata(edtp,D_DYNA,dat);
	return(R_MESR);
}

/*** Do Accento/Portament ***/

static flag doprefix(edtp,d0,d1)
char *edtp;
{
	char *p;

	if(p=scandata(edtp,d0)) deldata(p);
	else insdata(edtp,d0,d1);
	return(R_MESR);
}

/*** Do Repeat ***/

int  dorept(edtp,mode,pi,n)
char *edtp;
int  mode;
int  pi;
int  n;
{
	int  ret;
	int  c;
	int  type;
	int  tick;
	int  tsum;
	int  icn;
	flag add;
	flag f;
	char *p;
	char *np;
	char *tp;
	PART *pp;

	ret=R_NOP;
	pp=&part[pi];
	if(icon == IC_CUT) {
		icn=cp.repm-1+IC_REP;
		add=FALSE;
	} else {
		icn=icon;
		add=TRUE;
	}
	switch(icn) {
	case IC_REP:
		if(mode == -1) goto end_rept;
		p=(char*)scanipar(cp.nowp);
		while(*p == D_REPT && *(p+1)) p+=2;
		tp=p;
		f=FALSE;
		while(p < edtp-2) {
			if(*p == D_REPT) f=TRUE;
			if(*p == D_REPT9) { tp=p+2; f=FALSE; }
			p+=2;
		}
		if(f && !cp.repm) goto end_rept;
		if(add) {
			if(!cp.trep) goto end_rept;
			p=edtp;
			tsum=sumtick(cp.nowp,edtp);
			if(tsum+cp.trep > cp.tmesr) goto end_rept;
			tick=0;
			repeat {
				if(!(*p)) break;
				if(*p < 0) {
					tick+=settick(*p);
					if(cp.chord) p+=2;
				}
				p+=2;
			} until (tick >= cp.trep);
			if(tick != cp.trep) goto end_rept;
			delpart(pp->partp,edtp,p-edtp);
			if(cp.repm) (*(edtp-1))++;
			else {
				insdata(edtp,D_REPT9,1);
				insdata(tp,D_REPT,0);
			}
		} else {
			if(!cp.repm) goto end_rept;
			insdata(edtp,tonorm(cp.trep),RESTC);
			if(!(--(*(edtp-1)))) {
				deldata(edtp-2);
				while(*tp != D_REPT || *(tp+1)) tp+=2;
				deldata(tp);
			}
		}
		ret=R_MESR;
		break;
	case IC_REP1:
	case IC_REP2:
		c=icn-IC_REP;
		type=c<<6;
		np=cp.nowp;
		if(!cp.repm) {
			if(!add) goto end_rept;
			if(n-c < 0) goto end_rept;
			np=cp.nowp;
			p=locbar(pi,n-c);
		}
		if(cp.repm) {
			if(cp.repm == c+1) {
				if(add) {
					if((*(np-1)&0x3F) == 0x3F) goto end_rept;
					(*(np-1))++;
					pp->barc+=c;
				} else {
					if(cp.repm == 3 && cp.repc&1) goto end_rept;
					if(!(--(*(np-1))&0x3F)) {
						deldata(np-2);
						p=locbar(pi,n-c);
						while(*(int*)p != (type<<8)+D_REPT) p+=2;
						deldata(p);
					}
					pp->barc-=c;
				}
			} else goto end_rept;
		} else {
			if(!add) goto end_rept;
			insdata(np,D_REPT9,type+1);
			p=(char*)scanipar(p);
			insdata(p,D_REPT,type);
			pp->barc+=c;
		}
		ret=R_SCOR;
		break;
/*
	case IC_REST:
		if(add) {
			insdata(cp.nowp,tonorm(cp.tmesr),RESTC);
			pp->barc++;
			ret=R_SCOR;
		} else {
			p=cp.nowp;
			if(*p < 0 && *(p+1) == RESTC) {
				if(settick(*p) == cp.tmesr) {
					deldata(p);
					pp->barc--;
					ret=R_SCOR;
				}
			}
		}
		break;
*/
	}
	if(ret == R_SCOR) locbar(pi,ndsp);
end_rept:
	return(ret);
}

/*** Tick to Normal Lengh ***/

static int tonorm(tick)
int  tick;
{
	int  i;
	int  len;

	len=0x80;
	for_to(i,24) {
		if(ticks[i] == tick) {
			len=0x80+i;
		 	break;
		 }
	}
	return(len);
}
