/*************************
	'MET' Menu Handler
*************************/

#include "std.h"
#include "graf.h"
#include "met.h"
#include "vet.h"

#define MDSP	10
#define MNAMWD	180
#define MNAMLEN	20
#define VNAMLEN	16
#define MNAMX	1
#define MNAMY	19
#define MNAMSX	320
#define VNAMSX	240

enum mnfile {
	MN_LOD,
	MN_SAV,
	MN_MRG,
	MN_NEW,
	MN_END
};

enum mnedit {
	MN_EDT,
	MN_RPL,
	MN_INS,
	MN_DEL,
	MN_REN,
	MN_MNEW
};

enum mnvoic {
	MN_VLOAD,
	MN_VEDIT
};

enum mnform {
	MN_ASTF,
	MN_DSTF,
	MN_SSTF,
	MN_SCOR
};

enum mnsys {
	MN_INFO,
	MN_TTL
};

enum mnvtype {
	MN_FM,
	MN_PSG
};

static MENU mn_musc[]={
	"File",5,80,0,0,0,
	"Music",6,96,0,0,0,
	"Voice",2,80,0,0,0,
	"Format",4,128,0,0,0,
	"System",2,128,0,0,0
};

static ITEM it_file[]={
	"Load",0,
	"Save",0,
	"Merge",0,
	"New",0,
	"Quit",0
};

static ITEM it_music[]={
	"Edit",0,
	"Replace",0,	
	"Insert",0,
	"Delete",0,
	"Rename",0,
	"New",0
};

static ITEM it_voic[]={
	"Load",0,
	"Edit",0
};
	
static ITEM it_form[]={
	"Add Part",0,
	"Delete Part",0,
	"Setup Part",0,
	"Setup Score",0
};

static ITEM it_sys[]={
	"System Info.",0,
	"About me",0
};

static MENU mn_voic[]={
	"File",5,80,0,0,0,
	"Voice",5,96,0,0,0,
	"Type",3,80,0,0,0
};

static ITEM it_vfile[]={
	"Load",0,
	"Save",0,
	"Merge",0,
	"New",0,
	"Quit",0
};

static ITEM it_voice[]={
	"Edit",0,
	"Replace",0,	
	"Insert",0,
	"Delete",0,
	"Rename",0
};

static ITEM it_vtype[]={
	"FM",0,
	"PSG",0,
	"Noise",0
};

static char muscid[]="MSC";
static char muscmask[]="*.msc";
static char voicid[]="VCE";
static char voicmask[]="*.vce";
static DLOG dg_sure={  "Are you sure?",0,0,2,Q_YES,Q_NO };
static DLOG dg_lodng={ "Can't Load!",0,0,1,Q_OK };
/* static DLOG dg_lodok={ "Load \"%s\"?",240,0,2,Q_YES,Q_NO }; */
       DLOG dg_msel={ NIL,MNAMWD+46,72+MDSP*16,2,Q_OK,Q_ESC,Q_DEL };
static SMNU sm_msel={ CT_SMNU,0,0,0,NIL,MNAMWD,MDSP };
static SBAR sb_msel;
static DLOG dg_ins={ NIL,MNAMWD+32,56+32,2,Q_OK,Q_ESC };
static TBOX tb_ins={ CT_TBOX,0,0,0,NIL,0,MNAMWD };
static TBOX tb_ren={ CT_TBOX,0,0,0,NIL,0,MNAMWD };
static char tl_ins[]="Insert as:\n";
static char tl_ren[]="Rename as:\n";
	   DLOG dg_full={ "Not enough Memory !",0,0,1,Q_OK };
static DLOG dg_vful={ "Voice table Full !",0,0,1,Q_OK };
static DLOG dg_info={ "System Information...\n\n",216,8*20,1,Q_OK };
static USER us_info={ CT_USER };
static DLOG dg_ttl={ "Music Editor 'Menuet' V0.83\n\n",272,8*14,1,Q_OK };
static USER us_ttl={ CT_USER };
static char ttl_msel[]="Select Music...\n";
static char ttl_vsel[]="Select Voice...\n";
static char ttl_ins[]="Insert Position...\n";
static char sbuf[MNAMLEN];

static PATT pt_vnam={ 0,2,4,1,0,0,0,7,0 };
static int mpatt[5]={ 0x0000,0xFFFF,0xFFFF,0x0000,0x0000 };

extern int doinst();
extern int doblck();

/*** Draw Music name ***/

drawmnam()
{
	int  wd;
	int  oldfont;

	oldfont=setfont(font16p);
	pt_vnam.pat=(char*)&mpatt[1];
	fillrect(MNAMX,MNAMY,MNAMSX,16,&pt_vnam);
	shaderct(MNAMX,MNAMY,MNAMSX,16,1);
	pn.col=7;
	wd=strwdth(mb.name);
	fillrect(MNAMX+(MNAMSX-(wd+16))/2,MNAMY,wd+16,16,NIL);
	gloc(MNAMX+(MNAMSX-wd)/2,MNAMY+1);
	pn.col=0;
	print(mb.name);
	setfont(oldfont);
}
	
/*** Do menu.file ***/

static dofile(itm)
int itm;
{
	switch(itm) {
	case MN_LOD:
		if(loadmusc(NIL)) init();
		break;
	case MN_SAV:
		savemusc();
		break;
	case MN_MRG:
		if(mergmusc()) init();
		break;
	case MN_NEW:
		if(dialog(&dg_sure) == Q_YES) {
			mheadp=NIL;
			init();
		}
		break;
	case MN_END:
		if(dialog(&dg_sure) == Q_YES) quit=TRUE;
		break;
	}
}

/*** Get Music Name Pointer ***/

static MBLK *mblkptr(n)
int  n;
{
	int  i;
	MBLK *mp;

	mp=(MBLK*)(mheadp+1);
	for_to(i,n) mp=(MBLK*)((char*)mp+mp->size);
	return(mp);
}

static char *mnameptr(n)
int  n;
{
	return(mblkptr(n)->name);
}

static prntmnam(n)
int  n;
{
	int  x,y;
	MBLK *mp;

	mp=mblkptr(n);
	getgloc(&x,&y);
	print(mp->name);
	gloc(x+MNAMWD-30,y);
	print("%3d",mp->nall);
}

/*** Do menu.music ***/

static domusic(itm)
int  itm;
{
	int  n;

	switch(itm) {
	case MN_EDT:
		if((n=selmusic(ttl_msel)) >= 0) {
			musicblk(MN_EDT,n);
			drawall();
		}
		break;
	case MN_RPL:
		if(dialog(&dg_sure) == Q_YES) {
			musicblk(MN_RPL,edtmn);
		}
		break;
	case MN_INS:
		dg_ins.link=(CTRL*)&tb_ins;
		dg_ins.ttl=tl_ins;
		tb_ins.str=mb.name;
		tb_ins.val=MNAMLEN-1;
		if(dialog(&dg_ins) == Q_OK) {
			drawmnam();
			if(mcount) n=selmusic(ttl_ins); else n=-1;
			musicblk(MN_INS,n);
		}
		break;
	case MN_DEL:
		if((n=selmusic(ttl_msel)) >= 0) {
			if(dialog(&dg_sure) == Q_YES) {
				musicblk(MN_DEL,n);
			}
		}
		break;
	case MN_REN:
		if((n=selmusic(ttl_msel)) >= 0) {
			dg_ins.link=(CTRL*)&tb_ren;
			dg_ins.ttl=tl_ren;
			strcpy(sbuf,mnameptr(n));
			tb_ren.str=sbuf;
			tb_ren.val=MNAMLEN-1;
			if(dialog(&dg_ins) == Q_OK) {
				musicblk(MN_REN,n);
			}
		}
		break;
	case MN_MNEW:
		if(dialog(&dg_sure) == Q_YES) {
			musicblk(MN_MNEW,edtmn);
			drawall();
		}
		break;
	}
	initmmnu();
}

/*** Do menu.voice ***/

static dovoic(itm)
int  itm;
{
	switch(itm) {
	case MN_VLOAD:
		if(loadvoic(NIL)) {
			setimnu();
			drawall();
		}
		break;
	case MN_VEDIT:
		initvedt();
		break;
	}
}

/*** Do memu.format ***/

static doform(itm)
int  itm;
{
	int  f;

	switch(itm) {
	case MN_ASTF:
		f=addstaf();
		break;
	case MN_DSTF:
		f=delstaf();
		break;
	case MN_SSTF:
		f=setstaf();
		break;
	case MN_SCOR:
		f=setscor();
		break;
	}
	if(f) {
		initmmnu();
		drawpanl();
		drawscor();
	}
}

/*** Do System ***/

static int  drawinfo(cp)
USER *cp;
{
	gloc(cp->px,cp->py);
	print("Free area: %d\n",clipp-freep);
	print("Music file size: %d\n",musicp-(char*)mheadp);
	print("Edit music size: %d\n",freep-musicp);
	print("Paste buffer size: %d\n",maxp-clipp);
	print("Voice count: %d\n",vcount);
	return(16*5);
}

static int  drawttl(cp)
USER *cp;
{
	gloc(cp->px+40,cp->py);
	print("86/12/25 by ZOBplus C.MOS");
	return(16);
}

static dosys(itm)
int  itm;
{
	switch(itm) {
	case MN_INFO:
		dg_info.link=(CTRL*)&us_info;
		us_info.drawuser=drawinfo;
		dialog(&dg_info);
		break;
	case MN_TTL:
		dg_ttl.link=(CTRL*)&us_ttl;
		us_ttl.drawuser=drawttl;
		dialog(&dg_ttl);
		break;
	}
}

/*** Init Menus ***/

initmmnu()
{
	mb_musc.mnu=&mn_musc[0];
	mb_musc.ttl=mfilenam;
	mn_musc[0].item=it_file;	
	mn_musc[0].func=dofile;
	mn_musc[1].item=it_music;
	mn_musc[1].func=domusic;
	mn_musc[2].item=it_voic;
	mn_musc[2].func=dovoic;
	mn_musc[3].item=it_form;
	mn_musc[3].func=doform;
	mn_musc[4].item=it_sys;
	mn_musc[4].func=dosys;
	setienbl(&it_file[MN_SAV],1,!mcount);
	setienbl(&it_music[MN_EDT],1,!mcount);
	setienbl(&it_music[MN_RPL],1,!mdup || !mcount);
	setienbl(&it_music[MN_DEL],2,!mcount);
	setienbl(&it_form[MN_ASTF],1,(usefm+usepsg+usenois == 7));
	setienbl(&it_form[MN_DSTF],1,!mb.part);
	setimnu();
}

/*** load sub ***/

static char* load1(headp,size,name,mask,id)
char *headp;
word size;
char *name;
char *mask;
char *id;
{
	int  i;
	int  f;
	int  ret;

	ret=0;
	if(!name) {
		if(!(name=(char*)selfile(mask,freep,clipp-freep))) goto load_ng;
	}
	ret=-1;
	f=loadfil2(name,headp,size);
	if(!f || f == -1) goto load_ng;
	for_to(i,4) {
		if(*headp++ != *id++) goto load_ng;
	}
	ret=(int)name;
load_ng:
	return((char*)ret);
}

/*** Load Music ***/

flag loadmusc(name)
char *name;
{
	name=load1(mheadp,clipp-(char*)mheadp,name,muscmask,muscid);
	if(!name) goto cancel;
	else if((int)name == -1) goto loaderr;
	mcount=mheadp->count;
	musicp=(char*)mheadp+mheadp->size;
	freep=musicp+sizeof(MBLK);
	if(freep > clipp || freep < musicp) goto loaderr;
	edtmn=0;
	strcpyl(mfilenam,name);
	musicblk(MN_EDT,0);
	return(TRUE);
loaderr:
	dialog(&dg_lodng);
cancel:	
	return(FALSE);
}

static strcpyl(dst,src)
char *dst;
char *src;
{
	int  c;

	while(c = *src++){
		if(c >= 'A' && c <= 'Z') c+='a'-'A';
		*dst++=c;
	}
	*dst=0;
}

/*** Save Music ***/

static savemusc()
{
	HEAD *p;
	int  r;

	r=setname(mfilenam,muscmask+1);
	if(r == -1) goto end_save;
	if(r > 0) drawmenu(&mb_musc);
	p=mheadp;
	strcpy(p,muscid);
	p->count=mcount;
	p->size=musicp-(char*)mheadp;
	savefile(mfilenam,p,p->size);
end_save:;
}

/*** Merge Music ***/

static mergmusc()
{
	word size;
	char *name;
	
	name=load1(musicp,clipp-musicp,NIL,muscmask,muscid);
	if(!name) goto cancel;
	else if((int)name == -1) goto loaderr;
	size=((HEAD*)musicp)->size-HEADSZ;
	edtmn=mcount;
	mcount+=((HEAD*)musicp)->count;
	movemem(musicp+HEADSZ,musicp,size);
	musicp+=size;
	freep=musicp+sizeof(MBLK);
	if(freep > clipp || freep < musicp) goto loaderr;
	musicblk(MN_EDT,edtmn);
	return(TRUE);
loaderr:
	dialog(&dg_lodng);
cancel:	
	return(FALSE);
}

/*** Select Music ***/

static int selmusic(p)
char *p;
{
	int  ret;

	ret=-1;
	dg_msel.ttl=p;
	dg_msel.link=(CTRL*)&sm_msel;
	sm_msel.iall=mcount;
	sm_msel.itop=(edtmn >= sm_msel.idsp) ? edtmn : 0;
	sm_msel.isel=mdup ? edtmn : -1;
	sm_msel.func=prntmnam;
	sm_msel.sbar=&sb_msel;
	if(dialog(&dg_msel) == Q_OK) {
		ret=sm_msel.isel;
	}
	return(ret);
}

/*** Music Record ***/

int musicblk(op,n)
int op;
int  n;
{
	int  size;
	int  ofst;
	char *p;
	MBLK *mp;

	if(n >= 0) mp=mblkptr(n); else mp=(MBLK*)musicp;
	switch(op) {
	case MN_EDT:
		edtmn=n;
		size=mp->size;
		if(musicp+size >= maxp) goto memful;
		freep=musicp+size;
		movemem(mp,&mb,sizeof(MBLK));
		movemem(mp,musicp,size);
		mdup=TRUE;
		initmusc();
		break;	
	case MN_INS:
		if(n >= 0) edtmn=n; else edtmn=mcount;
		mcount++;
		size=ofst=freep-musicp;
		p=(char*)mp;
		goto replace;
	case MN_RPL:
		size=freep-musicp;
		ofst=size-mp->size;
		p=(char*)mp+mp->size;
replace:
		calcbar();
		setnall();
		if(freep+ofst >= clipp) goto memful;
		movemem(p,p+ofst,freep-p);
		ptradj(musicp,ofst);
		musicp+=ofst;
		movemem(musicp,mp,size);
		mb.size=size;
		movemem(&mb,mp,sizeof(MBLK));
		mdup=TRUE;
		break;
	case MN_DEL:
		size=mp->size;
		movemem((char*)mp+size,mp,freep-((char*)mp+size));
		ptradj(musicp,-size);
		musicp-=size;
		if(edtmn > n) {
			edtmn--;
		} else if(edtmn == n) {
			mdup=FALSE;
			if(edtmn == mcount-1) {
				edtmn--;
			}
		}
		mcount--;
		break;
	case MN_REN:
		strcpy(mp->name,sbuf);
		if(edtmn == n) {
			strcpy(mb.name,sbuf);
			drawmnam();
		}
		break;
	case MN_MNEW:
		mb.part=0;
		mb.barlin=2;
		mb.beat=0;
		freep=musicp+sizeof(MBLK);
		mdup=FALSE;
		initmusc();
		break;
	}
	return(0);
memful:
	dialog(&dg_full);
	return(ERROR);
}

/**********************
	Voice edit menu
**********************/

/*** Draw Voice name ***/

drawvnam()
{
	int  wd;
	int  oldfont;

	oldfont=setfont(font16p);
	wd=strwdth(voicname);
	pt_vnam.pat=(char*)&mpatt[0];
	fillrect((640-(VNAMSX+32))/2,0,VNAMSX+32,16,&pt_vnam);
	pn.col=7;
	fillrect((640-(wd+16))/2,0,wd+16,16,NIL);
	gloc((640-wd)/2,1);
	pn.col=0;
	print(voicname);
	setfont(oldfont);
}
	
/*** Do vmenu.file ***/

static dovfile(itm)
int itm;
{
	switch(itm) {
	case MN_LOD:
		if(loadvoic(NIL)) {
			drawvedt();
			initvmnu();
		}
		break;
	case MN_SAV:
		savevoic();
		break;
	case MN_MRG:
		if(mergvoic()) {
			drawvedt();
			initvmnu();
		}
		break;
	case MN_NEW:
		if(dialog(&dg_sure) == Q_YES) {
			vcount=0;
			voicep=(char*)vheadp+HEADSZ;
			edtvn=0;
			initvmnu();
		}
		break;
	case MN_END:
		initmedt();
		break;
	}
}

/*** Get Voice Name Pointer ***/

char *vnameptr(n)
int  n;
{
	return((char*)vheadp+(n*VBLKSZ)+HEADSZ);
}

static prntvnam(n)
int  n;
{
	print("%3d %s",n,vnameptr(n));
}

/*** Do vmenu.voice ***/

static dovoice(itm)
int  itm;
{
	int  n;

	switch(itm) {
	case MN_EDT:
		if((n=selvoice(ttl_vsel)) >= 0) {
			voicerec(MN_EDT,n);
			drawvedt();
		}
		break;
	case MN_RPL:
		if(dialog(&dg_sure) == Q_YES) {
			voicerec(MN_RPL,edtvn);
		}
		break;
	case MN_INS:
		if(vcount >= VCMAX) dialog(&dg_vful);
		else {	
			dg_ins.link=(CTRL*)&tb_ins;
			dg_ins.ttl=tl_ins;
			tb_ins.str=voicname;
			tb_ins.val=VNAMLEN-1;
			if(dialog(&dg_ins) == Q_OK) {
				drawvnam();
				if(vcount) n=selvoice(ttl_ins); else n=-1;
				voicerec(MN_INS,n);
			}
		}
		break;
	case MN_DEL:
		if((n=selvoice(ttl_vsel)) >= 0) {
			if(dialog(&dg_sure) == Q_YES) {
				voicerec(MN_DEL,n);
			}
		}
		break;
	case MN_REN:
		if((n=selvoice(ttl_vsel)) >= 0) {
			dg_ins.link=(CTRL*)&tb_ren;
			dg_ins.ttl=tl_ren;
			strcpy(sbuf,vnameptr(n));
			tb_ren.str=sbuf;
			tb_ren.val=VNAMLEN-1;
			if(dialog(&dg_ins) == Q_OK) {
				voicerec(MN_REN,n);
			}
		}
		break;
	}
	initvmnu();
}

/*** Do vmenu.type ***/

static dovtype(itm)
{
	if(itm != vc.type) {
		vc.type=itm;
		initvch();
		initvmnu();
		drawvedt();	
	}
}

/*** Init Menus ***/

initvmnu()
{
	mb_voic.mnu=&mn_voic[0];
	mb_voic.ttl=vfilenam;
	mn_voic[0].item=it_vfile;	
	mn_voic[0].func=dovfile;
	mn_voic[1].item=it_voice;
	mn_voic[1].func=dovoice;
	mn_voic[2].item=it_vtype;
	mn_voic[2].func=dovtype;
	setienbl(&it_vfile[MN_SAV],1,!vcount);
	setienbl(&it_voice[MN_EDT],1,!vcount);
	setienbl(&it_voice[MN_RPL],1,!vdup || !vcount);
	setienbl(&it_voice[MN_DEL],2,!vcount);
	setimark(&it_vtype[MN_FM],2,vc.type);
}

static initvch()
{
	vch=vc.type*3;
	setsnd(vch,CH_TYPE,vc.type);
}

/*** Load Voice ***/

flag loadvoic(name)
char *name;
{
	name=load1(vheadp,VBUFSZ,name,voicmask,voicid);
	if(!name) goto cancel;
	else if((int)name == -1) goto loaderr;
	vcount=vheadp->count;
	voicep=(char*)vheadp+HEADSZ;
	edtvn=0;
	vdup=FALSE;
	strcpyl(vfilenam,name);
	return(TRUE);
loaderr:
	dialog(&dg_lodng);
cancel:	
	return(FALSE);
}

/*** Save Voice ***/

static savevoic()
{
	HEAD *p;
	int  r;

	r=setname(vfilenam,voicmask+1);
	if(r == -1) goto end_save;
	if(r > 0) {
		drawmenu(&mb_voic);
		drawvnam();
	}
	p=vheadp;
	strcpy(p,voicid);
	p->size=HEADSZ+vcount*VBLKSZ;
	p->count=vcount;
	savefile(vfilenam,p,p->size);
end_save:;
}

/*** Merge Voice ***/

mergvoic()
{
	HEAD *vhp;
	word size;
	char *name;
	
	size=vcount*VBLKSZ+HEADSZ;
	vhp=(HEAD*)((char*)vheadp+size);
	name=load1(vhp,VBUFSZ-size,NIL,voicmask,voicid);
	if(!name) goto cancel;
	else if((int)name == -1) goto loaderr;
	size=vhp->size-HEADSZ;
	vcount+=vhp->count;
	movemem(vhp+1,vhp,size);
	return(TRUE);
loaderr:
	dialog(&dg_lodng);
cancel:	
	return(FALSE);
}

/*** Select Voice ***/

static int selvoice(p)
char *p;
{
	dg_msel.ttl=p;
	sm_msel.itop=(edtvn >= sm_msel.idsp) ? edtvn : 0;
	sm_msel.isel=vdup ? edtvn : -1;
	return((selvoic1(p) == Q_OK) ? sm_msel.isel : -1);
}	

static selvoic1()
{
	dg_msel.link=(CTRL*)&sm_msel;
	sm_msel.iall=vcount;
	sm_msel.func=prntvnam;
	sm_msel.sbar=&sb_msel;
	return(dialog(&dg_msel));
}

int  selvoic2(datp,insm)
int  *datp;
int  insm;
{
	int  ret;
	int  vnum;

	vnum=*datp;
	dg_msel.ttl=ttl_vsel;
	sm_msel.itop=(insm && vnum >= sm_msel.idsp) ? vnum : 0;
	sm_msel.isel=insm ? vnum : -1;
	if(insm) dg_msel.sel=3;
	ret=selvoic1();
	dg_msel.sel=2;
	*datp=sm_msel.isel;
	return(ret);
}

/*** Voice Record ***/

static voicerec(op,n)
int  op;
int  n;
{
	char *vp;

	vp=(char*)vheadp+n*VBLKSZ+HEADSZ;
	switch(op) {
	case MN_EDT:
		edtvn=n;
		voicep=vp;
		strcpy(voicname,vp);
		movemem(vp+VNAMLEN,&vc,sizeof(VREC));
		initvch();
		setvoice(vch,&vc);
		vdup=TRUE;
		break;	
	case MN_INS:
		if(n >= 0) {
			edtvn=n;
			voicep=vnameptr(n);
			movemem(voicep,voicep+VBLKSZ,(vcount-n)*VBLKSZ);
			vnumadj(n,1);
		} else {
			edtvn=vcount;
			voicep=vnameptr(edtvn);
		}
		vcount++;
	case MN_RPL:
		fillmem(voicep,VNAMLEN+2,0);
		strcpy(voicep,voicname);
		movemem(&vc,voicep+VNAMLEN,sizeof(VREC));
		vdup=TRUE;
		break;
	case MN_DEL:
		movemem(vp+VBLKSZ,vp,(char*)vheadp+vcount*VBLKSZ-vp-VBLKSZ+HEADSZ);
		if(edtvn > n) {
			edtvn--;
			voicep-=VBLKSZ;
		} else if(edtvn == n) {
			vdup=FALSE;
			if(edtvn == vcount-1) {
				edtvn--;
				voicep-=VBLKSZ;
			}
		}
		vnumadj(n,-1);
		vcount--;
		break;
	case MN_REN:
		strcpy(vp,sbuf);
		if(edtvn == n) {
			strcpy(voicname,sbuf);
			drawvnam();
		}
		break;
	}
}
