/***********************
	'MET' Voice edit
************************/

#include "std.h"
#include "graf.h"
#include "met.h"
#include "vet.h"

#define BASE_X	18
#define BASE_Y	10
#define BOX_X	17
#define BOX_Y	13	
#define CNCT	7
#define OFS_X	24
#define OFS_Y	16
#define LOP_X	7
#define LOP_Y	7

#define OPW_PX	2
#define OPW_PY	100
#define OPW_SX	312
#define OPW_SY	108
#define OPW_DX	320
#define OPW_DY	112
#define EW_PX	4
#define EW_PY	20	
#define EW_SX	150
#define EW_SY	86
#define FC_PX	40
#define FC_PY	2
#define FC_SX	36
#define FC_SY	14
#define FC_DX	40
#define ER_PX	160
#define ER_PY	10
#define EL_PX	268
#define EL_PY	2
#define SSG_PX	160
#define SSG_PY	86
#define SGW_PX	208
#define SGW_PY	80
#define SGW_SX	40
#define SGW_SY	24
#define SGW_MG	4
#define LFO_PX	320
#define LFO_PY	20
#define LFO_SX	300
#define LFO_SY	72
#define LFW_PX	LFO_PX+16
#define LFW_PY	LFO_PY+24
#define LFP_PX	LFO_PX+64
#define LFP_PY	LFO_PY+4
#define CP_PX	180
#define CP_PY	20
#define CP_SX	120
#define CP_SY	72

#define AR		32
#define	DRMAX	72 
#define RRMAX	112
#define RL		16
#define XR		EW_SX
#define XL		EW_SY
#define BASE	256

typedef struct algrec {
	byte bx;		/* base x */
	byte by;		/* base y */
	byte op[8];		/* OP position */
	char cc;		/* connect count */
	byte cn[6];		/* connect */
	byte tx;		/* term x */
	byte ty1;		/* term y1 */
	byte ty2;		/* term y2 */
} ALDAT;

static ALDAT algdat[8]={
	{ 0,3, 0,0,1,0,2,0,3,0, 3,0,1,1,2,2,3, 3,0,0 },
	{ 1,2, 0,0,0,1,1,0,2,0, 3,0,2,1,2,2,3, 2,0,0 },
	{ 1,2, 1,0,0,1,1,1,2,1, 3,0,3,1,2,2,3, 2,1,1 },
	{ 1,2, 0,0,1,0,1,1,2,0, 3,0,1,1,3,2,3, 2,0,0 },
	{ 2,2, 0,0,1,0,0,1,1,1, 2,0,1,2,3,0,0, 1,0,1 },
	{ 2,1, 0,1,1,0,1,1,1,2, 3,0,1,0,2,0,3, 1,0,2 },
	{ 2,1, 0,0,1,0,1,1,1,2, 1,0,1,0,0,0,0, 1,0,2 },
	{ 3,0, 0,0,0,1,0,2,0,3, 0,0,0,0,0,0,0, 0,0,3 }
};

static word bx,by;
static bps_x[4];
static bps_y[4];
static int  metroc;

static RECT ctr_w={ CP_PX,CP_PY,CP_SX,CP_SY };
static BTNS bt_rep={ CT_RBTN,0,CP_PX+24,CP_PY+8,0,0,1,HZ };
static BTN  rb_rep={ "Repeat",0,0,0 };
static SBAR sb_tmp={
	CT_SBAR,0,CP_PX+6,CP_PY+28,"Tmp",26,HZ,32,16,16,0,2,0,2 };
static SBAR sb_vol={
	CT_SBAR,0,CP_PX+6,CP_PY+48,"Vol",26,HZ,32,16,16,0,2,0,2 };

static RECT alg_w={ 8,20,120,72 };
static RECT alg_r={ 8,20,32,16 };
static char alg_n[]="AL%d";
static RECT fb_w={ 136,20,32,72 };
static SBAR sb_fb={ CT_SBAR,0,144,22,"FB",0,VT,16,8,8,0,2,0,1 };

static RECT lfo_w={ LFO_PX,LFO_PY,LFO_SX,LFO_SY };
static RECT lfo_r={ LFO_PX,LFO_PY,32,16 };
static RECT lfw_r={ LFW_PX,LFW_PY,SGW_SX,SGW_SY };
static char lfo_n[]="LFO";
static SBAR	sb_lfsp={
	CT_SBAR,0,LFP_PX,LFP_PY,"SP",24,HZ,144,16,256,0,10,0,3 };
static SBAR	sb_lfpm={
	CT_SBAR,0,LFP_PX,LFP_PY+16,"PM",24,HZ,144,16,128,0,10,0,3 };
static SBAR	sb_lfam={
	CT_SBAR,0,LFP_PX,LFP_PY+32,"AM",24,HZ,144,16,128,0,10,0,3 };
static BTNS bt_lfop={ CT_RBTN,0,LFP_PX,LFP_PY+50,"AME",0,4,HZ,8 };
static BTN  rb_lfop[4]={
	{ "OP1",0,0,0 },
	{ "OP2",0,0,0 },
	{ "OP3",0,0,0 },
	{ "OP4",0,0,0 }
};

static RECT op_w[4]={
	{ OPW_PX,OPW_PY,OPW_SX,OPW_SY }, 
	{ OPW_PX+OPW_DX,OPW_PY,OPW_SX,OPW_SY },
	{ OPW_PX,OPW_PY+OPW_DY,OPW_SX,OPW_SY },
	{ OPW_PX+OPW_DX,OPW_PY+OPW_DY,OPW_SX,OPW_SY }
};
static RECT op_r={ 0,0,32,16 };
static char op_n[]="OP%d";
static RECT fc_r[3]={
	{ FC_PX,FC_PY,FC_SX,FC_SY },
	{ FC_PX+FC_DX,FC_PY,FC_SX,FC_SY },
	{ FC_PX+FC_DX*2,FC_PY,FC_SX,FC_SY }
};
static SBAR sb_env[6]={
	{ CT_SBAR,0,ER_PX,ER_PY,	"AR",0,HZ,40,8,32,0,5,0,2,0,0,0 }, 
	{ CT_SBAR,0,ER_PX,ER_PY+16,	"DR",0,HZ,40,8,32,0,5,0,2,0,0,0 }, 
	{ CT_SBAR,0,ER_PX,ER_PY+32,	"SR",0,HZ,40,8,32,0,5,0,2,0,0,0 }, 
	{ CT_SBAR,0,ER_PX,ER_PY+48,	"RR",0,HZ,40,8,16,0,2,0,2,0,0,0 }, 
	{ CT_SBAR,0,EL_PX,EL_PY,	"TL",0,VT,40,8,128,0,10,0,3,0,0,0 },
	{ CT_SBAR,0,EL_PX+24,EL_PY,	"SL",0,VT,40,8,16,0,2,0,2,0,0,0 },
};

static rate[32]={
	0,1,2,3,4,6,8,11,16,23,32,45,64,91,128,181,256,362,512,724,1024,
	1448,2048,2896,4096,5793,8192,11585,16384,23170,32768,46341
};

static RECT ssg_r={ SGW_PX,SGW_PY,SGW_SX,SGW_SY };
static int  ssgwv[8][4]={
	{ 1,2,3,4 },
	{ 1,2,4,0 },
	{ 1,2,5,0 },
	{ 1,2,3,5 },
	{ 3,2,5,4 },
	{ 3,5,0,0 },
	{ 3,4,0,0 },
	{ 3,2,4,0 }
};

enum op_item {
	FC_FQ,
	FC_DT,
	FC_KS,
	EV_AR,
	EV_DR,
	EV_SR,
	EV_RR,
	EV_TL,
	EV_SL,
	EV_SSG
};
	
enum linestil {
	SOLID,
	DOTTED
};

VREC vc;

/*** Interval proc ***/

metro()
{
	if(rb_rep.mode) {
		if(--metroc <= 0) {
			skeyon(vch);
			metroc=(18-sb_tmp.val)*5;
		}
	}
}

/*** Draw Voice edit ***/

initvedt()
{
	vedit=TRUE;
	rb_rep.mode=0;
	oncrtv(&metro,3);
	initvmnu();
	initsnd();
	setvoice(vch,&vc);
	setmvolm(mastvolm);
	drawvedt();	
}

drawvedt()
{
	mousoff();
	fillrect(0,0,640,400,&bak_s);
	drawmenu(&mb_voic);
	drawvnam();
	drawctr();
	if(!vc.type) {
		drawalg();
		drawfb();
		drawfmop();
	}
	drawlfo();
	drawkbd();
	mouson();
}

int do_vedt()
{
	int  f;

	f=TRUE;
	if(domenu(&mb_voic)) goto end_vedt;
	if(do_ctr()) goto end_vedt;
	if(!vc.type) {
		if(do_alg()) goto end_vedt;
		if(do_fb()) goto end_vedt;
		if(do_op()) goto end_vedt;
	}
	if(do_lfo()) goto end_vedt;
	if(do_kbd()) goto end_vedt;
	f=FALSE;
end_vedt:
	return(f);
}

/********************
	Control Panel
********************/

/*** Draw Controls ***/

static drawctr()
{
	mousoff();
	pn.col=7;
	drawrect(&ctr_w,2);
	sb_vol.val=mastvolm;
	drawsbar(&sb_vol);
	bt_rep.btnp=&rb_rep;
	drawrbtn(&bt_rep);
	drawsbar(&sb_tmp);
	mouson();
}

/*** Do Controls ***/

static int  do_ctr()
{
	flag f; 

	f=TRUE;
	if(do_sbar(&sb_vol)) {
		mastvolm=sb_vol.val;
		setmvolm(mastvolm);
	} else if(do_sbar(&sb_tmp)) {
	} else if(do_rbtn(&bt_rep)) {
	} else f=FALSE;
	return(f);
}

/************************
	Algorism/Feedback
************************/

/*** Draw Algorism ***/

static drawalg()
{
	int  i;
	int  alg;
	int  a1,a2;
	int  tc;
	word tym;
	word x,y;
	byte *p;
	ALDAT *al;

	mousoff();
	pn.col=7;
	drawrect(&alg_w,2);
	pn.col=0;
	alg=vc.fm_fbal & 7;
	drawrttl(&alg_r,alg_n,alg);

	al=&algdat[alg];
	bx=alg_w.px+al->bx*(OFS_X/2)+BASE_X;
	by=alg_w.py+al->by*(OFS_Y/2)+BASE_Y;
	p=(byte*)&al->op[0];
	for_to(i,4) {
		drawop(i,TRUE);
	}
	p=(byte*)&al->cn[0];
	for_to(i,al->cc) {
		a1=*p++;
		a2=*p++;
		line(bps_x[a1]+BOX_X,bps_y[a1]+BOX_Y/2,bps_x[a2],bps_y[a2]+BOX_Y/2);
	}
	x=bx+al->tx*OFS_X+BOX_X;
	tc=0;
	tym=0;
	if(al->ty1 == al->ty2) {
		y=by+al->ty1*OFS_Y+BOX_Y/2;
		line(x,y,x+CNCT,y);
	}
	else {
		for(i=al->ty1; i<=al->ty2; i++) {
			y=by+i*OFS_Y+BOX_Y/2;
			line(x,y,x+CNCT,y);
			tym+=y;
			tc++;
		}	
		x+=CNCT;
		line(x,by+al->ty1*OFS_Y+BOX_Y/2,x,by+al->ty2*OFS_Y+BOX_Y/2);
		y=tym/tc;
		line(x,y,x+CNCT,y);
	}
	mouson();
}

/*** Draw Operator ***/

static drawop(op,mod)
int  op;
flag mod;
{
	word x,y;
	ALDAT *al;

	al=&algdat[vc.fm_fbal&7];
	bps_x[op]=x=bx+(al->op[op*2])*OFS_X;
	bps_y[op]=y=by+(al->op[op*2+1])*OFS_Y;
	if(vc.fm_opm & (1<<op)) {
		pn.col=0;
		fillrect(x,y,BOX_X,BOX_Y,NIL);
		pn.col=7;
	}
	else {
		pn.col=7;
		fillrect(x,y,BOX_X,BOX_Y,NIL);
		pn.col=0;
		framerct(x,y,BOX_X,BOX_Y);
	}
	gloc(x+4,y+1);
	pchr('1'+op);
	pn.col=0;
	if(mod && !op) {
		line(x+BOX_X/2,y,x+BOX_X/2,y-LOP_Y);
		line(x+BOX_X/2,y-LOP_Y,x-LOP_X,y-LOP_Y);
		line(x-LOP_X,y-LOP_Y,x-LOP_X,y+BOX_Y/2);
		line(x-LOP_X,y+BOX_Y/2,x,y+BOX_Y/2);
	}
}

/*** Draw Title ***/

static drawrttl(rct,ttl,val)
RECT *rct;
char *ttl;
int  val;
{
	int  oldfont;

	oldfont=setfont(font16p);
	pn.col=7;
	drawrect(rct,1);
	gloc(rct->px,rct->py);
	pn.col=0;
	print(ttl,val);
	setfont(oldfont);
}

/*** Do Algorism ***/

static do_alg()
{
	word x,y;
	byte al;
	int  i;

	x=msrec.px;
	y=msrec.py;
	if(!inrects(x,y,&alg_w)) return(FALSE);
	if(msrec.evnt & MS_LDN+MS_RDN) {
		if(inrects(x,y,&alg_r)) {
			al=vc.fm_fbal & 7;
			if(msrec.evnt & MS_LDN) al=(++al)&7;
        	else al=(--al)&7;
        	vc.fm_fbal&=~7;
        	vc.fm_fbal|=al;
        	setsnd(vch,FM_FBAL,vc.fm_fbal);
        	drawalg();
        }
		else {
			for_to(i,4) {
				if(inrect(x-bps_x[i],y-bps_y[i],BOX_X,BOX_Y)) {
					vc.fm_opm^=(1<<i);
					mousoff();
					drawop(i,FALSE);
					mouson();
					setsnd(vch,FM_OPM,vc.fm_opm);
					break;
				}
			}
		}
	}
	return(TRUE);
}					

/*** Draw Feedback ***/

static int cv_fb(val)
int  val;
{
	return(7-val);
}

static drawfb()
{
	mousoff();
	pn.col=7;
	drawrect(&fb_w,2);
	pn.col=0;
	sb_fb.val=7-((vc.fm_fbal & 0x38) >> 3);
	sb_fb.func=cv_fb;
	drawsbar(&sb_fb);
	mouson();
}

/*** Do Feedback ***/

static do_fb()
{
	int  f;

	if((f=do_sbar(&sb_fb)) > 0) {
		vc.fm_fbal&=~0x38;
		vc.fm_fbal|=7-sb_fb.val << 3;
		setsnd(vch,FM_FBAL,vc.fm_fbal);
	}
	return(f);
}


/***************
	Operator
****************/

/*** Get/Set Value ***/

byte getval(op,n)
int  op;
int  n;
{
	byte val;	

	switch(n) {
	case FC_FQ:
		val=vc.fm_dtml[op] & 0x0F;
		break;
	case FC_DT:
		val=(vc.fm_dtml[op] & 0x70)>>4;
		break;
	case FC_KS:
		val=(vc.fm_ksar[op] & 0xC0)>>6;
		break;
	case EV_AR:
		val=vc.fm_ksar[op] & 0x1F;
		break;
	case EV_DR:
		val=vc.fm_dr[op];
		break;
	case EV_SR:
		val=vc.fm_sr[op];
		break;
	case EV_RR:
		val=vc.fm_slrr[op] & 0x0F;
		break;
	case EV_TL:
		val=vc.fm_tl[op];
		break;
	case EV_SL:
		val=(vc.fm_slrr[op] & 0xF0)>>4;
		break;
	case EV_SSG:
		val=vc.fm_ssg[op];
		break;
	}
	return(val);
}

setval(op,n,val)
int  op;
int  n;
byte val;
{
	int  reg;
	int  dat;

	switch(n) {
	case FC_FQ:
		vc.fm_dtml[op]&=~0x0F;
		dat=(vc.fm_dtml[op]|=val);
		reg=FM_DTML;
		break;
	case FC_DT:
		val<<=4;
		vc.fm_dtml[op]&=~0x70;
		dat=(vc.fm_dtml[op]|=val);
		reg=FM_DTML;
		break;
	case FC_KS:
		val<<=6;
		vc.fm_ksar[op]&=~0xC0;
		dat=(vc.fm_ksar[op]|=val);
		reg=FM_KSAR;
		break;
	case EV_AR:
		vc.fm_ksar[op]&=~0x1F;
		dat=(vc.fm_ksar[op]|=val);
		reg=FM_KSAR;
		break;
	case EV_DR:
		dat=vc.fm_dr[op]=val;
		reg=FM_DR;
		break;
	case EV_SR:
		dat=vc.fm_sr[op]=val;
		reg=FM_SR;
		break;
	case EV_RR:
		vc.fm_slrr[op]&=~0x0F;
		dat=(vc.fm_slrr[op]|=val);
		reg=FM_SLRR;
		break;
	case EV_TL:
		dat=vc.fm_tl[op]=val;
		reg=FM_TL;
		break;
	case EV_SL:
		val<<=4;
		vc.fm_slrr[op]&=~0xF0;
		dat=(vc.fm_slrr[op]|=val);
		reg=FM_SLRR;
		break;
	case EV_SSG:
		dat=vc.fm_ssg[op]=val;
		reg=FM_SSG;
		break;
	}
	setsnd(vch,reg+op,dat);
}

/*** Draw Opearator ***/

static drawfmop()
{
	int  i;

	mousoff();
	for_to(i,4) drawop1(i);
	mouson();
}

static drawop1(op)
int  op;
{
	int  i;
	RECT oldrct;

	pn.col=7;
	drawrect(&op_w[op],2);
	pn.col=0;
	setwind(&op_w[op],&oldrct);
	drawrttl(&op_r,op_n,op+1);
	for_to(i,3) {
		drawopf(op,i);
	}
	shaderct(EW_PX,EW_PY,EW_SX,EW_SY,0);
	drawenvw(op);
	for_to(i,6) {
		drawenvs(op,i);
	}
	drawssg(getval(op,EV_SSG));
	reswind(&oldrct);
}

/*** Draw Op func ***/

static drawopf(op,n)
int  op;
int  n;
{
	byte val;

	mousoff();
	pn.col=7;
	drawrect(&fc_r[n],0);
	gloc(fc_r[n].px,fc_r[n].py+2);
	pn.col=0;
	val=getval(op,n);
	switch(n) {
	case FC_FQ:
		if(val) print("Fq%2d",val);
		else print("Fq.5");
		break;
	case FC_DT:
		if(val == 0 || val == 4) print("Dt 0");
		else if(val < 4) print("Dt+%d",val);
		else print ("Dt-%d",val-4);
		break;
	case FC_KS:
		print("Ks %d",val);
		break;
	}
	mouson();
}

/*** Draw Op Env ***/

static drawenvs(op,n)
int  op;
int  n;
{
	sb_env[n].val=getval(op,n+3);
	drawsbar(&sb_env[n]);
}

/*** Do Opearator ***/

static do_op()
{
	int  i;
	flag f;

	f=FALSE;
	for_to(i,4) {
		if(f=do_op1(i)) break;
	}
	return(f);
}

static do_op1(op)
int  op;
{
	word x,y;
	int  i;
	int  wave;
	flag inc;
	byte val;
	RECT oldrct;

	x=msrec.px;
	y=msrec.py;
	if(!inrects(x,y,&op_w[op])) return(FALSE);
	if(msrec.evnt & MS_LDN+MS_RDN) {
		if(msrec.evnt & MS_LDN) inc=TRUE; else inc=FALSE;
		setwind(&op_w[op],&oldrct);
		x-=op_w[op].px;
		y-=op_w[op].py;
		msrec.px=x;
		msrec.py=y;
		for_to(i,3) {
			if(inrects(x,y,&fc_r[i])) {
				val=getval(op,i);
				switch(i) {
				case FC_FQ:
					if(inc) {
						if(val < 15) val++;
					} else {
						if(val) val--;
					}
					break;
				case FC_DT:
					if(inc) {
						if(val == 5) val=0;
						else if(val > 4) val--;
						else if(val < 3) val++;
					} else {
						if(val == 0) val=5;
						else if(val < 4) val--;
						else if(val < 7) val++;
					}
					break;
				case FC_KS:
					if(inc) {
						if(val < 3) val++;
					} else {
						if(val) val--;
					}
					break;
				}
				setval(op,i,val);
				drawopf(op,i);
				goto end_do;
			}
		}
		for_to(i,6) {
			sb_env[i].val=getval(op,i+3);
		}
		for_to(i,6) {
			if(do_sbar(&sb_env[i]) > 0) {
				setval(op,i+3,sb_env[i].val);
				drawenvw(op);
				goto end_do;
			}
		}
		wave=dowave(&ssg_r,getval(op,EV_SSG));
		if(wave >= 0) setval(op,EV_SSG,wave);
end_do:
		reswind(&oldrct);
	}
	return(TRUE);
}

/**************************
	'VET' Draw Envelope
**************************/

/*** Draw Env line ***/

static envline(x1,y1,x2,y2,stile)
word x1,y1,x2,y2;
enum linestil stile;
{
	int  oldlin;

	oldlin=pn.lin;
	switch(stile) {
	case SOLID:
		pn.lin=0xFFFF;
		break;
	case DOTTED:
		pn.lin=0xCCCC;
		break;
	}
	pn.col=0;
	line(x1+EW_PX, EW_PY+EW_SY-y1, x2+EW_PX, EW_PY+EW_SY-y2);
	pn.lin=oldlin;
}
	
/*** Draw Envelope ***/

static drawenvw(op)
int  op;
{
	int  b;
	int  x,y;
	word a,d,s,r;
	word dr,rr,rl;
	word tl,sl;

	pn.col=7;
	fillrect(EW_PX,EW_PY,EW_SX,EW_SY,NIL);
	
	tl=XL-getval(op,EV_TL);
	if(tl > XL) tl=0;
	sl=tl-getval(op,EV_SL)*4;
	if(sl > XL) sl=0;
	rl=sl-RL;
	if(rl > XL) rl=0;
	envline(0,tl,XR,tl,DOTTED);
	envline(0,sl,XR,sl,DOTTED);

	a=getval(op,EV_AR);
	if(!a) goto end_env;
	a=rate[a];
	b=tl-muldiv(AR,a,BASE);
	if(b > 0) {
		x=0;
		y=b;
	} else {
		x=AR-muldiv(tl,BASE,a);
		y=0;
	}
	envline(AR,0,AR,tl,DOTTED);
	envline(x,y,AR,tl,SOLID);
	
	if(tl == sl) {
		dr=AR;
	} else {
		d=getval(op,EV_DR);
		if(d) {
			d=rate[d];
			x=muldiv(tl-sl,BASE,d)+AR;
			if(x < DRMAX) y=sl;
			else {
				x=DRMAX;
				y=tl-muldiv(DRMAX-AR,d,BASE);	
			}
		} else {
			x=DRMAX;
			y=tl;
		}
		dr=x;
		envline(x,sl,x,y,DOTTED);
		envline(AR,tl,x,y,SOLID);
	}

	if(sl > 0) {
		s=getval(op,EV_SR);
		if(s) {
			s=rate[s];
			x=muldiv(sl-rl,BASE,s)+dr;
			if(x < RRMAX) y=rl;
			else {
				x=RRMAX;
				y=sl-muldiv(RRMAX-dr,s,BASE);	
			}
		} else {
			x=RRMAX;
			y=sl;
		}
		rr=x;
		rl=y;
		envline(x,0,x,tl,DOTTED);
		envline(dr,sl,x,y,SOLID);

		if(rl > 0) {
			r=rate[getval(op,EV_RR)*2+1];
			y=rl-muldiv(XR-rr,r,BASE);
			if(y > 0) x=XR;
			else {
				x=rr+muldiv(rl,BASE,r);
				y=0;
			}
			envline(rr,0,rr,tl,DOTTED);
			envline(rr,rl,x,y,SOLID);
		}
	}
end_env:
}

/*** SSG Envelope ***/

static drawssg(val)
int  val;
{
	mousoff();
	gloc(SSG_PX,SSG_PY);
	pn.col=0;
	print("SSGenv");
	drawwave(&ssg_r,val);
	mouson();
}

static drawwave(rp,val)
RECT *rp;
int  val;
{
	int  x1,y1,x2,y2;
	int  i;
	int  d;

	mousoff();
	pn.col=7;
	drawrect(rp,0);
	pn.col=0;
	if(val&0x08) {
		val&=7;
		x1=rp->px+SGW_MG;
		y1=rp->py+SGW_SY-SGW_MG;
		for_to(i,4) {
			if(!(d=ssgwv[val][i])) break;
			x2=(d>>1)*(SGW_SX/2-SGW_MG)+rp->px+SGW_MG;
			y2=(d&1) ? rp->py+SGW_MG : rp->py+SGW_SY-SGW_MG;
			line(x1,y1,x2,y2);
			x1=x2; y1=y2;
		}
	} else {
		gloc(rp->px+(SGW_SX-24)/2,rp->py+(SGW_SY-10)/2);
		print("OFF");
	}
	mouson();
}

static int dowave(rp,val)
RECT *rp;
int  val;
{
	int  ret;

	ret=-1;
	if(inrects(msrec.px,msrec.py,rp)) {
		if(msrec.evnt & MS_LDN+MS_RDN) {
			if(msrec.evnt & MS_LDN) {
				if(val) {
					if(++val > 15) val=0;
				} else val=8;
			} else {
				if(val) {
					if(--val < 8) val=0;
				} else val=15;
			}
			drawwave(rp,val);
			ret=val;
		}
	}
	return(ret);
}

/*** LFO ***/

static drawlfo()
{
	int  i;
	int  btst;

	pn.col=7;
	drawrect(&lfo_w,2);
	drawrttl(&lfo_r,lfo_n);
	drawwave(&lfw_r,vc.lfo_wv);
	sb_lfsp.val=vc.lfo_sp;
	drawsbar(&sb_lfsp);
	sb_lfpm.val=vc.lfo_pm;
	drawsbar(&sb_lfpm);
	sb_lfam.val=vc.lfo_am;
	drawsbar(&sb_lfam);
	bt_lfop.btnp=&rb_lfop[0];
	btst=1;
	for_to(i,4) {
		rb_lfop[i].mode=vc.type ? MD_INACT : ((vc.lfo_aop & btst) ? MD_ON : 0);
		btst<<=1;
	}
	drawrbtn(&bt_lfop);
}

static do_lfo()
{
	int  i;
	int  wave;
	int  btst;
	flag f;

	f=FALSE;
	if(!inrects(msrec.px,msrec.py,&lfo_w)) goto end_lfo;
	f=TRUE;
	if(do_sbar(&sb_lfsp) > 0) {
		setsnd(vch,LFO_SP,vc.lfo_sp=sb_lfsp.val);
	} else if(do_sbar(&sb_lfpm) > 0) {
		setsnd(vch,LFO_PM,vc.lfo_pm=sb_lfpm.val);
	} else if(do_sbar(&sb_lfam) > 0) {
		setsnd(vch,LFO_AM,vc.lfo_am=sb_lfam.val);
	} else if(do_rbtn(&bt_lfop)) {
		btst=1;
		for_to(i,4) {
			if(rb_lfop[i].mode & MD_ON) {
				vc.lfo_aop|=btst;
			} else {
				vc.lfo_aop&=~btst;
			}
			btst<<=1;
		}
		setsnd(vch,LFO_AOP,vc.lfo_aop);
	} else {
		wave=dowave(&lfw_r,vc.lfo_wv);
		if(wave >= 0) setsnd(vch,LFO_WV,vc.lfo_wv=wave);
	}
end_lfo:
	return(f);
}
