/***********************
	'VET' Play Piano
***********************/

#include "std.h"
#include "graf.h"
#include "met.h"
#include "vet.h"

#define KB_PX	24
#define KB_PY	332
#define KB_WX	12
#define KB_WY	56
#define KB_BX	8
#define KB_BY	32
#define KB_DX	(KB_WX-KB_BX/2)
#define KB_OCT	7
#define KB_SX	(KB_WX*KB_OCT*7)
#define KB_SY	KB_WY

static RECT kbd_w={ KB_PX,KB_PY,KB_SX,KB_SY };
static int  tone_b[7]={ 0,1,-1,3,4,5,-1 };

/*** Draw Keyboard ***/

drawkbd()
{
	word x;
	int  i,j;

	mousoff();
	pn.col=7;
	drawrect(&kbd_w,2);
	pn.col=0;
	for(x=KB_PX+KB_WX; x<KB_PX+KB_SX; x+=KB_WX) {
		line(x,KB_PY,x,KB_PY+KB_WY);
	}	
	x=KB_PX+KB_DX;
	pn.col=0;
	for_to(i,KB_OCT) {
		for_to(j,7) {
			if(j != 2 && j !=6) { 
				fillrect(x,KB_PY,KB_BX,KB_BY,NIL);
			}
			x+=KB_WX;
		}
	}
	mouson();
}

/*** Set tone from x,y ***/

static int gettone(x,y)			
word x,y;
{
	int  oct;
	int  tone;

	oct=x/(KB_WX*7)+1;
	if(y > KB_BY) {
		tone=(x/KB_WX)%7;
	} else {
		tone=tone_b[((x-KB_DX)/KB_WX)%7]|0x40;
	}
	if(tone != -1) tone|=oct<<3;
	return(tone);
}				

/*** Invert keyboard ***/

static invkbd(x,y)			
word x,y;
{
	mousoff();
	if(y > KB_BY) {
		x/=KB_WX;
		invrect(x*KB_WX+KB_PX+1, KB_PY+KB_BY+1, KB_WX-1, KB_WY-KB_BY-1);
	} else {
		x=(x-KB_DX)/KB_WX;
		invrect(x*KB_WX+KB_PX+KB_DX+1, KB_PY, KB_BX-2, KB_BY-1);
	}		
	mouson();
}

/*** Do Keyboard ***/

int do_kbd()
{
	word x,y;
	int  tone;
	flag inkbd;
	static word xs,ys;
	static flag keyon;
	static flag echo;
	static int	tones; 

	inkbd=inrects(msrec.px,msrec.py,&kbd_w);
	if(inkbd && msrec.btn & MS_LON) {
		x=msrec.px-KB_PX;
		y=msrec.py-KB_PY;
		tone=gettone(x,y);
		if(tone == -1) goto offkey;
		if(!keyon) goto onkey;
		if(tone == tones) goto keep;
		invkbd(xs,ys);
onkey:		
		invkbd(x,y);
		tones=tone;
		xs=x;
		ys=y;
		keyon=TRUE;
		outsnd(tone);
	} else {
offkey:
		if(keyon) {		
			invkbd(xs,ys);
			keyon=FALSE;
			echo=TRUE;
		}
		if(echo) {
			if(!(inkbd && msrec.btn & MS_RON)) {
				skeyoff(vch);
				echo=FALSE;
			}
		}
	}
keep:
	return(inkbd);
}

/*** Output Sound ***/

outsnd(dat)
int  dat;
{
	setsnd(vch,CH_VOLM,12);
	setsnd(vch,CH_TONE,dat);
	skeyon(vch);
}
