/************************
	'SF' Area handler
************************/

#include "std.h"
#include "sf.h"

#define STKSZ	32
#define ATBLSZ	128

typedef struct treerec {
	char n1;
	char n2;
} TREE;

extern TREE *areatbl;

/*** Compare area No. ***/

TREE* chknp(n)
int  n;
{
	return(n < ATBLSZ ? NIL : areatbl+(n-ATBLSZ));
}

flag inarea(n,m)
int  n,m;
{
	TREE *p1,*p2;	
	static TREE *stk1[STKSZ];
	int  sp;
    
	sp=0;    
	if(!n || !m) return(FALSE);
	loop {
		if(cmpno(m,n)) goto true1;
		if(p1=chknp(n)) {
label1:	
			n=p1->n1;
			if(cmpno(m,n)) goto true1;
			if(p2=chknp(n)) {
				n=p1->n2;
				if(cmpno(m,n)) goto true1;
				stk1[sp++]=chknp(n);
				p1=p2;
				goto label1;
			} else {
				n=p1->n2;
				continue;
			}
		} else {
			if(sp) {
				p1=stk1[--sp];
				goto label1;
			} else return(FALSE);
		}
	}
true1:
	return(TRUE);
}

static flag cmpno(n,m)
int  n,m;
{
	TREE *p1,*p2;	
	static TREE *stk2[STKSZ];
	int  sp;
    
	sp=0;    
	loop {
		if(n == m) goto true2;
		if(p1=chknp(n)) {
label2:		n=p1->n1;
			if(n == m) goto true2;
			if(p2=chknp(n)) {
				n=p1->n2;
				if(n == m) goto true2;
				stk2[sp++]=chknp(n);
				p1=p2;
				goto label2;
			} else {
				n=p1->n2;
				continue;
			}
		} else {
			if(sp) {
				p1=stk2[--sp];
				goto label2;
			} else return(FALSE);
		}
	}
true2:
	return(TRUE);
}

