/**************************
	'PET' Pattern Editor
**************************/

#include "std.h"
#include "graf.h"
#include "pet.h"

static int  tubcol=-1;
static int  mixcol;
static word tub_x=12*8;
static word tub_y=5*8;
static int  mixpat[3]={ 0x8020,0xA050,0xB0E0 };
static int  mixpat1[6]={ 0x8888,0x2222,0xAAAA,0x5555,0xBBBB,0xEEEE };
static int  mixpat2[12]={ 0x8888,0x8888,0x2222,0x2222,0xAAAA,0xAAAA,
					      0x5555,0x5555,0xBBBB,0xBBBB,0xEEEE,0xEEEE };

/*** Mix Color ***/

mixcolor(pal,col)
int  pal;
int  col;
{
	MIXP *p;
	int  *pn;
	int  i;
	int  tst;
	int  dat;
	int  set;
	int  bit;
	
	p=&mixpal[pal];
	if(col == -1) col=p->col1;
	else {	
		if(col == p->col1) {
			if(p->rate) p->rate--;
		}
		else if(p->rate) {
			if(col == p->col2) {
				if(++p->rate == 4) p->rate=0;
			}
			else p->rate=0;
		}
		else if(palet[p->col1] != 8 && palet[col] !=8) {
			p->col2=col;
			p->rate++;
		}
	}
	if(!(p->rate)) {
		p->col1=col;
		setcolor(col);
	}
	else {
		pn=patpn;
		dat=mixpat[p->rate-1];
		tst=1;
		for(i=0; i<plane; i++) {
			bit=0;
			if(p->col1 & tst) bit|=1;
			if(p->col2 & tst) bit|=2;
			switch(bit) {
			case 0:
				set=0;
				break;
			case 1:
				set=~dat;
				break;
			case 2:
				set=dat;
				break;
			case 3:
				set=-1;
				break;
			}
			*pn++=set;
			*pn++=set;
			tst<<=1;
		}
	}
}
	
/*** Set Color ***/	

setcolor(col)
int  col;
{
	int  i;
	int  tst;
	int  set;
	int  *pn;
	
	pn=patpn;
	tst=1;
	for(i=0; i<plane; i++) {
		if(col & tst) set=-1; else set=0;
		*pn++=set;
		*pn++=set;
		tst<<=1;
	}
}	
		
/*** Draw Mix-color Box ***/

drawmbox()
{
	word x,y;
	
	for(y=0; y<4/(vsize+1); y++) {
		for(x=0; x<4; x++) {
			drawpix(x,y,palbx_x,pal_y,&pen_rec,FALSE);
		}
	}
	shaderct(palbx_x,pal_y,32,32,2);
}

/*** Draw Source Palet ***/

drawspal(pal)
int  pal;
{
	word x;
	PATT *patn;
	
	pn.col=palet[pal];
	if(pn.col == 8) patn=&bak_s; else patn=NIL;
	x=pal_x+pal*24;
	fillrect(x,pal_y,16,16,patn);
	shaderct(x,pal_y,16,16,2);
}

/*** Draw Mix Palet ***/

drawmpal(pal)
int  pal;
{
	MIXP *p;
	word x;
	int  col1;
	int  col2;
	PATT *patn;
	
	p=&mixpal[pal];
	x=pal_x+pal*24;
	col1=palet[p->col1];
	col2=palet[p->col2];
	if(p->rate) {
		patn=&mix_s;
		mix_s.col0=col1;
		mix_s.col1=col2;
		if(vsize) {
			mix_s.pat=(char*)&mixpat2[(p->rate-1)*4];
			mix_s.sy=4;
		}
		else {
			mix_s.pat=(char*)&mixpat1[(p->rate-1)*2];
			mix_s.sy=2;
		}
	}	
	else if(col1 == 8) patn=&bak_s;
	else {
		pn.col=col1;
		patn=NIL;
	}
	fillrect(x,pal_y+24,16,16,patn);
	shaderct(x,pal_y+24,16,16,2);
}

/*** Do Mix palet ***/

int do_palet()
{
	word x;
	word y;
	int  pal;
	int  col;
	
	x=(msrec.px-pal_x)/8;
	y=(msrec.py-pal_y)/8;
	if(!inrect(x,y,23,5)) return(FALSE);
	if((msrec.evnt & (MS_RDN+MS_LDN)) && x%3 != 2 && y != 2) {
		pal=x/3;
		if(y < 2) {
			if(pal >= palmax) return(TRUE);
			if(msrec.evnt & MS_LDN) {
				setcolor(pal);
				drawmbox();
				mixcol=pal;
			}
			else if(tubcol >=0) {
				palet[pal]=tubcol;
				tubcol=-1;
				drawall();
			}
		}
		else {
			if(msrec.evnt & MS_LDN) col=-1; else col=mixcol;
			mixcolor(pal,col);
			mousoff();
			drawmpal(pal);
			mouson();
			drawmbox();
		}
	}
	return(TRUE);
}

/*** Draw tubes ***/

drawtube()
{
	int  i;
	
	shaderct(tub_x-8,tub_y-4,154,18,2);
	for(i=0; i<9; i++) {
		if(i) {
			pn.col=i-1;
			fillrect(tub_x+i*16,tub_y,10,10,0);
		}
		shaderct(tub_x+i*16,tub_y,10,10,1);
	}
}

/*** Do Paint tube ***/

int do_tube()
{
	word x;
	word y;
	int  altcol;
	
	x=msrec.px-tub_x;
	y=msrec.py-tub_y;
	if(!inrect(x,y,16*9,10)) return(FALSE);
	if((x&15) < 10) {
	 	x=x/16;
		if(msrec.evnt & MS_LDN) {
		 	tubcol=(x ? x-1 :8);
		 	flushrct(x*16+tub_x,tub_y,10,10);
		 }
		 else if((msrec.evnt & MS_RDN) && (tubcol >= 0)) {
		 	altcol=(x ? x-1 :8);
		 	movemem(patwk,patbk,384);
			movemem(pixtbl,uratbl,16);
			for_to(y,ssiz_y) {
				for_to(x,ssiz_x) {
					if(getpix(x,y,&edt_rec) == tubcol) {
						setpix(x,y,&edt_rec,altcol);
					}
				}
			}
			drawebox();
		}
	}
	return(TRUE);
}
