/**************************
	'PET' Do Edit Proc
**************************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define TL_LIN 1
#define TL_BOX 2
#define TL_CPY 3

static int  pre_x;
static int  pre_y;
static word bx0;
static word by0;
static word bx;
static word by;
static flag drag;
static int  eras_c;
static int  cpy_x;
static int  cpy_y;

/*** Draw Edit Box ***/

drawebox()
{
	word x,y;
	
	mousoff();
	for_to(y,ssiz_y) {
		for_to(x,ssiz_x) {
			drawpix(x,y,ebox_x,ebox_y,&edt_rec,TRUE);
		}
	}
	mouson();
}

/*** Draw pixcel ***/
	
drawepix(x,y)
word x,y;
{
	drawpix(x,y,ebox_x,ebox_y,&edt_rec,TRUE);
}

putepix(x,y,col)
word x,y;
int  col;
{
	setpix(x,y,&edt_rec,col);
	drawepix(x,y);
}

/*** Draw by Pen ***/

static putpen(x,y)
word x;
word y;
{
	putepix(x,y,getpix(x&3,y&3,&pen_rec));
}

/*** Do Edit ***/

int do_edit()
{
	word x,y;	
	
	x=(msrec.px-ebox_x)/8;
	y=(msrec.py-ebox_y)/8;
	if(vsize) y/=2;
	if(!inrect(x,y,ssiz_x,ssiz_y)) {
		 pre_x=-1;
		 pre_y=-1;
		 return(FALSE);
	}
	if(!(msrec.evnt & ~MS_MOV)) {
		if((x == pre_x) && (y == pre_y)) return(TRUE);
	}
	pre_x=x;
	pre_y=y;
	if(boxmod) {
		if(msrec.evnt & MS_LDN) {
			bx0=x;
			by0=y;
			bx=x;
			by=y;
			drag=TRUE;
			dragbox();
		}
		if(msrec.evnt & MS_RON) {
			switch(boxmod) {
			case TL_LIN:
			case TL_BOX:
				if(drag) {
					dragbox();
					drag=FALSE;
				}
				drawtol1(boxmod,0);
				boxmod=FALSE;
				break;
			case TL_CPY:
				if(drag) {
					dragbox();
					drag=FALSE;
				}
				else {
					copy_box(x,y,FALSE);
				}
				break;
			}
		}
		if(drag) {
			mousoff();
			dragbox();
			if(msrec.evnt & MS_LUP) {
				drag=FALSE;
				switch(boxmod) {
				case TL_LIN:
					line_box();
					break;
				case TL_BOX:
					fill_box();
					break;
				case TL_CPY:
					copy_box(x,y,TRUE);
					break;
				}
			}
			else if(!(msrec.btn & MS_LON)) drag=FALSE;
			else {
				if(boxmod == TL_LIN) {
					bx=x;
					by=y;
				}
				else {
					if(x>=bx0) bx=x;
					if(y>=by0) by=y;
				}
				dragbox();
			}
			mouson();
		}
	}
	else {
		if(msrec.btn & MS_LON) {
			mousoff();
			if(pensiz) {
				putpen(x,y);
				if(x+1 < ssiz_x) putpen(x+1,y);
				if(y+1 < ssiz_y) putpen(x,y+1);
				if(x+1 < ssiz_x && y+1 < ssiz_y) putpen(x+1,y+1);
			}
			else putpen(x,y);
			mouson();
		}
		else if(msrec.btn & MS_RON) {
			if(msrec.evnt & MS_RDN) eras_c=getpix(x,y,&edt_rec);
			mousoff();
			putepix(x,y,eras_c);
			mouson();
		}
	}
	return(TRUE);
}
		
/*** Dragging box/line ***/

static dragbox()
{
	int  sy;
	int  dy;
	PEN  pn;
	PEN  *oldpn;
	
	oldpn=setpen(&pn);
	pn.col=7;
	pn.op=GP_XOR;
	pn.lin=0xAAAA;
	sy=(vsize+1)*8;
	mousoff();
	if(boxmod == TL_LIN) {
		dy=ebox_y+(vsize+1)*4;
		line(bx0*8+ebox_x+4,by0*sy+dy,bx*8+ebox_x+4,by*sy+dy);
	}
	else {
		dy=(vsize+1)*8-1;
		box(bx0*8+ebox_x,by0*sy+ebox_y,bx*8+7+ebox_x,by*sy+dy+ebox_y);
	}
	mouson();
	respen(oldpn);
}	

/*** Line Edit Box ***/

static line_box()
{
	int  x,y;
	int  sx,sy;
	int  mx,my;

	if(bx >= bx0) {
		sx=bx-bx0;
		mx=1;
	}
	else {
		sx=bx0-bx;
		mx=-1;
	}
	if(by >= by0) {
		sy=by-by0;
		my=1;
	}
	else {
		sy=by0-by;
		my=-1;
	}
	if(!sx && !sy) putpen(bx0,by0);
	else if(sx >= sy) {
		for_to(x,sx+1) {
			putpen(bx0+x*mx,by0+divide(x,sy,sx)*my);
		}
	}
	else {
		for_to(y,sy+1) {
			putpen(bx0+divide(y,sx,sy)*mx,by0+y*my);
		}
	}
}	

/*** division ***/

divide(x,i,n)
int x,i,n;
{
	int t;
	
	t=x*2*i/n;
	if(t & 1) t+=2;
	return(t/2);
}

/*** Fill Edit Box ***/

static fill_box()
{
	word  x,y;	

	
	mousoff();
	for(y=by0; y<=by; y++) { 
		for(x=bx0; x<=bx; x++) putpen(x,y);
	}
	mouson();
}

/*** Box Copy ***/

static copy_box(x0,y0,dr)
word x0,y0;
flag dr;
{
	word x,y;
	int  col;
	
	if(dr) {
		cpy_x=bx-bx0;
		cpy_y=by-by0;
		for(y=0; y<=cpy_y; y++) {
			for(x=0; x<=cpy_x; x++) {
				setpix(x,y,&cpy_rec,(getpix(x+bx0,y+by0,&edt_rec)));
			}
		}
	}
	else {
		mousoff();
		for(y=0; y<=cpy_y; y++) {
			if(y+y0 >= ssiz_y) break;
			for(x=0; x<=cpy_x; x++) {
				if(x+x0 >= ssiz_x) break;
				col=getpix(x,y,&cpy_rec);
				if(palet[col] < 8) putepix(x+x0,y+y0,col);
			}
		}
		mouson();
	}
}

