/***************************
	'PET' Pattern Editor
***************************/

#define MAIN

#include "std.h"
#include "graf.h"
#include "pet.h"

/************
	main
************/

main()
{
	int  evnt;
	
	font12p=load(font12n);
	font16p=load(font16n);
	setfont(font16p);
	initspat(load(patname),&ctrl_s);
	initspat(load(iconname),&tool_s);
	setpen(&pn);
	pfkey(OFF);
	pchr(CLS);
	gmode(0);
	gcls();
	pinit(PR_GRAF);
	gon();
	init();
	mousini;
	mouson();
	repeat {
		evnt=getmous(&msrec);
		if(evnt || msrec.btn & MS_LON+MS_RON) {
			if(action) {
				if(domenu(&mb_stag)) continue;
				if(do_stag()) continue;
				if(do_selct())	continue;
			}
			else if(fldmap) {
				if(domenu(&mb_fmap)) continue;
				if(do_fmap()) continue;
			}
			else {
				if(domenu(&mb_main))	continue;
				if(do_edit())	continue;
				if(do_palet())	continue;
				if(do_tube())	continue;
				if(do_tool())	continue;
				if(do_sbox())	continue;	
				if(do_selct())	continue;
			}
		}
	} until(quit);
	mousoff();
	pchr(CLS);
	gcls();
	pfkey(ON);
	exit();
}

/*** load file ***/

load(name)
char *name;
{
	int  p;
	
	p=loadfile(name);
	if(!p) {
		print("Can't find \"%s\"\n",name);
		exit();
	}
	return(p);
}

/*** Init ***/

init()
{
	if(action) initstag();
	else if(fldmap) initfmap();
	else {
		switch(pattyp) {
		case TP_FNT:
			plane=1;
			vsize=0;
			siz_x=16;
			if(siz_y > 16) siz_y=16;
			patcnt=96;
		case TP_PAT:
			ssiz_x=siz_x;
			ssiz_y=siz_y;
			break;
		case TP_CHP:
		case TP_BGP:
			vsize=0;
			siz_x=siz_y=8;
			ssiz_x=ssiz_y=32;
			break;
		}
		vsiz_y=ssiz_y*(vsize+1);
		if(getpatmem()) {
			print("Not enough memory !\n");
			exit();
		}
		iniprec(&edt_rec,siz_x/8,siz_y,patwk);
		iniprec(&ura_rec,siz_x/8,siz_y,patbk);
		iniprec(&cpy_rec,siz_x/8,siz_y,patcp);
		iniprec(&pen_rec,1,4,patpn);
		fillmem(pixtbl,16,0);
		fillmem(uratbl,16,0);
		inittool();
		palmax=1<<plane;
		palet=(char *)&palets[plane-1];
		if(vsize) pic_s.sy=16; else pic_s.sy=8;
	}
	initselw();
	drawall();
}
	
/*** draw screen ***/

drawall()
{
	int i;
	
	mousoff();
	pchr(CLS);
	bak_s.pat=(char*)bakpat;
	bak_s.col1=backcol;
	basecol=palet[0];
	if(basecol == 8) base_s=&bak_s; else base_s=NIL;
	fillrect(0,0,640,400,&bak_s);
	if(action) drawstag(curstg);
	else if(fldmap) drawfmap();
	else {
		initmenu();
		drawmenu(&mb_main);
		shaderct(ebox_x,ebox_y,ssiz_x*8,vsiz_y*8,4);
		shaderct(scr_x,scr_y,ssiz_x,vsiz_y,2);
		initpix();
		drawebox();
		drawmbox();
		for_to(i,palmax) drawspal(i);
		for_to(i,8) drawmpal(i);
		drawtube();
		drawtool();
	}
	if(!fldmap) {
		drawselw();
	}
	mouson();
}
	
/*** Get pattern area ***/

int getpatmem()
{
	selpage=0;
	patsiz=siz_x/8*siz_y*plane;
	pagcnt=(256/ssiz_x)*(256/vsiz_y);
	if(!patcnt) patcnt=1;
	maxpage=(patcnt-1)/pagcnt;
	allsiz=HEADSZ;
	switch(pattyp) {
	case TP_FNT:
		allsiz+=96;
	case TP_PAT:
		allsiz+=patsiz*patcnt;
		break;
	case TP_CHP:
	case TP_BGP:
		allsiz+=calcgmem();
		break;
	}
	if(patexist) {
		freemem(headptr);
		headptr=getmem(allsiz);
		if(!headptr) return(ERROR);
	}
	else {
		if(headptr) freemem(headptr);
		headptr=getmem(allsiz);
		if(!headptr) return(ERROR);
		fillmem(headptr,allsiz,0);
	}
	patptr=headptr+HEADSZ;
	if(pattyp >= TP_CHP) initgptr(patptr);
	return(0);
}
	
/*** Init Patt Record ***/

iniprec(p,sizx,sizy,pat)
PAT2 *p;
word sizx;
word sizy;
char *pat;
{
	int size;
	
	p->sx=sizx;
	p->sy=sizy;
	p->plsiz=sizx*sizy;
	p->patp=pat;
	if(p == &pen_rec) size=12; else size=384;
	fillmem(pat,size,0);
}

