/************************
	'PET' File handler
************************/

#include "std.h"
#include "graf.h"
#include "pet.h"

typedef struct header {
	char id[4];
	int  size;
	int  count;
	int  dot_x;
	int  dot_y;
	char plane;
	char zom_x;
	char zom_y;
	char wdth;
} HEAD;

static char *patid[4]={ "PAT","FNT","CHP","BGP" };
static char filemask[]="*.pat";
static int  fontwdth;

static struct dirrec {
	char name[13];  
	char atr;
	word time;
	word date;
	long size;
} dir;

DLOG dg_lodng={ "Can't Load!"		,0,0,1,Q_OK };
/*DLOG dg_lodok={ "Load \"%s\"?"		,240,0,2,Q_YES,Q_NO };*/
/*DLOG dg_saven={ "Save \"%s\"\nRename:",240,16*6,2,Q_OK,Q_ESC };*/
static DLOG dg_font={ "Font Width:",192,0,2,Q_OK,Q_ESC };
static SBAR sb_font={ CT_SBAR,0,0,0,NIL,0,HZ,32+16,16,32,0,2,0,3 };

/*** Save Pattern ***/

savepat()
{
	HEAD *hp;
	int  r;

	r=setname(filename,filemask+1);
	if(r == -1) goto end_save;
	if(r > 0) {
		drawmenu(&mb_main);
		if(pattyp == TP_FNT) {
			dg_font.link=(CTRL*)&sb_font;
			sb_font.max=siz_x;
			sb_font.val=fontwdth;
			if(dialog(&dg_font) == Q_OK) {
				fontwdth=sb_font.val;
			}
		}
	}
	strcpy(headptr,patid[pattyp]);
	hp=(HEAD*)headptr;
	hp->size=allsiz;
	hp->count=patcnt;
	hp->dot_x=siz_x;
	hp->dot_y=siz_y;
	hp->plane=(char)plane;
	hp->zom_y=(char)vsize;
	if(pattyp == TP_FNT) {
		if(!(hp->wdth=fontwdth)) dcodwtbl();
	}
	savefile(filename,hp,allsiz);
end_save:
}

/*** Load Pattern ***/

flag loadpat()
{
	int  i,j;
	flag f;
	char *name;
	char *p;
	char *q;
	HEAD *hp;
	
	name=(char*)selfile(filemask,NIL);
	if(!name) goto cancel;
	freemem(headptr);
	headptr=(char*)loadfile(name);
	if(!headptr) goto loaderr;
	for_to(i,4) {
		p=headptr;
		q=&(*patid[i]);
		f=TRUE;
		for_to(j,4) {
			if(*p++ != *q++) {
				f=FALSE;
				break;
			}
		}
		if(f) {
			pattyp=i;
			break;
		}
	}
	if(!f) goto loaderr;
	patexist=TRUE;
	patptr=headptr+HEADSZ;
	hp=(HEAD*)headptr;
	patcnt=hp->count;
	siz_x=hp->dot_x;
	siz_y=hp->dot_y;
	plane=(int)(hp->plane);
	patsiz=siz_x/8*siz_y*plane;
	vsize=(int)(hp->zom_y);
	fontwdth=hp->wdth;
	strcpy(filename,name);
	if(pattyp == TP_FNT) {
		if(!(fontwdth=hp->wdth)) ecodwtbl();
	}
	return(TRUE);
loaderr:
	dialog(&dg_lodng);
cancel:	
	return(FALSE);
}

/*** Encode Font Width Table ***/

ecodwtbl()
{
	char *fp;
	char *tp;
	int  i;
	
	
	fp=patptr;
	tp=fp+patsiz*patcnt;
	for_to(i,patcnt) {
		*(int *)fp=swaphl((word)0x8000>>*tp++);
		fp+=patsiz;
	}
}
		
/*** Decode Font Width Table ***/

dcodwtbl()
{
	char *fp;
	char *tp;
	int  i,j;
	word msk;
	
	fp=patptr;
	tp=fp+patsiz*patcnt;
	for_to(i,patcnt) {
		msk=0x8000;
		for_to(j,16) {
			if(*(int *)fp & swaphl(msk)) break;
			msk>>=1;
		}
		(*tp++)=j;
		*(int *)fp=0;
		fp+=patsiz;
	}
}

