/***********************
	'PET' ZF Routines
***********************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define OBSTSZ	2*256
#define BGATRSZ	256
#define BGMSKSZ	8*32
#define BGMSK	0xE0
#define ATRCNT	8

extern flag fullmap;
extern byte piece[];
extern byte piece0[];

int  *obstblp;
int  bgobst;

static byte *bgatrp;
static byte *bgmskp;
static byte selpixp[24];
static byte selurap[24];
static byte mskpixp[8];
static byte mskurap[8];
static int  selpixn;
static int  selpos;
static byte	selatr;

static DLOG dg_atr={ "Attribute:\n",120,200,2,Q_OK,Q_ESC };
static BTNS rb_atrs={ CT_RBTN,0,0,0,NIL,0,8,VT };
static BTN rb_atr[]={
	"Overlay",0,0,0,
	"Mask",0,0,0,
	"Water",0,0,0,
	"Top",0,0,0,
	"R Slope",0,0,0,
	"L Slope",0,0,0,
	"D Slope",0,0,0,
	"U Slope",0,0,0,
};

static byte atrmsk[]={ 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80 };

/*** Draw select ***/

drawgsel(i)
int  i;
{
	int  x,y;
	
	if(pattyp < TP_CHP) return(FALSE);
	if(!spr_pix) {
		if(pattyp == TP_BGP) drawobst();
		for_to(y,8) {
			for_to(x,8) {
				if(i >= patcnt) goto ended;
				putgspr(x,y,i++,FALSE);
			}
		}
	}
	else {
		if(pattyp == TP_BGP) {
			fillrect(atr_x-2,atr_y-2,38,38,&bak_s);
			if(selpixn >= BGMSK) drawmask();
		}
		i=0;
		for_to(y,16) {
			for_to(x,16) {
				putgpix(x*2,y*2,i++,1);
			}
		}
	}
ended:
	return(TRUE);
}

/*** Put GAME pixcel ***/

static putgpix(x,y,n,f)
word x,y;
word n;
int  f;
{
	x=x*8+sel_x;
	y=y*8+sel_y;
	if(f) {
		if(f == 2) {
			pn.col=basecol;
			fillrect(x,y,16,16,base_s);
		}
		if(!frame) {
			pn.col=2;
			framerct(x+15,y,1,16);
			framerct(x,y+15,16,1);
		}
	}
	putzpix(x,y,cpatptr+n*patsiz,plane,0);
}

/*** Put GAME sprite ***/

static putgspr(x,y,n,f)
word x,y;
int  n;
flag f;
{
	byte *mp;
	
	mp=mapptr+n*16;
	x=x*32+sel_x;	
	y=y*32+sel_y;
	pn.col=basecol;
	if(f) fillrect(x,y,32,32,base_s);
	putzspr(x,y,cpatptr,plane,0,mp);
	if(!frame) {
		pn.col=2;
		framerct(x,y,32,32);
	}
}

/*** Draw Pixcel ***/

static drawslpx(n)
int  n;
{
	mousoff();
	drawhexa(pix_x,pix_y-18,n);
	pn.col=basecol;
	fillrect(pix_x,pix_y,16,16,base_s);
	putzpix(pix_x,pix_y,cpatptr+n*patsiz,plane,0);
	mouson();
}

/*** Do Select Pix/Spr ***/

do_gsel()
{
	word x,y;
	int  i;
	int  sel;
	int  tmp;
	byte atr;
	byte *patp;
	byte *mapp;
	byte *sprp;
	byte *mskp;
	byte *atrp;
	
	if(pattyp < TP_CHP) return(FALSE);
	if(pattyp == TP_BGP) {
		if(!spr_pix) {
			if(do_obst()) goto end_gsel;
		}
		else {
			if(do_mask()) goto end_gsel;
			if(do_atr()) goto end_gsel;
		}
	}
	x=msrec.px-sel_x;
	y=msrec.py-sel_y;
	if(!inrect(x,y,256,256)) return(FALSE);
	if(fldmap && fullmap) {
		dofulmap();
		goto end_gsel;
	}
	if(!spr_pix) {
		x/=32;
		y/=32;
		sel=y*8+x+selpage*64;
		mapp=mapptr+sel*16;
		if(msrec.evnt & MS_LDN) {
			if(pattyp == TP_BGP) {
				bgobst=*(obstblp+sel);
				drawobst();
			}
			if(action || fldmap) {
				if(sel) {
					flushrct(x*32+sel_x,y*32+sel_y,32,32);
					selsprn=sel;
				}
			}
			else {
				selpos=-1;
				movemem(pixtbl,uratbl,16);
				movemem(patwk,patbk,patsiz*16);
				movemem(mapp,pixtbl,16);
				sprp=mapp;
				patp=patwk;
				for_to(i,16) {
					movemem(cpatptr+(*sprp++)*patsiz,patp,patsiz);
					patp+=patsiz;
				}
				mousoff();
				drawpatn(sel);
				drawebox();
				mouson();
			}
		}
		else if(msrec.evnt & MS_RDN) {
			if(!(action || fldmap)) {
				if(pattyp == TP_BGP) {
					tmp=*(obstblp+sel);
					*(obstblp+sel)=bgobst;
					bgobst=tmp;
					drawobst();
				}
				movemem(mapp,uratbl,16);
				sprp=mapp;
				patp=patbk;
				for_to(i,16) {
					movemem(cpatptr+(*sprp++)*patsiz,patp,patsiz);
					patp+=patsiz;
				}
				movemem(pixtbl,mapp,16);
				sprp=pixtbl;
				patp=patwk;
				for_to(i,16) {
					movemem(patp,cpatptr+(*sprp++)*patsiz,patsiz);
					patp+=patsiz;
				}
				movemem(uratbl,pixtbl,16);
				movemem(patbk,patwk,patsiz*16);
				mousoff();
				putgspr(x,y,sel,TRUE);
				drawpatn(sel);
				drawebox();
				mouson();
				patexist=TRUE;
			}
		}
	}
	
	else if(!action) {
		x/=16;
		y/=16;
		sel=y*16+x;
		patp=cpatptr+sel*patsiz;
		mskp=bgmskp+(sel-BGMSK)*8;
		if(msrec.evnt & MS_LDN) {
			flushrct(x*16+sel_x,y*16+sel_y,8,8);
			selpixn=sel;
			selatr=*(bgatrp+sel);
			drawslpx(selpixn);
			movemem(patp,selpixp,patsiz);
			selpos=-1;
			if(pattyp == TP_BGP) {
				if(sel >= BGMSK) {
					movemem(mskp,mskpixp,8);
					drawmask();
				} else fillrect(atr_x,atr_y,16,16,&bak_s);
			}
		}
		else if(msrec.evnt & MS_RDN) {
			drawslpx(sel);
			movemem(patp,selurap,patsiz);
			movemem(selpixp,patp,patsiz);
			movemem(selurap,selpixp,patsiz);
			if(selpos >= 0)  pixtbl[selpos]=sel;
			else chgpixn(selpixn,sel);
			selpos=-1;
			if(pattyp == TP_BGP) {
				drawmask();
				atrp=bgatrp+sel;
				atr=*atrp;
				*atrp=selatr;
				selatr=atr;
				if(selpixn >= BGMSK) {
					movemem(mskp,mskurap,8);
					movemem(mskpixp,mskp,8);
					movemem(mskurap,mskpixp,8);
				}
			}
			mousoff();
			putgpix(x*2,y*2,sel,2);
			mouson();
		}
	}
end_gsel:
	return(TRUE);
}

/*** Change Pixcel number ***/

static chgpixn(old,new)
byte old,new;
{
	int  i;
	int  cnt;
	byte *mp;
	
	mp=mapptr;
	cnt=256*16;
	if(pattyp == TP_CHP) {
		if(selpage >= 2) {
			mp+=128*16;
		}
		cnt=128*16;
	}
	for_to(i,cnt) {
		if(*mp == old) *mp=new;
		mp++;
	}
}

/*** Do Scroll Box ***/

do_sbox()
{
	int  x;	
	int  y;
	int  sel;
	
	if(pattyp < TP_CHP) return(FALSE);
	x=(msrec.px-scr_x)/8;
	y=(msrec.py-scr_y)/8;
	if(!inrect(x,y,4,4)) return(FALSE);
	sel=y*4+x;
	if(msrec.evnt & MS_LDN) {
		mousoff();
		flushrct(x*8+scr_x,y*8+scr_y,8,8);
		selpixn=pixtbl[sel];
		drawslpx(selpixn);
		mouson();
		movemem(&patwk[sel*patsiz],selpixp,patsiz);
		selpos=sel;
	}
	else if(msrec.evnt & MS_RDN) {
		movemem(selpixp,&patwk[sel*patsiz],patsiz);
		pixtbl[sel]=selpixn;
		mousoff();
		drawslpx(selpixn);
		drawebox();
		mouson();
	}
	return(TRUE);
}

ptbl()
{
	int i;
	int prtp;
	
	prtp=pinit(PR_TEXT);
	ploc(30,0);
	patr(0x21);
	for_to(i,16) {
		print("%3x",pixtbl[i]);
	}
	patr(0xE1);
	pinit(prtp);
}

/*** Calculate Total Bytes ***/

int calcgmem()
{
	int  ret;
	
	switch(pattyp) {
	case TP_CHP:
		ret=patsiz*512+16*patcnt;
		break;
	case TP_BGP:
		ret=patsiz*256+16*patcnt+OBSTSZ+BGATRSZ+BGMSKSZ;
		break;
	}
	return(ret);
}

/*** Init pointers ***/

initgptr(p)
byte *p;
{
	switch(pattyp) {
	case TP_CHP:
		mapptr=p+patsiz*512;
		break;
	case TP_BGP:
		mapptr=p+patsiz*256;
		obstblp=(int*)(mapptr+16*patcnt);
		bgatrp=(byte*)obstblp+OBSTSZ;
		bgmskp=bgatrp+BGATRSZ;
		dg_atr.link=(CTRL*)&rb_atrs;
		rb_atrs.btnp=&rb_atr[0];
		rb_atrs.btns=ATRCNT;
		break;
	}
}

/*** Draw BG obstacle bit ***/

drawobst()
{
	int  x,y;
	int  bit;
	
	mousoff();
	pn.col=0;
	shaderct(atr_x,atr_y,32,32,2);
	bit=bgobst;
	for_to(y,4) {
		for_to(x,4) {
			putobst(x,y,bit & 1);
			bit>>=1;
		}
	}
	mouson();
}
				
static putobst(x,y,f)
word x,y;
flag f;
{
	putzpix(x*8+atr_x,y*8+atr_y,f ? piece : piece0,1,7);
}


/*** Do BG obstacle bit ***/

static do_obst()
{
	int  x,y;
	int  bit;
	int  ret;
	
	ret=FALSE;
	if(pattyp == TP_BGP) {
		x=(msrec.px-atr_x)/8;
		y=(msrec.py-atr_y)/8;
		if(inrect(x,y,4,4)) {
			bit=1<<(y*4+x);
			if(msrec.btn & MS_LON && !(bgobst & bit)
			|| msrec.btn & MS_RON && bgobst & bit ) {
				bgobst^=bit;
				mousoff();
				putobst(x,y,bgobst & bit);
				mouson();
			}
			ret=TRUE;
		}
	}
	return(ret);
}		

/*** Draw BG Mask ***/

static drawmask()
{
	mousoff();
	pn.col=0;
	fillrect(atr_x,atr_y,16,16,NIL);
	putzpix(atr_x,atr_y,mskpixp,1,7);
	mouson();
}

/*** Do BG Mask ***/

static do_mask()
{
	int  x,y;
	int  i;
	int  ret;
	
	ret=FALSE;
	if(pattyp == TP_BGP) {
		x=(msrec.px-atr_x);
		y=(msrec.py-atr_y);
		if(inrect(x,y,16,16)) {
			if(msrec.evnt & MS_LDN) {
				flushrct(atr_x,atr_y,8,8);
				for(i=0; i<24; i+=8) {
					movemem(mskpixp,selpixp+i,8);
				}
			}
			else if(msrec.evnt & MS_RDN) {
				movemem(selpixp,mskpixp,8);
				drawmask();
			}
			ret=TRUE;
		}
	}
	return(ret);
}

/*** Do BG attribute ***/

static do_atr()
{
	word x,y;
	int  i;
	BTN	 *btp;
	
	x=msrec.px-pix_x;
	y=msrec.py-pix_y;
	if(!inrect(x,y,16,16)) return(FALSE);
	if(msrec.evnt & MS_LDN) {
		btp=&rb_atr[0];
		for_to(i,ATRCNT) {
			btp->mode=(selatr & atrmsk[i]) ? MD_ON : 0;
			btp++;
		}
		if(dialog(&dg_atr) == Q_OK) {
			btp=&rb_atr[0];
			for_to(i,ATRCNT) {
				if(btp->mode) selatr|=atrmsk[i]; else selatr&=~atrmsk[i];
				btp++;
			}
			*(bgatrp+selpixn)=selatr;
		}
	}
	return(TRUE);
}
