/*********************
	'PET' Pixel I/O
*********************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define COLBFSZ	32*32

char 		piece[24]=	{ 0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0x00,
						  0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
						  0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0x00 };
char 		piece0[24]= { 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0xFF,
						  0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
						  0x01,0x01,0x01,0x01,0x01,0x01,0x01,0xFF };
static char piece8[24]=	{ 0xAA,0x55,0xAA,0x45,0xAA,0x55,0xAA,0x55,
						  0xAA,0x55,0xAA,0x45,0xAA,0x55,0xAA,0x45,
						  0xA2,0x55,0xAA,0x45,0xAA,0x55,0xAA,0x55 };
static char mask[8]=	{ 0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01 };
static char colbuf[COLBFSZ];

/*** Init Pixcel ***/

initpix()
{
	fillmem(colbuf,COLBFSZ,-1);
}

/*** Draw Pixcel ***/

drawpix(px,py,bx,by,pat,f)
word px,py;
word bx,by;
PAT2 *pat;
flag f;
{
	int  col;
	int  bcol;
	int  i;
	char *patp;
	word x,y;
	word sy,dy;
	PATT *patf;
	
	col=palet[getpix(px,py,pat)];
	i=py*32+px;
	if(pat != &pen_rec) {
		if(col != colbuf[i]) colbuf[i]=col;
		else goto enddpix;
	}
	switch(col) {
	case 0:
		col=7;
		patp=piece0;
		pn.col=0;
		patf=NIL;
		bcol=7;
		break;
	case 8:
		col=7;
		patp=piece8;
		patf=&bak_s;
		bcol=0;
		break;
	default:
		patp=piece;
		pn.col=col;
		patf=NIL;
		bcol=0;
		break;
	}
	x=bx+px*8;
	if(vsize) {
		y=by+py*16;
		sy=16;
		dy=py*2;
		patp+=8;
	}
	else {
		y=by+py*8;
		sy=8;
		dy=py;
	}
	putzpix(x,y,patp,1,col);
	if(vsize) putzpix(x,y+8,patp+8,1,col);
	if(f) fillrect(scr_x+px,scr_y+dy,1,vsize+1,patf);	
	pn.col=bcol;
	if(px && (px & 7) == 0) line(x,y,x,y+sy-2);
	if(py && (py & 7) == 0) line(x,y,x+6,y);
enddpix:
}

/*** Set Pattern offset ***/

char *setpatp(x,y,pat)
word x,y;
PAT2 *pat;
{
	word  n;
	char *p;
	
	p=pat->patp;
	if(pattyp >= TP_CHP) {
		n=(y/8)*4+x/8;
		p+=n*patsiz+(y&7);
	}
	else p+=y*pat->sx+x/8;
	return(p);
}

/*** Get Pixcel Color ***/ 

int getpix(px,py,pat)
word px,py;
PAT2 *pat;
{
	int  i;
	int  col;
	int  set;
	char m;
	char *p;
	
	p=setpatp(px,py,pat);
	m=mask[px&7];
	col=0;
	set=1;
	for_to(i,plane) {
		if(*p & m) col |= set;
		set<<=1;
		p+=pat->plsiz;
	}
	return(col);
}

/*** Set Pixcel Color ***/

setpix(px,py,pat,col)
word px,py;
PAT2 *pat;
int  col;
{
	int  i;
	char m;
	char *p;
	
	p=setpatp(px,py,pat);
	m=mask[px&7];
	for_to(i,plane) {
		if(col & 1) *p |= m;
		else *p &=~m;
		col>>=1;
		p+=pat->plsiz;
	}
}
