/******************
	'PET' menus 
******************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define MENUS	5
#define MN_LOD	0
#define MN_SAV	1
#define MN_NEW	2
#define MN_END	3
#define	MN_CNT	0
#define	MN_SIZ	1
#define	MN_PLN	3
#define MN_VSZ	7
#define MN_ACT	0
#define MN_MAP	1

DLOG dg_sure={ "Are you sure?",0,0,2,Q_YES,Q_NO };
static DLOG dg_count={ "Pattern Count:\n\n",232,8*14,2,Q_OK,Q_ESC };
static DLOG dg_size={ "Pattern Size:\n\n",148,8*17,2,Q_OK,Q_ESC };
/*static DLOG dg_cant={  "Can't Change!",0,0,1,Q_OK };*/
static SBAR sb_count={ CT_SBAR,0,0,0,NIL,0,HZ,128+16,16,256,0,8,0,3 };
static SBAR sb_sizex={ CT_SBAR,0,0,0,"X:",0,HZ,32+16,16,32,0,8,0,2 };
static SBAR sb_sizey={ CT_SBAR,0,0,0,"Y:",0,HZ,32+16,16,32,0,8,0,2 };

static MENU mn_main[]={
	"File",4,80,0,0,0,
	"Type",4,96,0,0,0,
	"Format",9,112,0,0,0,
	"Screen",4,80,0,0,0,
	"Special",2,96,0,0,0
};

static ITEM it_file[]={
	"Load",0,
	"Save",0,
	"New",0,
	"Quit",0
};

static ITEM it_type[]={
	"Normal",0,
	"Font",0,
	"Game CH",0,
	"Game BG",0
};

static ITEM it_form[]={
	"Count",0,
	"Size",0,
	0,0,
	"1Plane",0,
	"2Plane",0,
	"3Plane",0,
	0,0,
	"400line",0,
	"200line",0
};

ITEM it_scrn[]={
	"Color",0,
	"B/W",0,
	0,0,
	"Frame",0
};

ITEM it_spec[]={
	"Action",0,
	"Map Edit",0
};

/*** Dialog font12p ***/

dialog12(dp)
DLOG *dp;
{
	int  oldfont;
	int  ret;

	oldfont=setfont(font12p);
	ret=dialog(dp);
	setfont(oldfont);
	return(ret);
}

/*** Do menu.file ***/

static dofile(itm)
int itm;
{
	switch(itm) {
	case MN_LOD:
		if(loadpat()) init();
		break;
	case MN_SAV:
		savepat();
		break;
	case MN_NEW:
		if(dialog(&dg_sure)) {
			patexist=FALSE;
			init();
		}
		break;
	case MN_END:
		if(dialog(&dg_sure)) {
			quit=TRUE;
		}
		break;
	default:
		break;
	}
}

/*** Do menu.type ***/

static dotype(itm)
int itm;
{
	pattyp=itm;
	init();
}

/*** Do menu.form ***/

int cv_base(val)
int  val;
{
	return(val+1);
}

static doform(itm)
int  itm;
{
	int  n;
	int  size;
	
	switch(itm) {
	case MN_CNT:
		dg_count.link=(CTRL*)&sb_count;
		sb_count.val=patcnt-1;
		sb_count.func=cv_base;
		if(dialog12(&dg_count) == Q_OK) {
			if(n=sb_count.val+1) {
				if(patcnt < n) {
					if(pattyp >= TP_CHP) size=16; else size=patsiz;
					fillmem(headptr+allsiz,(n-patcnt)*size,0);
				}
				patcnt=n;
				init();
			}
		}
		break;
	case MN_SIZ:		
		dg_size.link=(CTRL*)&sb_sizex;
		sb_sizex.link=(CTRL*)&sb_sizey;
		sb_sizex.val=siz_x-1;
		sb_sizey.val=siz_y-1;
		sb_sizex.func=sb_sizey.func=cv_base;
		if(dialog12(&dg_size) == Q_OK) {
			siz_x=sb_sizex.val+1;
			siz_y=sb_sizey.val+1;
			init();
		}
		break;
	case MN_VSZ:
	case MN_VSZ+1:
		if(itm-MN_VSZ != vsize) {
			vsize=itm-MN_VSZ;
			if(vsize) siz_y/=2; else siz_y*=2;
			init();
		}
		break;
	case MN_PLN:
	case MN_PLN+1:
	case MN_PLN+2:
		if(itm-MN_PLN+1 != plane) {
			plane=itm-MN_PLN+1;
			init();
		}
		break;
	default:
		break;
	}
}

/*** Do menu.screen ***/

static doscrn(itm)
int  itm;
{
	if(itm < 2) {
		mousoff();
		gcls();
		gmode(itm);
		drawall();
		mouson();
	} else {
		frame=!frame;
		drawselw();
		initmenu();
	}
}

/*** Do menu.special ***/

static dospec(itm)
int itm;
{
	if(itm == MN_ACT) action=TRUE; else fldmap=TRUE;
	init();
}

/*** Init Menus ***/

initmenu()
{
	mb_main.mnu=&mn_main[0];
	mb_main.ttl=filename;
	
	mn_main[0].item=it_file;	
	mn_main[1].item=it_type;	
	mn_main[2].item=it_form;
	mn_main[3].item=it_scrn;
	mn_main[4].item=it_spec;
	mn_main[0].func=&dofile;
	mn_main[1].func=&dotype;
	mn_main[2].func=&doform;
	mn_main[3].func=&doscrn;
	mn_main[4].func=&dospec;
	setimark(&it_type[0],4,pattyp);
	setimark(&it_form[MN_VSZ],2,vsize);
	setimark(&it_form[MN_PLN],3,plane-1);
	setimark(&it_scrn[0],2,bw);
	setimark(&it_scrn[3],1,frame);
	setienbl(&it_file[MN_SAV],1,!patexist);
	setienbl(&it_type[0],4,patexist);
	setienbl(&it_form[MN_CNT],1,pattyp == TP_FNT);
	setienbl(&it_form[MN_SIZ],1,pattyp >= TP_CHP || patexist);
	setienbl(&it_form[MN_PLN],1,pattyp != TP_PAT || patexist);
	setienbl(&it_form[MN_PLN+1],2,pattyp == TP_FNT || patexist);
	setienbl(&it_form[MN_VSZ],2,pattyp != TP_PAT || patexist);
	setienbl(&it_spec[0],1,pattyp != TP_CHP);
	setienbl(&it_spec[1],1,pattyp != TP_BGP);
}	
