/**************************
	'PET' Select Pattern
**************************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define MD_ACT	0
#define MD_REV	1
#define MD_INA -1
#define SM_NRM	0
#define SM_PIX	1
#define MN_MSK	0
#define MN_OBS	1
#define MN_ATR	2
#define CHPHALF 8*2*256

MBAR mb_selw={ NIL,1,0,0,256,NIL };
static MENU mn_selw[]={
	"Page1",0,0,0,0,0,
	"Pixcel",0,0,0,0,0,
};
static char nm_pix[]="Pixcel";
static char nm_map[]="Map";

extern flag fullmap;

/*** Draw Select Window ***/

drawselw()
{
	int  i;
	word xmax;
	word ymax;
	word x,y;
	char *p;

	mousoff();
	if(maxpage || pattyp >= TP_CHP) drawpage();
	pn.col=basecol;
	fillrect(sel_x,sel_y,256,256,base_s);
	shaderct(sel_x,sel_y,256,256,4);
	i=selpage*pagcnt;
	if(!drawgsel(i)) {
		xmax=256/siz_x;
		if(xmax > 16) xmax=16;
		ymax=256/vsiz_y;
		p=patptr+patsiz*i;
		pat_s.sx=siz_x/8;
		pat_s.sy=siz_y;
		pat_s.pl=plane;
		pat_s.zmx=0;
		pat_s.zmy=vsize;
		pat_s.opm=0;
		pat_s.col0=palet[0];
		pat_s.col1=palet[1];
		pat_s.col2=palet[2];
		pat_s.col3=palet[3];
		for_to(y,ymax) {
			for_to(x,xmax) {
				if(i++ == patcnt) goto ended;
				putspat(x,y,p,FALSE);
				p=p+patsiz;
			}
		}
	}
ended:
	mouson();
}		

/*** Draw page number ***/

drawpage()
{
	drawmenu(&mb_selw);
	
/*	prtp=pinit(PR_GRAF);
	pn.col=7;
	fillrect(sel_x,sel_y+PGBX_DY,PGBX_SX,PGBX_SY,NIL);
	shaderct(sel_x,sel_y+PGBX_DY,PGBX_SX,PGBX_SY,NIL);
	gloc(sel_x,sel_y+PGBX_DY);
	pn.col=0;
	if(selpage >= 0) print("Page%d",selpage); else print("Pixcel");
	pinit(prtp);
*/
}

/*** Draw Hexa number ***/

drawhexa(x,y,n)
int  x,y,n;
{
	int  prtp;
	int  sx;
	
	prtp=pinit(PR_GRAF);
	sx=chrwdth('0')*2+1;
	pn.col=7;
	fillrect(x,y,sx,16,NIL);
	shaderct(x,y,sx,16,1);
	gloc(x,y);
	pn.col=0;
	print("%02x",n);
	pinit(prtp);
}

/*** Draw Pattern number ***/

drawpatn(n)
int  n;
{
	drawhexa(scr_x,scr_y-18,n);
}

/*** Do Select ***/

do_selct()
{
	int  x;	
	int  y;
	int  sel;
	char *patp;
	
	if(domenu(&mb_selw)) return(TRUE);
	if(do_gsel()) return(TRUE);
	x=msrec.px-sel_x;
	y=msrec.py-sel_y;
	if(!inrect(x,y,256,256)) return(FALSE);
	x/=siz_x;
	y/=vsiz_y;
	sel=y*256/siz_x+x+selpage*pagcnt;
	if(sel < patcnt) {
		patp=patptr+sel*patsiz;
		if(msrec.evnt & MS_LDN) {
			movemem(patwk,patbk,patsiz);
			movemem(patp,patwk,patsiz);
			mousoff();
			drawpatn(sel);
			drawebox();
			mouson();
		}
		else if(msrec.evnt & MS_RDN) {
			movemem(patp,patbk,patsiz);
			movemem(patwk,patp,patsiz);
			movemem(patbk,patwk,patsiz);
			mousoff();
			putspat(x,y,patp,TRUE);
			drawpatn(sel);
			drawebox();
			mouson();
			patexist=TRUE;
			initmenu();
		}
	}
	return(TRUE);
}

/*** do page ***/

static dopage(evnt)
int  evnt;
{
	
	if(fldmap && fullmap) fullmap=FALSE;
	else {
		if(spr_pix) {
			spr_pix=0;
		} else {
			if(evnt & MS_LDN) {
				if(++selpage > maxpage) selpage=0;
			} else if(evnt & MS_RDN) {
				if(selpage-- == 0) selpage=maxpage;
			}
		}
	}
	initselw();
	drawselw();	
}

/*** do pixcel table ***/

static dopixw()
{
	spr_pix=~spr_pix;
	initselw();
	drawselw();
}

/*** do map mode ***/

static domap()
{
	if(fullmap) {
		fullmap=FALSE;
		mn_selw[1].mode=MD_ACT;
		initselw();
		drawselw();
	} else {
		fullmap=TRUE;
		mn_selw[1].mode=MD_REV;
		drawmap();
	}
}

/*** Put one pattern ***/

static putspat(x,y,patp,f)
word x,y;
char *patp;
flag f;
{
	int  i;
	int  n;
	char *p;
	
	x=x*siz_x+sel_x;
	y=y*vsiz_y+sel_y;
	if(f) {
		if(pat_s.pl == 1) n=2;
		else if(pat_s.pl == 2) n=3;
		else n=0;
		p=&pat_s.col0;
		pn.col=basecol;
		for_to(i,n) {
			if(*p++ == 8) {
				fillrect(x,y,siz_x,vsiz_y,base_s);
				break;
			}
		}
	}
	pat_s.pat=patp;
	putpat(x,y,&pat_s);
	if(!frame) {
		pn.col=2;
		framerct(x,y, siz_x, vsiz_y);
	}
}

/*** Init select ***/

initselw()
{
	mb_selw.mnu=&mn_selw[0];
	mb_selw.px=sel_x;
	mb_selw.py=sel_y-18;
	mn_selw[0].func=&dopage;
	if(pattyp < TP_CHP || action) mb_selw.mnus=1;
	else {
		mb_selw.mnus=2;
		if(fldmap) {
			mn_selw[1].nam=nm_map;
			mn_selw[1].func=&domap;
		} else {
			mn_selw[1].nam=nm_pix;
			mn_selw[1].func=&dopixw;
		}
	}
	if(!spr_pix) {
			mn_selw[0].mode=maxpage ? MD_ACT : MD_INA;
			mn_selw[0].nam[4]=(char)selpage+'1';
			mn_selw[1].mode=MD_ACT;
	} else {
			mn_selw[1].mode=MD_REV;
	}
	if((pattyp == TP_CHP) && (selpage >= 2)) cpatptr=patptr+CHPHALF;
	else cpatptr=patptr;
}

