/************************
	'PET' Action Stage
************************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define MENUS	3
#define MN_NEW	0
#define MN_END	1
#define	MN_SIZ	0
#define MN_WAI	1
#define MN_SET	0
#define MN_PLY	1
#define MN_DEL	2

#define SGBX_DY	-18
#define SGBX_SX	64
#define SGBX_SY	16

typedef struct stgrec {
	flag use;
	int px;
	int py;
	int num;
} STGE;

extern DLOG dg_sure;
extern MBAR mb_stag;

static STGE *stgptr;
static int  stgcnt=8;
static int  stgpat=2;
static word stg_sx=128;
static word stg_sy=32;
static int  stgwait=10;
static int  stgmode=MN_SET;

static DLOG dg_size={ "Setup Action Stage...\n\n",248,8*24,2,Q_OK,Q_ESC };
static SBAR sb_scnt={ CT_SBAR,0,0,0,"Stage count:",100,HZ,48,16,32,0,2,0,2 };
static SBAR sb_sszx={ CT_SBAR,0,0,0,"Stage size X:",100,HZ,48,16,8,0,1,0,3 };
static SBAR sb_sszy={ CT_SBAR,0,0,0,"Stage size Y:",100,HZ,48,16,8,0,1,0,3 };
static SBAR sb_pcnt={ CT_SBAR,0,0,0,"Pattern count:",100,HZ,48,16,32,0,2,0,2};

static DLOG dg_wait={ NIL,180,0,2,Q_OK,Q_ESC };
static SBAR sb_wait={ CT_SBAR,0,0,0,"Wait Time:",0,HZ,32,16,16,0,2,0,2 };

static char scntbf[4];
static char sszxbf[4];
static char sszybf[4];
static char pcntbf[4];

static MENU mn_stag[]={
	"File",2,80,0,0,0,
	"Format",2,128,0,0,0,
	"Mode",2,80,0,0,0
};

static ITEM it_file[]={
	"New",0,
	"Quit",0
};

static ITEM it_form[]={
	"Setup Stage",0,
	"Wait Time",0
};

ITEM it_mode[]={
	"Setting",0,
	"Play",0
};

/*** Do menu.file ***/

static dofile(itm)
int itm;
{
	int  i;
	STGE *sp;
	
	switch(itm) {
	case MN_NEW:
		if(dialog(&dg_sure)) {
			sp=stgptr;
			for_to(i,stgcnt*stgpat) {
				sp->use=0;
				sp++;
			}
			drawstag(curstg);
		}
		break;
	case MN_END:
		action=FALSE;
		init();
		break;
	}
}

/*** Do menu.form ***/

static int cv_base2(val)
int  val;
{
	return(val*32+32);
}

static doform(itm)
int  itm;
{
	switch(itm) {
	case MN_SIZ:		
		dg_size.link=(CTRL*)&sb_scnt;
		sb_scnt.link=(CTRL*)&sb_sszx;
		sb_sszx.link=(CTRL*)&sb_sszy;
		sb_sszy.link=(CTRL*)&sb_pcnt;
		sb_sszx.func=sb_sszy.func=cv_base2;
		sb_scnt.val=stgcnt;
		sb_sszx.val=stg_sx/32-1;
		sb_sszy.val=stg_sy/32-1;
		sb_pcnt.val=stgpat;
		if(dialog12(&dg_size) == Q_OK) {
			stgcnt=sb_scnt.val;
			stg_sx=sb_sszx.val*32+32;
			stg_sy=sb_sszy.val*32+32;
			stgpat=sb_pcnt.val;
			init();
		}
		break;
	case MN_WAI:
		dg_wait.link=(CTRL*)&sb_wait;
		sb_wait.val=stgwait;
		if(dialog12(&dg_wait) == Q_OK) {
			stgwait=sb_wait.val;
		}
		break;
	}
}

/*** Do menu.mode ***/

static domode(itm)
int  itm;
{
	stgmode=itm;
	initdraw();
}

/*** Init Stage ***/

static initdraw()
{
	initstag();
	drawstag(curstg);
}

initstag()
{
	int  size;
	
	mb_stag.mnu=&mn_stag[0];
	mb_stag.ttl=filename;
	
	mn_stag[0].item=it_file;	
	mn_stag[1].item=it_form;	
	mn_stag[2].item=it_mode;
	mn_stag[0].func=&dofile;
	mn_stag[1].func=&doform;
	mn_stag[2].func=&domode;
	setimark(&it_mode[0],2,stgmode);
	size=sizeof(STGE)*stgcnt*stgpat;
	if(stgptr) {
		freemem(stgptr);
		stgptr=(STGE*)getmem(size);
	}
	else {
		stgptr=(STGE*)getmem(size);
		fillmem(stgptr,size,0);
	}
	curstg=0;
	selsprn=0;
}	

/*** Draw Stage ***/

drawstag(pag)
int  pag;
{
	int  i;
	int  x,y;
	int prtp;
	STGE *sp;
	
	prtp=pinit(PR_GRAF);
	mousoff();
	drawmenu(&mb_stag);
	pn.col=basecol;
	fillrect(ebox_x,ebox_y,stg_sx,stg_sy,base_s);
	shaderct(ebox_x,ebox_y,stg_sx,stg_sy,4);
	pn.col=7;
	fillrect(ebox_x,ebox_y+SGBX_DY,SGBX_SX,SGBX_SY,NIL);
	shaderct(ebox_x,ebox_y+SGBX_DY,SGBX_SX,SGBX_SY,NIL);
	gloc(ebox_x,ebox_y+SGBX_DY);
	pn.col=0;
	print("Scene%2d",pag);
	if(stgmode != MN_PLY) {
		if(basecol) pn.col=0; else pn.col=7;
		for(x=ebox_x+8; x<ebox_x+stg_sx; x+=8) {
			line(x,ebox_y,x,ebox_y+stg_sy);
		}
		for(y=ebox_y+8; y<ebox_y+stg_sy; y+=8) {
			line(ebox_x,y,ebox_x+stg_sx,y);
		}
	}
	sp=stgptr+pag*stgpat;
	for_to(i,stgpat) {
		if(sp->use) drawspr(sp);
		sp++;
	}
	pinit(prtp);
	mouson();
}

/*** Draw one sprite ***/

drawspr(sp)
STGE *sp;
{
	int  x,y;
	int  x0,y0;
	char *mp;

	mp=mapptr+sp->num*16;
	x0=ebox_x+sp->px;
	y0=ebox_y+sp->py;
	for(y=y0; y<y0+32; y+=8) {
		for(x=x0; x<x0+32; x+=8) {
			putzpix(x,y,patptr+(*mp++)*patsiz,plane,0);
		}
	}
	if(stgmode != MN_PLY) {
		pn.col=2;
		framerct(x0,y0,32,32);
	}
}

/*** Do Stage ***/

do_stag()
{
	int  x,y;
	int  i;
	STGE *sp;
	
	x=msrec.px-ebox_x;
	y=msrec.py-ebox_y;
	if(x >= 0 && x < SGBX_SX && y >= SGBX_DY && y < SGBX_DY+SGBX_SY) {
		switch(stgmode) {
		case MN_SET :
			if(msrec.evnt & MS_LDN) {
				if(++curstg >= stgcnt) curstg=0;
				drawstag(curstg);
			}
			else if(msrec.evnt & MS_RDN) {
				if(curstg-- <= 0) curstg=stgcnt-1;
				drawstag(curstg);
			}
			break;
		case MN_PLY:
			if(msrec.evnt & MS_LDN) {
				mousoff();
				if(curstg) {
					curstg=0;
					drawstag(curstg);
				}
				else {
					for_to(i,stgcnt) {
						curstg=i;
						drawstag(i);
						vwait(stgwait);
					}
				}
				mouson();
			}
			break;
		}
		return(TRUE);
	}
	if(x < 0 || x >= stg_sx || y < 0 || y >= stg_sy) return(FALSE);
	x&=~7;
	y&=~7;
	switch(stgmode) {
	case MN_SET:
		sp=stgptr+curstg*stgpat;
		if(msrec.evnt & MS_RDN) {
			if(selsprn && x+32 <= stg_sx && y+32 <= stg_sy) {
				for_to(i,stgpat) {
					if(!sp->use) break;
					sp++;
				}
				if(i < stgpat) {
					sp->use=1;
					sp->px=x;
					sp->py=y;
					sp->num=selsprn;
					mousoff();
					drawspr(sp);
					mouson();
				}
			}
		}
		if(msrec.evnt & MS_LDN) {
			sp+=stgpat;
			for_to(i,stgpat) {
				--sp;
				if(sp->use) {
					if(x == sp->px && y == sp->py) {
						sp->use=0;
						selsprn=sp->num;
						drawstag(curstg);
						break;
					}
				}
			}
		}
		break;
	}
	return(TRUE);
}

