/********************
	'PET' Tool Box
*********************/

#include "std.h"
#include "graf.h"
#include "pet.h"

#define TOOLS 8
#define TL_PEN 0
#define TL_LIN 1
#define TL_BOX 2
#define TL_CPY 3
#define TL_ROL 4
#define TL_MIR 5
#define TL_UND 6
#define TL_MEM 7

static char tmptbl[16];

/*** Init toolbox ***/

inittool()
{
	pensiz=0;	
	boxmod=0;
}

/*** Draw tool box ***/

drawtool()
{
	int  i;
	int  rev;
		
	for_to(i,TOOLS) {
		rev=0;
		switch(i) {
		case TL_PEN:
			rev=pensiz;
			break;
		case TL_LIN:
		case TL_BOX:
		case TL_CPY:
			if(i == boxmod) rev=1;
			break;
		}
		drawtol1(i,rev);
		shaderct(tol_x,tol_y+i*24,16,16,2);
	}
}

drawtol1(tol,rev)
int  tol;
int  rev;
{
	putspat(tol_x,tol_y+tol*24,&tool_s,tol,rev ? 7 : 0);
}

/*** Do tool box ***/

do_tool()
{
	word x,y;	
	word z;
	int  tol;
	int  c1;
	int  c2;
	
	x=msrec.px-tol_x;
	y=msrec.py-tol_y;
	if(!inrect(x,y,16,TOOLS*24)) return(FALSE);
	if((msrec.evnt & MS_LDN) && (y%24 < 16)) {
		tol=y/24;
		mousoff();
		switch(tol) {
		case TL_PEN:
			pensiz^=1;
			drawtol1(tol,pensiz);
			break;
		case TL_LIN:
		case TL_BOX:
		case TL_CPY:
			if(boxmod) {
				if(tol != boxmod) {
					drawtol1(boxmod,0);
					boxmod=tol;
				}
				else boxmod=0;
			}
			else boxmod=tol;
			drawtol1(tol,boxmod);
			break;
		case TL_UND:
			for_to(y,ssiz_y) {
				for_to(x,ssiz_x) {
					c1=getpix(x,y,&edt_rec);
					c2=getpix(x,y,&ura_rec);
					if(c1 != c2) {
						setpix(x,y,&ura_rec,c1);
						putepix(x,y,c2);
					}
				}
			}
			movemem(uratbl,tmptbl,16);
			movemem(pixtbl,uratbl,16);
			movemem(tmptbl,pixtbl,16);
			break;
		case TL_MEM:
			for_to(y,ssiz_y) {
				for_to(x,ssiz_x) {
					setpix(x,y,&ura_rec,getpix(x,y,&edt_rec));
				}
			}
			movemem(pixtbl,uratbl,16);
			break;
		case TL_ROL:
			y%=24;
			z=15-x;		
			if(y < z && y < x) {
				for_to(x,ssiz_x) {
					c1=getpix(x,0,&edt_rec);
					for(y=1; y<ssiz_y; y++) {
						putepix(x,y-1,getpix(x,y,&edt_rec));
					}
					putepix(x,ssiz_y-1,c1);
				}
			}
			else if(y > z && y > x) {
				for_to(x,ssiz_x) {
					c1=getpix(x,ssiz_y-1,&edt_rec);
					for(y=ssiz_y-1; y>0; --y) {
						putepix(x,y,getpix(x,y-1,&edt_rec));
					}
					putepix(x,0,c1);
				}
			}
			else if(y < z && y > x) {
				for_to(y,ssiz_y) {
					c1=getpix(0,y,&edt_rec);
					for(x=1; x<ssiz_x; x++) {
						putepix(x-1,y,getpix(x,y,&edt_rec));
					}
					putepix(ssiz_x-1,y,c1);
				}
			}
			else if(y > z && y < x) {
				for_to(y,ssiz_y) {
					c1=getpix(ssiz_x-1,y,&edt_rec);
					for(x=ssiz_x-1; x>0; --x) {
						putepix(x,y,getpix(x-1,y,&edt_rec));
					}
					putepix(0,y,c1);
				}
			}
			break;
		case TL_MIR:
			for_to(y,ssiz_y) {
				for_to(x,ssiz_x/2) {
					c1=getpix(x,y,&edt_rec);
					c2=getpix(ssiz_x-x-1,y,&edt_rec);
					if(c1 != c2) {
						putepix(x,y,c2);
						putepix(ssiz_x-x-1,y,c1);
					}
				}
			}
			fillmem(pixtbl,16,0);
			break;
		}
		mouson();
	}
	return(TRUE);
}

