;********************
;*   'ZF' Refresh   *
;********************

	include	cmac.asm

B_SEG	equ	0A800h
R_SEG	equ	0B000h
G_SEG	equ	0B800h

SCR_X	equ	64
SCR_y	equ	40
SCR_SZ	equ	SCR_X*SCR_Y

data	segment

smap	dw	?	; screen map
bgpat	dw	?	; BG patt data pointer
dspofs	dw	?	; display offset
mixbuf	dw	?	; mix buffer
bgmap	dw	?	; BG field map
fld_x	dw	?	; field x size
fld_y	dw	?	; field y size
vew_x	dw	?	; view offset x
vew_y	dw	?	; view offset y

data	ends

;--- calc BG patt point ---

calcbgp	macro
	shl	ax,1
	mov	si,ax	
	shl	ax,1
	add	si,ax
	add	si,bgpat
	endm

;--- disp BG ---

dispbg	macro
	rept	8
	movsb
	add	di,bx
	endm
	endm

;--- mix common routine ---

mixinit	macro
	lodsw	
	mov	bx,ax
	lodsw
	mov	dx,ax
	or	ax,bx
	not	ax
	and	[di],ax
	and	[di+8],ax
	and	[di+16],ax
	endm

mixend	macro
	mov	bp,[bp+2]
	tst	bp
	jnz	chmix1
	mov	si,mixbuf
	jmp	disppx
	endm

;--- Refresh screen ---

code	segment
	assume	cs:code,ds:data

refresh:
	cld
	mov	si,smap
	mov	di,dspofs
	mov	cx,SCR_Y
loop_y:	push	cx
	mov	cx,SCR_X
loop_x:	lodsw
	shl	ax,1
	jc	refmodf
	inc	di
refnext:loop	loop_x
	add	di,640-SCR_Y
	pop	cx
	loop	loop_y
	ret
refmodf:
	pushm	<cx,si,di>
	shl	ax,1
	jc	chexist
bgonly:
	calcbgp
disppx:	mov	bx,79
	ldseg	es,B_SEG
	dispbg
	ldseg	es,R_SEG
	dispbg
	ldseg	es,G_SEG
	dispbg
	popm	<di,si,cx>
	jmp	refnext

chexist:
	mov	bp,ax
	mov	ax,[bp]
	calcbgp
	mov	di,mixbuf
	mov	cx,12
rep	movsw
	mov	bp,[bp+2]
chmix1:
	mov	si,[bp]
	mov	bx,si
	and	si,0FFF0h
	mov	di,mixbuf
	mov	cx,4
	and	bx,000Eh
	jmp	[bx+offset paletbl]
	
palet0:
	mixinit
	mov	ax,bx
	and	ax,dx
	or	[di],ax
	mov	ax,dx
	or	[di+8],ax
	mov	ax,bx
	and	ax,dx
	or	[di+16],ax
	inc	di
	inc	di
	loop	palet0
	mixend	

paletbl	dw	palet0
	
;--- spread BG map ---

spredbg:


code	ends
	
	end
