/*****************************
	'SF' Test Program No.1
*****************************/

#include "std.h" 
#include "sf.h"

#define static 
#define CHCNT1	16
#define CHRCNT	(CHCNT1*2+1)
#define RACES	5
#define FVPX0	0
#define FVPY0	54
#define HERO_X	8
#define HERO_Y	9
#define FRND_X	0
#define FRND_Y	8
#define ENMY_X	0
#define ENMY_Y	1

char *scrnmap;	/* screen map ptr */
char *bgpatt;	/* BG patt ptr */
char *bgsmap;	/* BG sprite map ptr */
char *bgobst;	/* BG obstract table ptr */
char *bgatrb;	/* BG attribute table ptr */
char *bgmask;	/* BG mask patt ptr */
char *fldmap;	/* fmap ptr */
int  fsx;		/* fmap size x,y (by pixcel) */
int  fsy;
int  vsx;		/* view port size x,y (by pixcel) */
int  vsy;
int  fvpx;		/* field View port x,y (by pixcel) */
int  fvpy;

CHRT *chrtbl;	/* CH table ptr */
char *chrrace;	/* CH race table ptr */
int  chrcnt;	/* CH count */
int  chtblsz;	/* CH table size */
char *chrmix;	/* CH mixing list ptr */
char *chlktop;	/* display CH link top */
int  dispofs;	/* display vram offset */
char *mixwork;	/* patt mix work (24byte) */
char *envatr;	/* environment atr package */

static PATHD *bgpathd;
static PATHD *chpathd[RACES];
static FMPHD *fmaphd;
static char bgname[]="BG.PAT";
static char fmname[]="FLD.FMP";
static char chnam0[]="CH0.PAT";
static char chnam1[]="CH1.PAT";
static RACE racetbl[RACES];
static int  scrnmapi[VWSZ_X*VWSZ_Y];
static char mixworki[24];
static char chrtbli[CHRCNT*CHTBLSZ];
CHRT	*hp;
static CHRT	*enmyp;
static CHRT *frndp;
static int  dir;
static char envatri[16];
int  key;
int  keyst;
flag keyon;
static int  spract[]={ 0,1,0,2 };
static int	sprdir[]={ 0,0x80,0x40,0xC0 };
static int  keyhis[4];
static int  keydep;
static int  runwak;
extern int  p_txt;

/*** peek ***/

peek(x)
int  x;
{
	ploc(0,0);
	print("%d   ",x);
}

/*** program entry ***/

main()
{
	int  prtp;
	
	pfkey(OFF);
	prtp=pinit(&p_txt);
	pchr(CLS);
	gmode(0);
	gcls();
	gon();
	crtvon();

	loaddata();
	initvar();
	initch();
	sfiniscr();
	fvpx=FVPX0*4;
	fvpy=FVPY0*4;
	sfsprdbg();
	loop {
		vwait(0);
		sfchain();
		sfsprdch();
		sffresh();
		do_hero();
		if(!(keyst & KY_B)) {
		/*	print("\n");
			prpt(' ',65);*/
			do_char();
		}
		if(keyst & KY_ESC) break;
		while(vwait(-1) < WAIT) {}
	}
	crtvoff();
	gcls();
	pinit(prtp);
	pfkey(ON);
	exit();
}

/*** Reqest CH table ***/

static CHRT *reqchtbl()
{
	CHRT *cp;

	cp=chrtbl;
	while(cp->use) cp++;
	fillmem(cp,CHTBLSZ,0);
	cp->use=TRUE;
	return(cp);
}

/*** Init CH ***/

static initch()
{
	int  i;
	int  type;
	int  x;
	int  y;
	int  ob;
	CHRT *cp;

	hp=reqchtbl();
	hp->fx=(FVPX0+HERO_X)*4;
	hp->fy=(FVPY0+HERO_Y)*4;
	hp->race=4;
	hp->army=0;
	hp->dir=DR_U;
	hp->act=AC_STY;
	hp->mode=MD_MOVE;
	hp->strn=4;
	hp->life=20;
	runwak=AC_WLK;
	sfsetob(hp->fx,hp->fy);
	setspr(hp,SP_WAK);

	frndp=NIL;
	for_to(i,CHCNT1) {
		type=i & 1;
		cp=reqchtbl();
		if(!frndp) frndp=cp;
		cp->fx=(FVPX0+FRND_X+i)*4;
		cp->fy=(FVPY0+FRND_Y+type)*4;
		cp->race=type;
		cp->army=0;
		cp->dir=DR_U;
		cp->act=AC_STY;
		cp->mode=MD_MOVE;
		cp->strn=type+1;
		cp->life=10;
		sfsetob(cp->fx,cp->fy);
		setspr(cp,SP_WAK);
	}
	enmyp=NIL;
	for_to(i,CHCNT1) {
		type=i & 1;
		cp=reqchtbl();
		if(!enmyp) enmyp=cp;
		repeat {
			x=rand()%64;
			y=rand()%192;
			ob=sfgetbg(x,y);
		} until(!(ob&0x0660));
		cp->fx=x;
		cp->fy=y;
		cp->race=type+2;
		cp->army=1;
		cp->dir=DR_D;
		cp->act=AC_STY;
		cp->mode=MD_MOVE;
		cp->strn=type+1;
		cp->life=10;
		sfsetob(cp->fx,cp->fy);
		setspr(cp,SP_WAK);
	}
}

/*** Do Hero ***/

static do_hero()
{
	int  i;
	int  key1;
	int  key2;
	int  act;
	int  dir;

	dir=hp->dir;
	act=hp->act;
	while(scan()) {
		if(key < 4) {
			if(keyon) {
				keyhis[keydep++]=key;
			} else {
				for_to(i,keydep) {
					if(keyhis[i] == key) {
						for(i=i+1; i<keydep; i++) {
							keyhis[i-1]=keyhis[i];
						}
						keydep--;
						break;
					}
				}
			}
			switch(keydep) {
			case 0:
				act=AC_STY;
				break;
			case 1:
				dir=keyhis[0];
				act=runwak;
				break;
			default:
				key1=keyhis[keydep-1];
				for(i=keydep-2; i>=0; i--) {
					key2=keyhis[i];
					if((key1^key2)&1) {
						if(((key1-key2)&3) == 1) {
							dir=key2+4;
						} else {
							dir=key2+8;
						}
						goto skip;
					}
				}
				dir=key1;
				act=runwak;
				break;
			}
skip:
		}
		else {
			switch(key) {
			case KY_A:
				runwak=keyon ? AC_RUN : AC_WLK;
				if(hp->act != AC_STY) act=runwak;
				break;
			}
		}
	}
	if(hp->act < AC_ENG) {
		if(hp->tget) {
			hp->act=(act==AC_STY) ? AC_CNF : AC_ATK;
		}
		else {
			hp->act=act;
		}
	}
	prpt(' ',65);
	print("%d\n",hp->act);
	hp->dir=dir;
	action(hp);
}
			
/*** do char ***/

static do_char()
{
	int  i,j;
	int  myid;
	CHRT *cp;
	CHRT *tp;

	cp=frndp;
	for_to(i,CHCNT1*2) {
/*		print("%d-%d ",cp->act,cp->tick);*/
		if(cp->mode == MD_MOVE) {
			if(!(cp->timeup)) {
				if(cp->act != AC_STY) {
					myid=cp->army;
					tp=hp;
					for_to(j,CHRCNT-1) {
						if(tp->army != myid) {
							if(tp->mode == MD_MOVE) {
								if(inzoc(cp,tp)) {
									cp->tget=tp;
									cp->mode=MD_FIGT;
									cp->act=AC_CNF;
									cp->tick=0;
									tp->tget=cp;
									tp->mode=MD_FIGT;
									tp->act=AC_CNF;
									tp->tick=0;
									setdir(cp);
									setdir(tp);
									goto nextch;
								}
							}
						}
						tp++;
					}
				}
				wander(cp);
			}
			if(!action(cp)) cp->timeup=0; else cp->timeup--;
		}
		else if(cp->mode == MD_FIGT) {
			action(cp);
		}
nextch:
		cp++;
	}
}

/*** Wandering ***/

static wander(cp)
CHRT *cp;
{
	int  rnd;
	
	rnd=rand();
	cp->act=(rnd&1) ? AC_RUN : AC_WLK;
	rnd>>=1;
	cp->dir=rnd%12;
	if(!cp->army) {
		if((cp->dir&3) == 1) {
			cp->dir|=2;
		}
	}
	rnd>>=4;
	cp->timeup=(rnd&15)+4;
}

/*** do action ***/

static flag action(cp)
CHRT *cp;
{
	int  spr;
	flag f;
	int  tact;
	int  dir1;
	int  dir2;
	CHRT *tp;

	f=TRUE;
	tact=(cp->tget)->act;
	switch(cp->act) {
	case AC_STY:
		spr=SP_WAK;
		break;
	case AC_WLK:
		cp->speed=SLOW;
		if(!(cp->tick&1)) {
			f=movech(cp);
		}
		spr=SP_WAK+spract[cp->tick>>1&3];
		break;
	case AC_RUN:
		cp->speed=FAST;
		f=movech(cp);
		spr=SP_RUN+spract[cp->tick&3];
		break;
	case AC_CNF:
		if(tact == AC_DED) {
			if(cp->tick >= 8) {
				cp->tget=NIL;
				cp->mode=MD_MOVE;
				cp->act=AC_STY;
				cp->tick=0;
			}
		}
		else {
			if(setdir(cp)) {
				if(tact == AC_ENG) {
					cp->act=AC_ENG;
					cp->tick=0;
				}
			}
			if(cp != hp) {
				if((tact == AC_CNF && cp->tick >=4)
				|| tact == AC_ATK) {
					cp->act=AC_ATK;
					cp->tick=0;
				}
			}
			spr=SP_CNF;
		}
		break;
	case AC_ATK:
		cp->speed=FAST;
		dir1=cp->dir;
		if(setdir(cp)) {
			cp->act=AC_ENG;
			cp->tick=0;
		} else {
			if(cp == hp) {
				dir2=cp->dir;
				cp->dir=dir1;
				f=movech(cp);
				cp->dir=dir2;
				if(!inzoc(cp,cp->tget)) f=FALSE;
			}
			else f=movech(cp);
			if(f) {
				spr=SP_ATK+(cp->tick&1);
			}
			else {
				tp=cp->tget;
				cp->tget=tp->tget=NIL;
				cp->mode=tp->mode=MD_MOVE;
				cp->act=tp->act=AC_STY;
				cp->tick=tp->tick=0;
			}
		}
		break;
	case AC_ENG:
		spr=SP_CNF+1;
		if(cp->tick >= 4) {
			switch(combat(cp)) {
			case CR_WIN:
				cp->act=AC_CNF;
				break;
			case CR_LOS:
				cp->act=AC_DMG;
				cp->dir=(cp->dir&3)+12;
				break;
			case CR_ENG:
				spr=SP_ATK;
				break;
			}
			cp->tick=0;
		}
		break;
	case AC_DMG:
		cp->speed=SLOW;
		if(!(cp->tick&1)) {
			f=movech(cp);
			if(!f || cp->tick >= 8) {
				cp->act=cp->life ? AC_CNF : AC_DED;
				cp->tick=0;
			}
		}
		spr=SP_DMG+(cp->tick>>1&1);
		break;
	case AC_DED:
		if(!cp->tick) cp->speed=rand()&1 ? SLOW : FAST;
		spr=SP_DED+cp->speed*2;
		if(cp->tick == 8) {
			cp->mode=MD_DEAD;
			sfresob(cp->fx,cp->fy);
			spr=SP_DED+cp->speed*2+1;
		}
		break;	
	}
	cp->tick++;
	setspr(cp,spr);
	return(f);
}

/*** Set CH Sprite ***/

static setspr(cp,spr)
CHRT *cp;
int  spr;
{
	cp->spr=spr+sprdir[cp->dir&3];
}

/*** in ZOC or not ***/

static flag inzoc(cp,tp)
CHRT *cp,*tp;
{
	int  dx,dy;

	dx=tp->fx-cp->fx;
	if(dx<0) dx=-dx;
	dy=tp->fy-cp->fy;
	if(dy<0) dy=-dy;
	if((dx <= ZOCDIS) && (dy <= ZOCDIS)) return(TRUE);
	else return(FALSE);
}

/*** Load data ***/

static loaddata()
{
	char *chrp0;
	char *chrp1;
	char *mapp0;
	char *mapp1;

	bgpathd=(PATHD*)load(bgname);
	fmaphd=(FMPHD*)load(fmname);
	
	bgpatt=(char*)bgpathd+HEADSZ;
	bgsmap=bgpatt+8*3*256;
	bgobst=bgsmap+16*(bgpathd->count);
	bgatrb=bgobst+2*256;
	bgmask=bgatrb+256;

	fldmap=(char*)fmaphd+HEADSZ;
	fsx=fmaphd->fsx*4;
	fsy=fmaphd->fsy*4;

	chpathd[0]=(PATHD*)load(chnam0);
	chpathd[1]=(PATHD*)load(chnam1);
	chrp0=(char*)chpathd[0]+HEADSZ;
	chrp1=(char*)chpathd[1]+HEADSZ;
	mapp0=chrp0+8*2*256*2;
	mapp1=chrp1+8*2*256*2;
	racetbl[0].patt=chrp1;
	racetbl[0].smap=mapp1;
	racetbl[0].pal=0;
	racetbl[0].sprb=0;
	racetbl[1].patt=chrp1;
	racetbl[1].smap=mapp1;
	racetbl[1].pal=0;
	racetbl[1].sprb=0x20;
	racetbl[2].patt=chrp0;
	racetbl[2].smap=mapp0;
	racetbl[2].pal=0;
	racetbl[2].sprb=0;
	racetbl[3].patt=chrp0;
	racetbl[3].smap=mapp0;
	racetbl[3].pal=0;
	racetbl[3].sprb=0x20;
	racetbl[4].patt=chrp1;
	racetbl[4].smap=mapp1;
	racetbl[4].pal=1;
	racetbl[4].sprb=0x20;
}

/*** Init variables ***/

static initvar()
{
	scrnmap=(char*)scrnmapi;
	vsx=VWSZ_X;	
	vsy=VWSZ_Y;
	chrtbl=(CHRT*)chrtbli;
	chrrace=(char*)&racetbl[0];
	chrcnt=CHRCNT;
	chtblsz=CHTBLSZ;
	dispofs=16*80;
	mixwork=mixworki;
	envatr=envatri;
	chrmix=(char*)setpara(getmem(chrcnt*16*4));
}

/*** load file ***/

static load(name)
char *name;
{
	int  p;
	
	p=loadfile(name);
	if(!p) {
		print("Can't find \"%s\"\n",name);
		exit();
	}
	return(p);
}

