/**********************
	'ZF' Definitons
**********************/

#define HEADSZ	16
#define VWSZ_X	64
#define VWSZ_Y	40
#define SCRC_X	8
#define SCRC_Y	5
#define ZOCDIS	8
#define CHTBLSZ	32
#define KY_R	0x01
#define KY_L	0x02
#define KY_D	0x04
#define KY_U	0x08
#define KY_A	0x10
#define KY_B	0x20
#define KY_ESC	0x80
#define WAIT	6
#define DR_R	0
#define DR_D	1
#define DR_L	2
#define DR_U	3
#define DR_RD	4
#define DR_LD	5
#define DR_LU	6
#define DR_RU	7
#define DR_LF	0x01
#define DR_UP	0x02
#define DR_VT	0x04
#define AC_STY	0
#define AC_WLK	1
#define AC_RUN	2
#define AC_CNF	3
#define AC_ATK	4
#define AC_ENG	5
#define AC_DMG	6
#define AC_DED	7
#define MD_MOVE	0
#define MD_RUSH	1
#define MD_FIGT	2
#define MD_ESCP	3
#define MD_DEAD 4
#define SP_WAK	0x08
#define SP_RUN	0x0B
#define SP_CNF	0x10
#define SP_ATK	0x12
#define SP_DMG	0x14
#define SP_DED	0x18
#define CR_WIN	1
#define CR_LOS	2
#define CR_ENG	3
#define SLOW	1
#define FAST	0

/*** PAT data header ***/

typedef struct pathead {
	char id[4];
	int  size;
	int  count;
	int  dot_x;
	int  dot_y;
	char plane;
	char zom_x;
	char zom_y;
	char wdth;
} PATHD;

/*** FMAP data header ***/

typedef struct fmaphead {
	char id[4];
	int  size;
	int  fsx;
	int  fsy;
	int  areac;
	int  fptrc;
} FMPHD;

/*** FMAP record ***/

typedef struct fmaprec {
	char spr;
	char area;
	int  obst;
} FMAP;

/*** char table ***/

typedef struct chrrec {
	int  fx;		/* field pos x,y (by pixcel)*/
	int  fy;
	char spr;		/* CH sprite No. */
	char race;		/* CH race No. */
	struct chrrec *link; /* display Link */
	char bgatr;		/* BG atr */
	char dir;		/* Direction */
	char tick;		/* Tick counter */
	char speed;		/* Action speed */
	char use;		/* Use flag */
	char act;		/* Action mode */
	char timeup;	/* Movement timeup */
	char army;		/* Army ID */
	struct chrrec *tget; /* terget CH */
	char strn;		/* Strength */
	char life;		/* Life */
	char kill;		/* killing count */
	char mode;		/* CH mode */
	char crs;		/* combat result status */
	char dummy[9];
} CHRT;

/*** race table ***/

typedef struct racerec {
	char *patt;		/* CH patt ptr */
	char *smap;		/* CH sprite map ptr */
	char pal;		/* CH palet No. */
	char sprb;		/* CH sprite No. base */
	int	 nul;
} RACE;

