;*****************************
;*   'ZPUT' ZF Graphic module
;*	for Lattice-c
;*****************************
			
;*************************
;*   Symbol Definitions
;*************************

;--- Constants ---

B_SEG	equ	0A800h
R_SEG	equ	0B000h
G_SEG	equ	0B800h

	include	cmac.asm

;*****************
;*   data area   *
;*****************

	dugroup

	dseg
	extrn	bw	:byte
	endds

	useg
mixbuf	db	24 dup(?)	
	endus

;**************
;*   macros   *
;**************

;--- disp BG ---

dispbg	macro
	rept	8
	movsb
	add	di,bx
	endm
	endm

;--- load BG ---

loadbg	macro
	rept	8
	movsb
	add	si,bx
	endm
	endm

;--- disp zero ---

dispzr	macro
	clr	al
	rept	8
	stosb
	add	di,bx
	endm
	endm

;--- mix common routine ---

mixinit	macro
	mov	dx,[si+8]
	lodsw
	mov	bx,ax
	or	ax,dx
	not	ax
	and	[di],ax
	and	[di+8],ax
	and	[di+16],ax
	endm

mixend	macro
	mov	si,offset DGROUP:mixbuf
	pop	di
	jmp	putbg
	endm

;******************
;*   code start   *
;******************
	
	pseg
	public	putzpix,putzspr

;--- putzspr(x,y,patp,pl,pal,pixtp) ---
; int	x,y	: screen x,y
; char  *patp	: pattern entry
; int	pl	: plane( 2 or 3 )
; int	pal	: palette No.
; char  *pixp	: 16 byte pix table ptr

putzspr	proc
	begin
	push	es
	call	setdi
	clr	si
pspr1:
	push	si
	mov	al,byte ptr [bp].arg4
	shl	al,1
	shl	al,1
	shl	al,1
	mov	bx,[bp].arg6
	mul	byte ptr byte ptr [bx+si]
	add	ax,[bp].arg3
	mov	si,ax
	call	putpx
	pop	si
	inc	si
	inc	di
	test	si,3
	jnz	pspr3
	add	di,640-4
pspr3:	cmp	si,16
	jne	pspr1
	pop	es
	endf
putzspr	endp

;--- putzpix(x,y,pat,pl,pal) ---
; int	x,y	: screen x,y
; char  *pat	: pattern pointer
; int	pl	: plane( 2 or 3 )
; int	pal	: palette No.

putzpix	proc
	begin
	push	es
	call	setdi
	mov	si,[bp].arg3	; pat	
	call	putpx
	pop	es
	endf

setdi:
	mov	ax,[bp].arg2	; y
	shl	ax,1
	shl	ax,1
	shl	ax,1
	shl	ax,1
	mov	di,ax
	shl	ax,1
	shl	ax,1
	add	di,ax		; y*80
	mov	ax,[bp].arg1	; x
	shr	ax,1
	shr	ax,1
	shr	ax,1
	add	di,ax
	ret

putpx:
	mov	al,byte ptr [bp].arg4	; pl
	cmp	al,2
	je	putch
	cmp	al,3
	je	putbg
	jmp	putpl
putbg:
	mov	bx,79
	mov	dx,di
	ldseg	es,B_SEG
	dispbg
	cmp	bw,0
	jnz	putpx9
	mov	di,dx
	ldseg	es,R_SEG
	dispbg
	mov	di,dx
	ldseg	es,G_SEG
	dispbg
putpx9:	mov	di,dx
	ret

putch:
	push	di
	push	si
	push	ds
	ldseg	es,ds
	mov	si,di
	mov	di,offset DGROUP:mixbuf
	mov	bx,79
	mov	dx,si
	ldseg	ds,B_SEG
	loadbg
	mov	si,dx
	ldseg	ds,R_SEG
	loadbg
	mov	si,dx
	ldseg	ds,G_SEG
	loadbg
	pop	ds
	pop	si
	mov	di,offset DGROUP:mixbuf
	mov	cx,4
	mov	bx,[bp].arg5
	shl	bx,1
	jmp	[bx+offset cs:paletbl]

palet0:
	mixinit
	or	[di+8],dx
	and	bx,dx
	or	[di],bx
	or	[di+16],bx
	inc	di
	inc	di
	loop	palet0
	mixend	

paletbl	dw	palet0
	
putpl:
	mov	bx,79
	ldseg	es,B_SEG
	mov	dx,di
	mov	cl,1
	call	putpl1
	cmp	bw,0
	jnz	putpl9
	ldseg	es,R_SEG
	mov	di,dx
	mov	cl,2
	call	putpl1
	ldseg	es,G_SEG
	mov	di,dx
	mov	cl,4
	call	putpl1
putpl9:	mov	di,dx
	ret

putpl1:
	test	cl,byte ptr [bp].arg5
	jz	putpl0	
	dispbg
	sub	si,8
	ret
putpl0:	dispzr
	ret

putzpix	endp
	endps
	end

